/*
	DZMSAIConfig.sqf
	This is a configuration for the AI that spawn at missions.
	This includes their skin, weapons, gear, and skills.
	You can adjust these to your liking, but it is for advanced users.
*/

///////////////////////////////////////////////
// Array of skin classnames for the AI to use
///////////////////////////////////////////////

DZMSBanditSkins = [
    "Bandit1_DZ",
    "Bandit1_DZ",
    "Bandit2_DZ",
    "Bandit2_DZ",
    "BanditW1_DZ",
    "BanditW2_DZ",
    "Rocker1_DZ",
    "Rocker2_DZ",
    "Rocker3_DZ",
    "Rocker4_DZ",
    "TK_INS_Warlord_EP1_DZ",
    "TK_INS_Soldier_EP1_DZ",
    "TK_INS_Soldier_EP1_DZ",
    "TK_INS_Soldier_EP1_DZ"
];


//////////////////////////////////////////////////////
// Array of skin classnames for the AI hostages to use
//////////////////////////////////////////////////////

DZMSHostageSkins = [
	"SurvivorW2_DZ",
	"SurvivorWpink_DZ",
	"SurvivorWurban_DZ",
	"SurvivorWcombat_DZ",
	"SurvivorWdesert_DZ",
	"SurvivorW3_DZ",
	"RU_WorkWoman1",
	"RU_WorkWoman2",
	"RU_WorkWoman3",
	"RU_WorkWoman4",
	"RU_WorkWoman5",
	"Dr_Annie_Baker_EP1",
	"Rita_Ensler_EP1",
	"HouseWife1"
];


////////////////////////
// Array of AI Skills
////////////////////////

DZMSSkills0 = [
	["aimingAccuracy",0.10,0.125],
	["aimingShake",0.45,0.55],
	["aimingSpeed",0.45,0.55],
	["endurance",0.40,0.50],
	["spotDistance",0.30,0.45],
	["spotTime",0.30,0.45],
	["courage",0.40,0.60],
	["reloadSpeed",0.50,0.60],
	["commanding",0.40,0.50],
	["general",0.40,0.60]
];

DZMSSkills1 = [
	["aimingAccuracy",0.125,0.15],
	["aimingShake",0.60,0.70],
	["aimingSpeed",0.60,0.70],
	["endurance",0.55,0.65],
	["spotDistance",0.45,0.60],
	["spotTime",0.45,0.60],
	["courage",0.55,0.75],
	["reloadSpeed",0.60,0.70],
	["commanding",0.55,0.65],
	["general",0.55,0.75]
];

DZMSSkills2 = [
	["aimingAccuracy",0.15,0.20],
	["aimingShake",0.75,0.85],
	["aimingSpeed",0.70,0.80],
	["endurance",0.70,0.80],
	["spotDistance",0.60,0.75],
	["spotTime",0.60,0.75],
	["courage",0.70,0.90],
	["reloadSpeed",0.70,0.80],
	["commanding",0.70,0.90],
	["general",0.70,0.90]
];

DZMSSkills3 = [	
	["aimingAccuracy",0.20,0.25],
	["aimingShake",0.85,0.95],
	["aimingSpeed",0.80,0.90],
	["endurance",0.80,0.90],
	["spotDistance",0.70,0.85],
	["spotTime",0.70,0.85],
	["courage",0.80,1.00],
	["reloadSpeed",0.80,0.90],
	["commanding",0.80,0.90],
	["general",0.80,1.00]
];

DZMSSkills4 = [	
	["aimingAccuracy",0.25,0.30],
	["aimingShake",0.90,0.97],
	["aimingSpeed",0.83,0.93],
	["endurance",0.83,0.93],
	["spotDistance",0.75,0.88],
	["spotTime",0.75,0.88],
	["courage",0.85,1.00],
	["reloadSpeed",0.85,0.93],
	["commanding",0.85,0.95],
	["general",0.90,1.00]
];

//////////////////////////////////////////////////////////////
// This is the primary weaponlist that can be assigned to AI
// These are assigned based on AI difficulty level
//////////////////////////////////////////////////////////////

DZMSWeps0 = [
	"Saiga12K",
    	"M16A2_DZ",
    	"M16A4_DZ",
    	"M16A2GL",
    	"AK74_DZ",
    	"M4A1_Aim",
    	"AK74_Kobra_DZ",
    	"AKS74U_DZ",
    	"AKM_DZ",
    	"M24_DZ",
    	"M24_des_EP1",
    	"M1014_DZ",
    	"DMR_DZ",
    	"M4A1_DZ",
    	"M14_DZ",
    	"Remington870_DZ",
    	"MP5_DZ",
    	"MP5SD",
    	"m8_carbine",
    	"m8_compact",
    	"M4A3_CCO_EP1"
	];

DZMSWeps1 = [
    	"M16A2_DZ",
   	"M16A2GL",
    	"M249_DZ",
    	"AK74_DZ",
    	"M4A1_Aim",
    	"AK74_Kobra_DZ",
    	"AKS74U_DZ",
    	"AKM_DZ",
    	"M24_DZ",
    	"SVD_DZ",
    	"M1014_DZ",
    	"DMR_DZ",
    	"M4A1_DZ",
    	"M14_DZ",
    	"Remington870_DZ",
    	"M240_DZ",
    	"M4A1_AIM_SD_camo",
    	"G36_C_SD_camo",
    	"M16A4_ACG",
    	"M4A1_HWS_GL_camo",
    	"Mk48_DZ",
    	"M4A3_CCO_EP1",
    	"Sa58V_RCO_EP1",
    	"Sa58V_CCO_EP1",
    	"M40A3_DZ",
    	"m8_SAW",
    	"Sa58P_EP1",
    	"Sa58V_EP1"
	];

DZMSWeps2 = [
    	"FNFAL_DZ",
    	"FN_FAL_ANPVS4_DZE",
    	"Mk48_DZ",
    	"M249_DZ",
    	"M249_EP1_DZ",
    	"M249_m145_EP1_DZE",
    	"M60A4_EP1_DZE",
    	"MG36",
    	"MG36_camo",
    	"BAF_L85A2_RIS_Holo",
    	"G36C_DZ",
    	"G36C_camo",
    	"G36A_Camo_DZ",
    	"G36K_Camo_DZ",
    	"FNFAL_DZ",
    	"AKM_DZ",
    	"AKS74U_DZ",
    	"M14_DZ",
    	"Bizon_SD_DZ",
    	"DMR_DZ",
    	"m8_holo_sd",
    	"M4A1_HWS_GL_SD_Camo",
    	"m8_sharpshooter",
    	"RPK74_DZ"
	];

DZMSWeps3 = [
    	"FNFAL_DZ",
    	"FN_FAL_ANPVS4_DZE",
   	"Mk48_DZ",
    	"M249_DZ",
    	"BAF_L85A2_RIS_Holo",
    	"G36C_DZ",
    	"G36C_camo",
    	"G36A_Camo_DZ",
    	"G36K_Camo_DZ",
    	"FNFAL_DZ",
    	"AKM_DZ",
    	"AKS74U_DZ",
    	"M14_DZ",
    	"MP5SD",
    	"Bizon_SD_DZ",
    	"DMR_DZ",
    	"SCAR_H_LNG_Sniper_SD",
    	"BAF_L85A2_RIS_SUSAT",
    	"UK59_DZ",
    	"RPK74_DZ"
	];

/////////////////////////////////////////////////////////////
// These are gear sets that will be randomly given to the AI
// They are all the same, but can be customized.
/////////////////////////////////////////////////////////////

DZMSGear0 = [[
    "ItemBandage",
    "ItemBandage",
    "ItemBandage",
    "ItemPainkiller",
    "ItemMorphine",
    "ItemBloodbag",
    "FoodBioMeat",
    "ItemAntibiotic6",
    "ItemSodaLemonade",
    "ItemSodaRbull",
    "ItemWaterbottleBoiled",
    "FoodrabbitCooked",
    "FoodbeefCooked"
],[
    "ItemKnife",
    "ItemCompass",
    "Binocular_Vector",
    "NVGoggles",
    "ItemEtool",
    "ItemGPS",
    "ItemMap",
    "ItemWatch",
    "ItemRadio",
    "ItemKeyKit"
]];

DZMSGear1 = [[
    "ItemBandage",
    "ItemAntibacterialWipe",
    "ItemEpinephrine",
    "ItemSodaR4z0r",
    "ItemSodaRbull",
    "FoodchickenCooked",
    "FoodbaconCooked"
],[
    "ItemKnife",
    "ItemFlashlight",
    "ItemCompass",
    "Binocular",
    "ItemMap",
    "ItemMatchbox",
    "ItemWatch",
    "ItemFishingPole",
    "ItemRadio"
]];

DZMSGear2 = [[
    "ItemBandage",
    "ItemBandage",
    "ItemPainkiller",
    "ItemMorphine",
    "ItemBloodbag",
    "ItemAntibiotic",
    "ItemHeatPack",
    "ItemEpinephrine",
    "ItemWaterbottleBoiled"
],[
    "ItemFlashlight",
    "ItemCompass",
    "Binocular",
    "ItemMap",
    "ItemMatchbox",
    "ItemWatch"
]];

DZMSGear3 = [[
    "ItemBandage",
    "ItemAntibacterialWipe",
    "ItemSodaMdew",
    "ItemSodaMdew",
    "FoodrabbitCooked"
],[
    "ItemFlashlight",
    "Binocular_Vector",
    "ItemEtool",
    "ItemGPS",
    "ItemMap",
    "ItemToolbox",
    "ItemWatch",
    "ItemRadio",
    "ItemKeyKit"
]];

DZMSGear4 = [[
    "ItemBandage",
    "ItemBandage",
    "ItemBandage",
    "ItemPainkiller",
    "ItemMorphine",
    "ItemBloodbag",
    "ItemAntibiotic",
    "ItemHeatPack",
    "ItemEpinephrine"
],[
    "ItemKnife",
    "ItemFlashlight",
    "ItemWatch"
]];

DZMSGear5 = [[
    "ItemBandage",
    "ItemBloodbag",
    "ItemAntibacterialWipe",
    "FoodBioMeat",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodbaconCooked"
],[
    "ItemKnife",
    "ItemCompass",
    "Binocular",
    "ItemToolbox",
    "ItemWatch",
    "ItemCrowbar"
]];

DZMSGear6 = [[
    "ItemPainkiller",
    "ItemMorphine",
    "ItemWaterbottle",
    "FoodmuttonCooked"
],[
    "ItemCompass",
    "Binocular_Vector"
]];

DZMSGear7 = [[
    "ItemBandage",
    "ItemMorphine",
    "ItemHeatPack",
    "ItemEpinephrine",
    "ItemWaterbottle",
    "FoodchickenCooked"
],[
    "ItemKnife",
    "ItemFlashlightRed",
    "Binocular",
    "ItemMap",
    "ItemMatchbox",
    "ItemWatch",
    "ItemMachete"
]];

DZMSGear8 = [[
    "ItemBandage",
    "ItemBandage",
    "ItemPainkiller",
    "ItemHeatPack",
    "ItemEpinephrine",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodbeefCooked"
],[
    "ItemKnife",
    "ItemFlashlight",
    "ItemFlashlightRed",
    "ItemCompass",
    "Binocular",
    "ItemMatchbox",
    "ItemWatch",
    "ItemCrowbar"
]];

DZMSGear9 = [[
    "ItemBandage",
    "ItemPainkiller",
    "ItemMorphine",
    "ItemEpinephrine",
    "ItemAntibacterialWipe",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodmuttonCooked"
],[
    "ItemKnife",
    "ItemMatchbox",
    "ItemMachete"
]];

DZMSGearA = [[
    "ItemBandage",
    "ItemBloodbag",
    "FoodBioMeat",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodbaconCooked"
],[
    "ItemKnife",
    "ItemCompass",
    "Binocular",
    "ItemToolbox",
    "ItemWatch",
    "ItemCrowbar"
]];

DZMSGearB = [[
    "ItemPainkiller",
    "ItemMorphine",
    "ItemWaterbottle",
    "FoodmuttonCooked"
],[
    "ItemCompass",
    "Binocular_Vector"
]];

DZMSGearC = [[
    "ItemBandage",
    "ItemMorphine",
    "ItemHeatPack",
    "ItemEpinephrine",
    "ItemWaterbottle",
    "FoodchickenCooked"
],[
    "ItemKnife",
    "ItemFlashlightRed",
    "Binocular",
    "ItemMap",
    "ItemMatchbox",
    "ItemWatch",
    "ItemMachete"
]];

DZMSGearD = [[
    "ItemBandage",
    "ItemBandage",
    "ItemPainkiller",
    "ItemHeatPack",
    "ItemEpinephrine",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodbeefCooked"
],[
    "ItemKnife",
    "ItemFlashlight",
    "ItemFlashlightRed",
    "ItemCompass",
    "Binocular",
    "ItemMatchbox",
    "ItemWatch",
    "ItemCrowbar"
]];

DZMSGearE = [[
    "ItemBandage",
    "ItemPainkiller",
    "ItemMorphine",
    "ItemEpinephrine",
    "ItemSodaCoke",
    "ItemWaterbottle",
    "FoodmuttonCooked"
],[
    "ItemKnife",
    "ItemMatchbox",
    "ItemMachete"
]];

DZMSGearArrays = [
    DZMSGear0,
    DZMSGear1,
    DZMSGear2,
    DZMSGear3,
    DZMSGear4,
    DZMSGear5,
    DZMSGear6,
    DZMSGear7,
    DZMSGear8,
    DZMSGear9,
    DZMSGearA,
    DZMSGearB,
    DZMSGearC,
    DZMSGearD,
    DZMSGearE
];


