/*
	DayZ Mission System Config by Vampire
	DZMS: https://github.com/SMVampire/DZMS-DayZMissionSystem
*/

///////////////////////////////////////////////////////////////////////
// Do you want your players to gain humanity from killing mission AI?
DZMSMissHumanity = true;

// How Much Humanity?
DZMSCntHumanity = 25;

// how much humanity is lost for killing hostages?
DZMSHostageHumanityPenalty = 500;

// Do You Want AI to use NVGs?
//(They are deleted on death)
DZMSUseNVG = true;

// Do you want AI to use RPG7V's?
//(Only one unit per group spawn will have one)
DZMSUseRPG = false;

// Do you want AI kills to count as bandit kills?
DZMSCntBanditKls = true;

// Do you want AI to disappear instantly when killed?
DZMSCleanDeath = false;

// Do you want AI that players run over to not have gear?
// (If DZMSCleanDeath is true, this doesn't matter)
DZMSRunGear = false;

// How long before bodies disappear? (in seconds) (default = 2400)
DZMSBodyTime = 3500;

// Percentage of AI that must be dead before mission completes (default = 0)
//( 0 is 0% of AI / 0.50 is 50% / 1 is 100% )
DZMSRequiredKillPercent = 1;

// How long in seconds before mission scenery disappears (default = 1800 / 0 = disabled)
DZMSSceneryDespawnTimer = 3500;

// Should crates despawn with scenery? (default = false)
DZMSSceneryDespawnLoot = false;

//////////////////////////////////////////////////////////////////////////////////////////
// You can adjust the weapons that spawn in weapon crates inside DZMSWeaponCrateList.sqf
// You can adjust the AI's gear inside DZMSAIConfig.sqf in the ExtConfig folder also.
//////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////
// Do you want to use static coords for missions?
// Leave this false unless you know what you are doing.
DZMSStaticPlc = false;

// Array of static locations. X,Y,Z
DZMSStatLocs = [
[0,0,0],
[0,0,0]
];

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Do you want vehicles from missions to save to the Database? (this means they will stay after a restart)
// If False, vehicles will disappear on restart. It will warn a player who gets inside of a vehicle.
// This is experimental, and off by default in this version.
DZMSSaveVehicles = false;

/////////////////////////////////////////////////////////////////////////////////////////////
// These are arrays of vehicle classnames for the missions.
// Adjust to your liking.

// Armed Choppers
DZMSChoppers = [
    "UH1H_DZ",
    "UH1H_DZE",
    "Mi17_DZ",
    "Mi17_DZE",
    "AH1Z",
    "AH64D_EP1",
    "CH_47F_EP1_DZ",
    "CH_47F_EP1_DZE",
    "Ka52",
    "Ka137_MG_PMC",
    "MH60S_DZ",
    "MH60S_DZE",
    "MH60S",
    "Mi24_D",
    "Mi24_P",
    "Mi24_V",
    "UH1Y_DZ",
    "UH1Y_DZE",
    "UH60M_EP1_DZ",
    "UH60M_EP1_DZE"
];

// Small Vehicles
DZMSSmallVic = [
    "GAZ_Vodnik_DZE",
    "hilux1_civil_3_open_DZE",
    "hilux1_civil_2_covered_DZE",
    "hilux1_civil_1_open_DZE",
    "HMMWV_DES_EP1",
    "HMMWV_DZ",
    "HMMWV_M1035_DES_EP1",
    "SUV_Camo",
    "SUV_Blue",
    "SUV_Green",
    "SUV_TK_CIV_EP1",
    "UAZ_CDF",
    "UAZ_INS",
    "UAZ_RU",
    "UAZ_Unarmed_UN_EP1"
];

// medical vehicles
DZMSMedicalSurfaceVics = [
    "BMP2_Ambul_CDF",
    "BMP2_Ambul_INS",
    "M113Ambul_TK_EP1",
    "M113Ambul_TK_EP1_DZ",
    "M113Ambul_UN_EP1",
    "M113Ambul_UN_EP1_DZ",
    "HMMWV_Ambulance",
    "HMMWV_Ambulance_DES_EP1",
    "HMMWV_Ambulance_CZ_DES_EP1",
    "S1203_ambulance_EP1",
    "GAZ_Vodnik_MedEvac"
];

DZMSMedicalAircraft = [
    "pook_H13_medevac_INS",
    "pook_H13_medevac_UNO",
    "pook_H13_medevac_PMC",
    "Mi17_medevac_CDF",
    "Mi17_medevac_INS",
    "Mi17_medevac_RU",
    "UH60M_MEV_EP1",
    "MH6J_DZ"
];


// Large Cargo Vehicles
DZMSLargeVic = [
    "KamazOpen_DZE",
    "KamazRepair",
    "MTVR_DES_EP1",
    "MtvrRepair_DES_EP1",
    "MtvrSalvage_DES_EP1",
    "MtvrSupply_DES_EP1",
    "UralCivil_DZE",
    "UralCivil2_DZE",
    "Ural_CDF",
    "Ural_INS",
    "Ural_TK_CIV_EP1",
    "Ural_UN_EP1",
    "UralRepair_CDF",
    "UralSalvage_TK_EP1",
    "UralSupply_TK_EP1",
    "V3S_Reammo_TK_GUE_EP1",
    "V3S_Repair_TK_GUE_EP1",
    "V3S_Salvage_TK_GUE_EP1",
    "V3S_Supply_TK_GUE_EP1"
];

// armed surface vehicles level 1
DZMSArmedVics1 = [
    "BAF_Jackal2_GMG_D",
    "BAF_Jackal2_GMG_W",
    "BAF_Jackal2_L2A1_D",
    "BAF_Jackal2_L2A1_W",
    "BTR40_MG_TK_GUE_EP1",
    "GAZ_Vodnik_DZ",
    "HMMWV_M1151_M2_CZ_DES_EP1_DZ",
    "HMMWV_M998A2_SOV_DES_EP1_DZ",
    "LandRover_MG_TK_EP1_DZ",
    "UAZ_MG_TK_EP1_DZ",
    "Offroad_DSHKM_Gue_DZ",
    "Pickup_PK_GUE_DZ",
    "Pickup_PK_INS_DZ",
    "Pickup_PK_TK_GUE_EP1_DZ"
];

// armed surface vehicles level 2
DZMSArmedVics2 = [
    "ArmoredSUV_PMC_DZ",
    "BRDM2_CDF",
    "HMMWV_M998_crows_M2_DES_EP1",
    "M1126_ICV_M2_EP1"
];

// armed surface vehicles level 3
DZMSArmedVics3 = [
    "BAF_FV510_D",
    "BAF_FV510_W",
    "LAV25",
    "HMMWV_M998_crows_MK19_DES_EP1",
    "M1126_ICV_mk19_EP1",
    "M1128_MGS_EP1"
];

// active armed chopppers
DZMSActiveChoppers = [
    "UH1H_DZ",
    "Mi17_DZ",
    "CH_47F_EP1_DZ",
    "MH60S_DZ",
    "MH60S",
    "UH1Y_DZ",
    "UH60M_EP1_DZ"
];

// loot vehicles level 1
DZMSLootVehicles1 = [
    "BRDM2_ATGM_CDF",
    "BRDM2_ATGM_INS",
    "BRDM2_ATGM_TK_EP1",
    "BRDM2_ATGM_TK_GUE_EP1",
    "BAF_Jackal2_GMG_D",
    "BAF_Jackal2_GMG_W",
    "LAV25_HQ",
    "M1126_ICV_M2_EP1",
    "M1126_ICV_mk19_EP1",
    "M1130_CV_EP1",
    "M113_TK_EP1",
    "M113_UN_EP1"
];

// loot vehicles level 2
DZMSLootVehicles2 = [
    "BMP2_CDF",
    "BMP2_HQ_CDF",
    "BMP2_HQ_INS",
    "BMP2_HQ_TK_EP1",
    "BMP2_INS",
    "BMP2_GUE",
    "BMP2_TK_EP1",
    "BMP2_UN_EP1",
    "BTR90_HQ",
    "HMMWV_Avenger",
    "HMMWV_Avenger_DES_EP1",
    "HMMWV_TOW",
    "HMMWV_TOW_DES_EP1",
    "HMMWV_M998_crows_MK19_DES_EP1",
    "M1128_MGS_EP1",
    "M1129_MC_EP1",
    "M1135_ATGMV_EP1",
    "LAV25",
    "T34",
    "T34_TK_EP1",
    "T34_TK_GUE_EP1",
    "T34_TK_GUE_EP1",
    "T55_TK_EP1",
    "T55_TK_GUE_EP1"
];

// loot vehicles level 3
DZMSLootVehicles2 = [
    "BAF_FV510_D",
    "BAF_FV510_W",
    "BMP3",
    "BTR60_TK_EP1",
    "BTR90",
    "M2A2_EP1",
    "M2A3_EP1",
    "M6_EP1",
    "T72_CDF",
    "T72_INS",
    "T72_GUE",
    "T72_RU",
    "T72_TK_EP1"
];

// loot vehicles level 4
DZMSLootVehicles3 = [
    "M1A1",
    "M1A1_US_DES_EP1",
    "M1A2_TUSK_MG",
    "M1A2_US_TUSK_MG_EP1",
    "T90"
];

// loot aircraft
DZMSLootAircraft = [
    "CH_47F_BAF",
    "CH_47F_EP1",
    "CH_47F_EP1_DZ",
    "Mi24_D",
    "Mi24_D_TK_EP1",
    "Mi24_P",
    "Mi24_V",
    "MH60S",
    "MH60S_DZ",
    "MV22",
    "MV22_DZ",
    "UH1Y_DZ",
    "UH60M_EP1",
    "UH60M_EP1_DZ"
];

DZMSGunners01 = [ "UH1H_DZ" , 2 ];
DZMSGunners02 = [ "Mi17_DZ" , 2 ];
DZMSGunners03 = [ "CH_47F_EP1_DZ" , 3 ];
DZMSGunners04 = [ "Ka137_MG_PMC" , 1 ];
DZMSGunners05 = [ "MH60S_DZ" , 2 ];
DZMSGunners06 = [ "MH60S" , 2 ];
DZMSGunners07 = [ "UH60M_EP1_DZ" , 2 ];
DZMSGunners08 = [ "BAF_Jackal2_GMG_D" , 2 ];
DZMSGunners09 = [ "BAF_Jackal2_GMG_W" , 2 ];
DZMSGunners10 = [ "BAF_Jackal2_L2A1_D" , 2 ];
DZMSGunners11 = [ "BAF_Jackal2_L2A1_W" , 2 ];
DZMSGunners12 = [ "BTR40_MG_TK_GUE_EP1" , 1 ];
DZMSGunners13 = [ "GAZ_Vodnik_DZ" , 2 ];
DZMSGunners14 = [ "HMMWV_M1151_M2_CZ_DES_EP1_DZ" , 1 ];
DZMSGunners15 = [ "HMMWV_M998A2_SOV_DES_EP1_DZ" , 1 ];
DZMSGunners16 = [ "LandRover_MG_TK_EP1_DZ" , 1 ];
DZMSGunners17 = [ "UAZ_MG_TK_EP1_DZ" , 1 ];
DZMSGunners18 = [ "Offroad_DSHKM_Gue_DZ" , 1 ];
DZMSGunners19 = [ "Pickup_PK_GUE_DZE" , 1 ];
DZMSGunners20 = [ "Pickup_PK_INS_DZE" , 1 ];
DZMSGunners21 = [ "Pickup_PK_TK_GUE_EP1_DZE" , 1 ];
DZMSGunners22 = [ "ArmoredSUV_PMC_DZ" , 1 ];
DZMSGunners23 = [ "BRDM2_CDF" , 1 ];
DZMSGunners24 = [ "HMMWV_M998_crows_M2_DES_EP1" , 1 ];
DZMSGunners25 = [ "M1126_ICV_M2_EP1" ,  1 ];
DZMSGunners26 = [ "BAF_FV510_D" , 1 ];
DZMSGunners27 = [ "BAF_FV510_W" , 1 ];
DZMSGunners28 = [ "LAV25" , 1 ];
DZMSGunners29 = [ "HMMWV_M998_crows_MK19_DES_EP1" , 1 ];
DZMSGunners30 = [ "M1126_ICV_mk19_EP1" , 1 ];
DZMSGunners31 = [ "M1128_MGS_EP1" , 1 ];

DZMSGunners = [
	DZMSGunners01 , DZMSGunners02 , DZMSGunners03 , DZMSGunners04 , DZMSGunners05 , DZMSGunners06 , DZMSGunners07 ,
	DZMSGunners08 , DZMSGunners09 , DZMSGunners10 , DZMSGunners11 , DZMSGunners12 , DZMSGunners13 , DZMSGunners14 ,
	DZMSGunners15 , DZMSGunners16 , DZMSGunners17 , DZMSGunners18 , DZMSGunners19 , DZMSGunners20 , DZMSGunners21 ,
	DZMSGunners22 , DZMSGunners23 , DZMSGunners24 , DZMSGunners25 , DZMSGunners26 , DZMSGunners27 , DZMSGunners28 ,
	DZMSGunners29 , DZMSGunners30 , DZMSGunners31
];


/*///////////////////////////////////////////////////////////////////////////////////////////
There are THREE types of missions that run simultaneously on a server.
The THREE types are Major and Minor and Cookie missions.

Major missions have a higher AI count, but also have more crates to loot.
Minor missions have less AI than Major missions, but have crates that reflect that.
Cookies often have no AI at all, but the object is hidden within the mission zone.

Below is the array of mission file names and the minimum and maximum times they run.
Do not edit the Arrays unless you know what you are doing.
*/

DZMSMinorArray = [ "SM1" , "SM2" , "SM3" , "SM4" , "SM5" , "SM6" , "SM7" , "SM8" , "SM9" , "SM10" ];
DZMSMajorArray = [ "EM1" , "SM1" , "SM2" , "SM3" , "SM4" , "SM5" , "SM6" , "SM7" , "SM8" , "SM9" , "SM10" , "SM12"  ];
DZMSCookieArray = [ "CM1" , "CM2" , "CM3" , "CM4" , "CM5" , "CM6" , "CM7" ];

/////////////////////////////////////////////////////////////////////////////////////////////
// The minimum time in seconds before a minor mission will run and between missions, and the maximum value.
DZMSMinorMin = 445;
DZMSMinorMax = 607;

// The minumum time in seconds before a major mission will run and between missions, and the maximum value.
DZMSMajorMin = 877;
DZMSMajorMax = 1794;

// The minimum time in seconds before a cookie mission will run and between missions, and the maximum value.
DZMSCookieMin = 1903;
DZMSCookieMax = 3707;

// variables to control the timeout tests, in minutes
DZMSMinorTimeoutMins = 60;
DZMSMajorTimeoutMins = 60;
DZMSCookieTimeoutMins = 45;


// Blacklist Zone Array -- missions will not spawn in these areas
// format: [[x,y,z],radius]
DZMSBlacklistZones = [
	[ [ 16900, 10800 , 0 ] , 1400 ],
	[ [ 18900, 10800 , 0 ] , 1400 ],
	[ [ 16000 , 9300 , 0 ] , 1400 ],
	[ [ 18000 , 9300 , 0 ] , 1400 ],
	[ [  9500 , 4300 , 0 ] , 4500 ],
	[ [ 16500 , 4300 , 0 ] , 4500 ]
];


/*=============================================================================================*/
// Do Not Edit Below This Line
/*=============================================================================================*/
DZMSVersion = "1.1FIN";
