/*
	DayZ Mission System Functions
	originally by Vampire
	now many extensions and mods
*/

diag_log text "[DZMS]: Loading ExecVM Functions.";

DZMSMajTimer = "\z\addons\dayz_server\DZMS\Scripts\DZMSMajTimer.sqf";
DZMSMinTimer = "\z\addons\dayz_server\DZMS\Scripts\DZMSMinTimer.sqf";
DZMSCookieTimer = "\z\addons\dayz_server\DZMS\Scripts\DZMSCookieTimer.sqf";

DZMSMarkerLoop = "\z\addons\dayz_server\DZMS\Scripts\DZMSMarkerLoop.sqf";

DZMSAddMajMarker = "\z\addons\dayz_server\DZMS\Scripts\DZMSAddMajMarker.sqf";
DZMSAddMinMarker = "\z\addons\dayz_server\DZMS\Scripts\DZMSAddMinMarker.sqf";
DZMSAddCookieMarker = "\z\addons\dayz_server\DZMS\Scripts\DZMSAddCookieMarker.sqf";
DZMSAddAdminMarker = "\z\addons\dayz_server\DZMS\Scripts\DZMSAddAdminMarker.sqf";

DZMSAIKilled = "\z\addons\dayz_server\DZMS\Scripts\DZMSAIKilled.sqf";
DZMSHostageKilled = "\z\addons\dayz_server\DZMS\Scripts\DZMSHostageKilled.sqf";

DZMSBoxSetup = "\z\addons\dayz_server\DZMS\Scripts\DZMSBox.sqf";
DZMSSaveVeh = "\z\addons\dayz_server\DZMS\Scripts\DZMSSaveToHive.sqf";


diag_log text "[DZMS]: Loading Compiled Functions.";

// compiled functions
DZMSAISpawn = compile preprocessFileLineNumbers "\z\addons\dayz_server\DZMS\Scripts\DZMSAISpawn.sqf";
DZMSHostageSpawn = compile preprocessFileLineNumbers "\z\addons\dayz_server\DZMS\Scripts\DZMSHostageSpawn.sqf";
DZMSSpawnCrew = compile preprocessFileLineNumbers "\z\addons\dayz_server\DZMS\Scripts\DZMSSpawnCrew.sqf";
DZMSSpawnChopper = compile preprocessFileLineNumbers "\z\addons\dayz_server\DZMS\Scripts\DZMSSpawnChopper.sqf";
DZMSSpawnSurface = compile preprocessFileLineNumbers "\z\addons\dayz_server\DZMS\Scripts\DZMSSpawnSurface.sqf";

diag_log text "[DZMS]: Loading All Other Functions.";

// Attempts to find a mission location
// If findSafePos fails it searches again until a position is found
// This fixes the issue with missions spawning in Novy Sobor on Chernarus
DZMSFindPos = {

    	private["_mapHardCenter","_mapRadii","_isTavi","_centerPos","_pos","_disCorner","_hardX","_hardY","_findRun","_posX","_posY","_feel1","_feel2","_feel3","_feel4","_noWater","_tavTest","_tavHeight","_disMaj","_disMin","_okDis","_isBlack","_playerNear"];
  
    	// Lets try to use map specific "Novy Sobor Fixes".
    	// If the map is unrecognised this function will still work.
	// Better code thanks to Halv

	_mapHardCenter = true;
	_mapRadii = 5500;
	_isTavi = false;
	_tavHeight = 0;

	switch ( DZMSWorldName ) do {
		case "chernarus":{_centerPos = [7100, 7750, 0];_mapRadii = 5500;};
		case "utes":{_centerPos = [3500, 3500, 0];_mapRadii = 3500;};
		case "zargabad":{_centerPos = [4096, 4096, 0];_mapRadii = 4096;};
		case "fallujah":{_centerPos = [3500, 3500, 0];_mapRadii = 3500;};
		case "takistan":{_centerPos = [5500, 6500, 0];_mapRadii = 5000;};
		case "tavi":{_centerPos = [10370, 11510, 0];_mapRadii = 14090;_isTavi = true;};
		case "lingor":{_centerPos = [4400, 4400, 0];_mapRadii = 4400;};
		case "namalsk":{_centerPos = [4352, 7348, 0]};
		case "napf":{_centerPos = [10240, 10240, 0];_mapRadii = 10240;};
		case "mbg_celle2":{_centerPos = [8765.27, 2075.58, 0]};
		case "oring":{_centerPos = [1577, 3429, 0]};
		case "panthera2":{_centerPos = [4400, 4400, 0];_mapRadii = 4400;};
		case "isladuala":{_centerPos = [4400, 4400, 0];_mapRadii = 4400;};
		case "smd_sahrani_a2":{_centerPos = [13200, 8850, 0]};
		case "sauerland":{_centerPos = [12800, 12800, 0];_mapRadii = 12800;};
		case "trinity":{_centerPos = [6400, 6400, 0];_mapRadii = 6400;};

		// We don't have a supported map. Let's use the norm.
		default{_pos = [getMarkerPos "center",0,5500,60,0,20,0] call BIS_fnc_findSafePos;_mapHardCenter = false;};
	};

    	// If we have a hardcoded center, then we need to loop for a location
    	// Else we can ignore this block of code and just return the position
    	if ( _mapHardCenter AND ( !( DZMSStaticPlc ) ) ) then {
   
        _hardX = _centerPos select 0;
        _hardY = _centerPos select 1;
   
        // We need to loop findSafePos until it doesn't return the map center
        _findRun = true;
        while {_findRun} do
        {
            _pos = [ _centerPos , 0 , _mapRadii , 60 , 0 , 20 , 0 ] call BIS_fnc_findSafePos;
           
            // Apparently you can't compare two arrays and must compare values
            _posX = _pos select 0;
            _posY = _pos select 1;
           
            // Water Feelers. Checks for nearby water within 50meters.
            _feel1 = [ _posX , _posY+50 , 0 ];
            _feel2 = [ _posX+50 , _posY , 0 ];
            _feel3 = [ _posX , _posY-50 , 0 ];
            _feel4 = [ _posX-50 , _posY , 0 ];
           
            // Water Check
            _noWater = ( !surfaceIsWater _pos && !surfaceIsWater _feel1 && !surfaceIsWater _feel2 && !surfaceIsWater _feel3 && !surfaceIsWater _feel4 );
			
			// Lets test the height on Taviana
			if ( _isTavi ) then {
				_tavTest = createVehicle [ "Can_Small" , [ _posX , _posY , 0 ] , [] , 0 , "CAN_COLLIDE" ];
				_tavHeight = ( getPosASL _tavTest ) select 2;
				deleteVehicle _tavTest;
			};
			
			// Lets check for minimum mission separation distance
			_disMaj = ( _pos distance DZMSMajCoords );
			_disMin = ( _pos distance DZMSMinCoords );
			_okDis = ( ( _disMaj > 1000 ) AND ( _disMin > 1000 ) );
		   
            // make sure the point is not blacklisted
            _isBlack = false;
            {
                if ( ( _pos distance ( _x select 0 ) ) <= ( _x select 1 ) ) then { _isBlack = true; };

            } forEach DZMSBlacklistZones;
			
            _playerNear = {isPlayer _x} count (_pos nearEntities ["CAManBase", 500]) > 0;
            
            // Lets combine all our checks to possibly end the loop
            if ( ( _posX != _hardX ) AND ( _posY != _hardY ) AND _noWater AND _okDis AND !_isBlack AND !_playerNear ) then {

                if ( !( _isTavi ) ) then {

                    _findRun = false;
                };

                if ( _isTavi AND ( _tavHeight <= 185 ) ) then {

                    _findRun = false;
                };

            };

            // If the missions never spawn after running, use this to debug the loop.
            // Will Complete if: noWater = true / Distance > 1000 / TaviHeight <= 185 / Blacklisted = false / PlayerNear = false
            // diag_log text format ["[DZMS]: DEBUG: Pos:[%1,%2] / noWater?:%3 / okDistance?:%4 / TaviHeight:%5 / isBlackListed:%6 / isPlayerNear:%7", _posX, _posY, _noWater, _okDis, _tavHeight, _isBlack, _playerNear];
            sleep 2;
        };
       
    };
	
    if ( DZMSStaticPlc ) then {

        _pos = DZMSStatLocs call BIS_fnc_selectRandom;
    };
   
    _fin = [ ( _pos select 0 ) , ( _pos select 1 ) , 0 ];

    _fin
};

DZMSEmptyBoxCompletely = {

	// used to clear everything out of a box or boxes, in case of ambush

	// run the various global empty commands on each item in the parameter list
	{
		clearWeaponCargoGlobal _x;
		clearMagazineCargoGlobal _x;
		clearBackpackCargoGlobal _x;

	} forEach _this;

	// done here
	true
};

// Clears the cargo and sets fuel, direction, and orientation
// Direction stops the awkwardness of every vehicle bearing 0
DZMSSetupVehicle = {

	private [ "_object" , "_objectID" , "_ranFuel" , "_iPersistentFlag" ];

	// get the object handle
	_object = _this select 0;

	// get the persistence flag
	_iPersistentFlag = _this select 1;

	// check to see if we want a specific fuel value
	if ( ( count _this ) > 2 ) then {

		_ranFuel = _this select 2;

	} else {

		_ranFuel = random 1;

		if ( _ranFuel < .1 ) then { _ranFuel = .1; };
	};

	// make a random object ID
	_objectID = str ( round ( random 9999999 ) );

	// legacy setvariables
	_object setVariable [ "ObjectID" , _objectID , true ];
	_object setVariable [ "ObjectUID" , _objectID , true ];
	
	if ( DZMSEpoch ) then {

		PVDZE_serverObjectMonitor set [ count PVDZE_serverObjectMonitor , _object ];

	} else {

		dayz_serverObjectMonitor set [ count dayz_serverObjectMonitor , _object ];

	};
	
	// wait until the vehicle is in the system
	waitUntil { ( !isNull _object ) };

	// clean out the vehicle
	[ _object ] call DZMSEmptyBoxCompletely;
	
	// set fuel, speed, and random direction	
	_object setFuel _ranFuel;
	_object setvelocity [ 0 , 0 , 1 ];
	_object setDir ( round( random 360 ) );
	
	// if saving vehicles to the database is disabled AND if the persistent flag for this vehicle is low, warn players it will disappear upon entry
	if ( ( !( DZMSSaveVehicles ) ) AND ( _iPersistentFlag < 1 ) ) then {

		_object addEventHandler [ "GetIn", {
			_nil = [ nil , nil , rTITLETEXT , "Warning: This vehicle will disappear on server restart!" , "PLAIN DOWN" , 5 ] call RE;
		} ];
	};

	// done here
	true
};

// Prevents an object being cleaned up by the server anti-hack
DZMSProtectObj = {

	private [ "_object" , "_objectID" ];

	_object = _this select 0;
	
	_objectID = str( round( random 999999 ) );
	_object setVariable [ "ObjectID" , _objectID , true ];
	_object setVariable [ "ObjectUID" , _objectID , true ];
	
	if ( _object isKindOf "ReammoBox" ) then {

		// PermaLoot on top of ObjID because that "arma logic"
		_object setVariable [ "permaLoot" , true ];
	};

	if ( DZMSEpoch ) then {

		PVDZE_serverObjectMonitor set [ count PVDZE_serverObjectMonitor , _object ];

	} else {

		dayz_serverObjectMonitor set [ count dayz_serverObjectMonitor , _object ];

	};
	
	if ( !( ( typeOf _object ) in DZMSLootBoxTypes ) ) then {

		_object setVariable[ "DZMSCleanup" , true ];
	};

	true
};

// Gets the weapon and magazine based on skill level
DZMSGetWeapon = {

	private [ "_skill" , "_aiweapon" , "_weapon" , "_magazine" , "_fin" ];
	
	_skill = _this select 0;
	
	// diag_log text format [ "[DZMS]: AI Skill Func:%1" , _skill ];
	
	switch ( _skill ) do {

		case 0: { _aiweapon = DZMSWeps0; };
		case 1: { _aiweapon = DZMSWeps1; };
		case 2: { _aiweapon = DZMSWeps2; };
		case 3: { _aiweapon = DZMSWeps3; };
	};

	_weapon = _aiweapon call BIS_fnc_selectRandom;

	_magazine = getArray ( configFile >> "CfgWeapons" >> _weapon >> "magazines" ) select 0;

	_fin = [ _weapon , _magazine ];
	
	_fin
};


// This returns a random vehicle type from a predefined list
DZMSGetVeh = {

	private [ "_type" , "_vehArray" , "_choseVic" ];
	
	_type = _this select 0;
	
	switch ( _type ) do {

		case "heli": { _vehArray = DZMSChoppers; };
		case "Heli": { _vehArray = DZMSChoppers; };
		case "chopper": { _vehArray = DZMSChoppers; };
		case "Chopper": { _vehArray = DZMSChoppers; };
		case "small": { _vehArray = DZMSSmallVic; };
		case "Small": { _vehArray = DZMSSmallVic; };
		case "large": { _vehArray = DZMSLargeVic; };
		case "Large": { _vehArray = DZMSLargeVic; };
		case "medicalground": { _vehArray = DZMSMedicalSurfaceVics; };
		case "MedicalGround": { _vehArray = DZMSMedicalSurfaceVics; };
		case "medicalaircraft": { _vehArray = DZMSMedicalAircraft; };
		case "MedicalAircraft": { _vehArray = DZMSMedicalAircraft; };
		case "armedsurface1": { _vehArray = DZMSArmedVics1; };
		case "ArmedSurface1": { _vehArray = DZMSArmedVics1; };
		case "armedsurface2": { _vehArray = DZMSArmedVics2; };
		case "ArmedSurface2": { _vehArray = DZMSArmedVics2; };
		case "armedsurface3": { _vehArray = DZMSArmedVics3; };
		case "ArmedSurface3": { _vehArray = DZMSArmedVics3; };
		case "activechopper": { _vehArray = DZMSActiveChoppers; };
		case "ActiveChopper": { _vehArray = DZMSActiveChoppers; };
		case "lootvehicle1": { _vehArray = DZMSLootVehicles1; };
		case "LootVehicle1": { _vehArray = DZMSLootVehicles1; };
		case "lootvehicle2": { _vehArray = DZMSLootVehicles2; };
		case "LootVehicle2": { _vehArray = DZMSLootVehicles2; };
		case "lootvehicle3": { _vehArray = DZMSLootVehicles3; };
		case "LootVehicle3": { _vehArray = DZMSLootVehicles3; };
		case "lootvehicle4": { _vehArray = DZMSLootVehicles4; };
		case "LootVehicle4": { _vehArray = DZMSLootVehicles4; };
		case "lootaircraft": { _vehArray = DZMSLootAircraft; };
		case "LootAircraft": { _vehArray = DZMSLootAircraft; };
	};
	
	_choseVic = _vehArray call BIS_fnc_selectRandom;
	
	_choseVic
};


DZMSVehicleCategories = [ "heli" , "Heli" , "chopper" , "Chopper" , "small" , "Small" , "large" , "Large" , "medicalground" , "MedicalGround" , 
	"medicalaircraft" , "MedicalAircraft" , "armedsurface1" , "ArmedSurface1" , "armedsurface2" , "ArmedSurface2" , "armedsurface3" , "ArmedSurface3" , 
	"activechopper" , "ActiveChopper" , "lootvehicle1" , "LootVehicle1" , "lootvehicle2" , "LootVehicle2" , "lootvehicle3" , "LootVehicle3" , 
	"lootvehicle4" , "LootVehicle4" , "lootaircraft" , "LootAircraft" ];


// function to set up ambush AI
DZMSSetupAmbush = {

	private [ "_iGroupCount" , "_iUnitCount" , "_posFakeObjective" , "_fRadius" , "_fAngle" , "_foffsetx" , "_foffsety" ,
		"_iGroupMin" , "_iGroupAdd" , "_iUnitMin" , "_iUnitAdd" , "_iSkillMin" , "_iSkillMax" , "_iGroupsBefore" , "_iMissionType" ];

	// get the coordinates of the original mission objective from the parameter list
	_posFakeObjective = _this select 0;

	// now get the distance from which the ambush groups will approach
	_fRadius = _this select 1;

	// get the counts for groups and units ...
	_iGroupMin = _this select 2;
	_iGroupAdd = _this select 3;
	_iUnitMin = _this select 4;
	_iUnitAdd = _this select 5;

	// get the min and max skill levels
	_iSkillMin = _this select 6;
	_iSkillMax = _this select 7;

	// get the mission type
	_iMissionType = _this select 8;

	// now figure out how many groups are involved ...
	_iGroupCount = _iGroupMin + floor random _iGroupAdd;

	// figure out how many groups there were before
	switch ( _iMissionType ) do {
		case 1: { _iGroupsBefore = count DZMSGroupsMinor; };
		case 2: { _iGroupsBefore = count DZMSGroupsMajor; };
		case 3: { _iGroupsBefore = count DZMSGroupsCookie; };
	};

	// now create that many groups
	for "_iloop" from 1 to _iGroupCount do {

		// which direction is this group
		_fAngle = random 360;

		// so their offset position is ...
		_foffsetx = _fRadius * ( cos _fAngle );
		_foffsety = _fRadius * ( sin _fAngle );

		// and how many AI are in this group
		_iUnitCount = _iUnitMin + floor random _iUnitAdd;

		// and figure a skill level for this group
		_iSkillLevel = _iSkillMin + floor ( random ( 1 + _iSkillMax - _iSkillMin ) );

		// cap the skill level
		if ( _iSkillLevel > 3 ) then {
			_iSkillLevel = 3;
		};

		// make the spawn call
		[ [ ( _posFakeObjective select 0 ) + _foffsetx , ( _posFakeObjective select 1 ) - _foffsety  , 0 ] , _iUnitCount  , _iSkillLevel , _iMissionType , ( _iGroupsBefore + _iloop - 1 ) , _posFakeObjective ] call DZMSAISpawn;
		sleep 5;
	};

	// we're done here
	true
};

// function to wait for mission escape - cookies w/ambush
DZMSWaitAmbushEscape = {

    private[ "_posObjective" , "_bAllPlayersAway" ];
	
    _posObjective = _this select 0;
	
    diag_log text "[DZMS]: Waiting for all players to escape and be 1 km distant from the Mission Extension Ambush Area.";
	
    waitUntil {

        // wait a bit
        sleep 1;

        // set a flag
        _bAllPlayersAway = true;

        // traverse the list of playableUnits, which is all AI and all players
        {
            // if any player unit is inside the radius, false the flag
            if ( ( isPlayer _x ) && ( ( _x distance _posObjective ) < 1000 ) ) then {

                _bAllPlayersAway = false;
            };

        } forEach playableUnits;

        _bAllPlayersAway

    };
};


// function to wait for mission completion - cookies
DZMSWaitCookieMissionComp = {

    private[ "_objective" ];
	
    _objective = _this select 0;
	
    diag_log text "[DZMS]: Waiting for a player to be near the Cookie Objective.";
	
    call compile 
        "waitUntil {
            sleep 1; 
            ( 
                { isPlayer _x && _x distance _objective <= 5 } count playableUnits > 0  
            ) 
            OR
            (
                DZMSCookieTimeoutEXPIRED 
            )
        };" 
};

// function to wait for mission completion - majors
DZMSWaitMajorMissionComp = {

    private[ "_objective" , "_numSpawned" , "_numKillReq" ];
	
    _objective = _this select 0;
	
    _numSpawned = count DZMSUnitsMajor;
    _numKillReq = ceil( DZMSRequiredKillPercent * _numSpawned );
	
    diag_log text format[ "[DZMS]: Major Units waiting for %1/%2 Units or Less to be Alive and a Player to be Near the Objective." , (_numSpawned - _numKillReq) , _numSpawned ];
	
    call compile 
        "waitUntil {
            sleep 1; 
            (
                (
                    { isPlayer _x && _x distance _objective <= 30 } count playableUnits > 0 
                ) 
                && 
                ( 
                    { alive _x } count DZMSUnitsMajor <= ( _numSpawned - _numKillReq )
                )
            )
            OR
            (
                DZMSMajorTimeoutEXPIRED
            )
        };" 
};

// function to wait for mission completion - minors
DZMSWaitMinorMissionComp = {

    private[ "_objective" , "_numSpawned" , "_numKillReq" ];
	
    _objective = _this select 0;
	
    _numSpawned = count DZMSUnitsMinor;
    _numKillReq = ceil( DZMSRequiredKillPercent * _numSpawned );
	
    diag_log text format[ "[DZMS]: Minor Units waiting for %1/%2 Units or Less to be Alive and a Player to be Near the Objective." , (_numSpawned - _numKillReq) , _numSpawned ];
	
    call compile 
        "waitUntil {
            sleep 1; 
            (
                (
                    { isPlayer _x && _x distance _objective <= 30 } count playableUnits > 0 
                ) 
                && 
                ( 
                    { alive _x } count DZMSUnitsMinor <= ( _numSpawned - _numKillReq )
                )
            )
            OR
            (
                DZMSMinorTimeoutEXPIRED
            )
        };" 
};

// sleep function that uses diag_tickTime for accuracy
DZMSSleep = {

    	private[ "_sleepTime" , "_checkInterval" , "_startTime" ];
	
    	_sleepTime = _this select 0;
    	_checkInterval = _this select 1;
	
    	_startTime = diag_tickTime;
    	waitUntil{ sleep _checkInterval; ( diag_tickTime - _startTime ) > _sleepTime; };
};

// function to purge an object
DZMSPurgeObject = {
    	_this enableSimulation false;
    	_this removeAllMPEventHandlers "mpkilled";
    	_this removeAllMPEventHandlers "mphit";
    	_this removeAllMPEventHandlers "mprespawn";
    	_this removeAllEventHandlers "FiredNear";
    	_this removeAllEventHandlers "HandleDamage";
    	_this removeAllEventHandlers "Killed";
    	_this removeAllEventHandlers "Fired";
    	_this removeAllEventHandlers "GetOut";
    	_this removeAllEventHandlers "GetIn";
    	_this removeAllEventHandlers "Local";
    	clearVehicleInit _this;
    	deleteVehicle _this;
    	_this = nil;
};

DZMSPurgeMajorGroups = {

    { 
        deleteGroup _x;
    } forEach DZMSGroupsMajor; 

    DZMSGroupsMajor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesMajor; 

    DZMSGroupsHostagesMajor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesMajor; 

    DZMSGroupsInVehiclesMajor = [];
};

DZMSPurgeAllMajorAI = {

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsMajor;

    DZMSUnitsMajor = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsHostagesMajor;

    DZMSUnitsHostagesMajor = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsInVehiclesMajor;

    DZMSUnitsInVehiclesMajor = [];

    sleep 10;

    { 
        deleteGroup _x;
    } forEach DZMSGroupsMajor; 

    DZMSGroupsMajor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesMajor; 

    DZMSGroupsHostagesMajor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesMajor; 

    DZMSGroupsInVehiclesMajor = [];
};

DZMSPurgeMinorGroups = {

    { 
        deleteGroup _x;
    } forEach DZMSGroupsMinor; 

    DZMSGroupsMinor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesMinor; 

    DZMSGroupsHostagesMinor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesMinor; 

    DZMSGroupsInVehiclesMinor = [];
};

DZMSPurgeAllMinorAI = {

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsMinor;

    DZMSUnitsMinor = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsHostagesMinor;

    DZMSUnitsHostagesMinor = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsInVehiclesMinor;

    DZMSUnitsInVehiclesMinor = [];

    sleep 10;

    { 
        deleteGroup _x;
    } forEach DZMSGroupsMinor; 

    DZMSGroupsMinor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesMinor; 

    DZMSGroupsHostagesMinor = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesMinor; 

    DZMSGroupsInVehiclesMinor = [];
};

DZMSPurgeCookieGroups = {

    { 
        deleteGroup _x;
    } forEach DZMSGroupsCookie; 

    DZMSGroupsCookie = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesCookie; 

    DZMSGroupsHostagesCookie = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesCookie; 

    DZMSGroupsInVehiclesCookie = [];
};

DZMSPurgeAllCookieAI = {

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsCookie;

    DZMSUnitsCookie = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsHostagesCookie;

    DZMSUnitsHostagesCookie = [];

    {
        _x setDamage 1; 
        _x call DZMSPurgeObject;
    } forEach DZMSUnitsInVehiclesCookie;

    DZMSUnitsInVehiclesCookie = [];

    sleep 10;

    { 
        deleteGroup _x;
    } forEach DZMSGroupsCookie; 

    DZMSGroupsCookie = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsHostagesCookie; 

    DZMSGroupsHostagesCookie = [];

    { 
        deleteGroup _x;
    } forEach DZMSGroupsInVehiclesCookie; 

    DZMSGroupsInVehiclesCookie = [];
};

DZMSDelBackpacks = {

    // local variables
    private [ "_lstObjects" , "_strBPClassID" , "_coords" ];


    // get the coordinates from the argument list
    _coords = _this select 0;


    // initialize an empty array
    _lstObjects = [];

    // find the list of objects within 50 m of the mission coordinates
    _lstObjects = _coords nearObjects 50;


    // traverse the list
    {

        // find the class ID of the object in the list
        _strBPClassID = typeOf _x;


        // if the class ID is in the packpack list ...
        if ( _strBPClassID in DZMSPacklist ) then {

            // nuke that object
            _x call DZMSPurgeObject;
         
        };

    } forEach _lstObjects;

    true

};

DZMSFindGunnerCount = {

	private [ "_vehTargetType" , "_iChopperCount" , "_mlPair" , "_strTestType" , "_iGunners" , "_iLastIndex" , "_iloop" ];

	// get the vehicle type from the parameter list
	_vehTargetType = _this select 0;

	// initialize the value in case we can't find it
	_iGunners = 1;

	// how many elements are there?
	_iChopperCount = count DZMSGunners;

	// find the last index of the chopper pair
	_iLastIndex = _iChopperCount - 1;

	// traverse the list
	for "_iloop" from 0 to _iLastIndex do {

		// pull the pair
		_mlPair = DZMSGunners select _iloop;

		// get the contents of that pair
		_strTestType = _mlPair select 0;

		// test the vehicle string
		if ( _strTestType == _vehTargetType ) exitWith {

			_iGunners = _mlPair select 1;
		};

	};

	// done here -- return the value that may have been modified by the config data
	_iGunners
};

// function to clean up mission objects
DZMSCleanupThread = {
    	// sleep for the despawn timer length
    	[ DZMSSceneryDespawnTimer , 20 ] call DZMSSleep;
	
    	// delete flagged nearby objects
    	{
        	if ( _x getVariable [ "DZMSCleanup" , false ] ) then {
            	_x call DZMSPurgeObject;
        	};
    	} forEach ( _this nearObjects 50 );
};

//------------------------------------------------------------------//

diag_log text format [ "[DZMS]: Mission Functions Script Loaded!" ];
