/*																					//
	Weapons Cache Mission by lazyink (Original Full Code by TheSzerdi & TAW_Tonic)
	New Mission Format by Vampire
*/																					//

// when we come into this script, the mission timeout timer is already running

private [ "_missName" , "_coords" , "_net" , "_veh1" , "_veh2" , "_vehicle1" , "_vehicle2" , "_crate1" , "_crate2" , "_crate3" , "_crate4" ];

// Name of the Mission
_missName = "Forward Ordnance Depot";

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[ nil , nil , rTitleText , "Bandits have siezed a forward ordinance depot!" , "PLAIN" , 10 ] call RE;

// DZMSAddMajMarker is a simple script that adds a marker to the location
DZMSfMajMarkerSize = 250;
DZMSstrMajMarkerColor = "ColorRed";
DZMSstrMajMarkerBrush = "Grid";
DZMSstrMajMarkerShape = "ELLIPSE";
[ _coords , _missname ] ExecVM DZMSAddMajMarker;

// Lets add the scenery
_net = createVehicle [ "Land_CamoNetB_NATO" , [ ( _coords select 0 ) - 0.0649 , ( _coords select 1 ) + 0.6025 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
[ _net ] call DZMSProtectObj;

// We create the vehicles like normal
_veh1 = [ "small" ] call DZMSGetVeh;
_veh2 = [ "large" ] call DZMSGetVeh;
_vehicle1 = createVehicle [ _veh1 , [ ( _coords select 0 ) + 10.0303 , ( _coords select 1 ) - 12.298 , 10 ] , [] , 0 , "CAN_COLLIDE" ];
_vehicle2 = createVehicle [ _veh2 , [ ( _coords select 0 ) - 6.2764 , ( _coords select 1 ) - 14.086 , 10 ] , [] , 0 , "CAN_COLLIDE" ];

// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel and such
[ _vehicle1 , 0 ] call DZMSSetupVehicle;
[ _vehicle2 , 0 ] call DZMSSetupVehicle;

_crate1 = createVehicle [ "USVehicleBox" , _coords , [] , 0 , "CAN_COLLIDE" ];
_crate2 = createVehicle [ "AmmoBoxSmall_556" , [ ( _coords select 0 ) - 3.7251 , ( _coords select 1 ) - 2.3614 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
_crate3 = createVehicle [ "AmmoBoxSmall_762" , [ ( _coords select 0 ) - 2.6346 , ( _coords select 1 ) - 2.7614 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
_crate4 = createVehicle [ "AmmoBoxSmall_556" , [ ( _coords select 0 ) + 4.0996 , ( _coords select 1 ) + 3.9072 , 0 ] , [] , 0 , "CAN_COLLIDE" ];

// DZMSBoxFill fills the box, DZMSProtectObj prevents it from disappearing
[ _crate1 , "weapons" ] ExecVM DZMSBoxSetup;
[ _crate1 ] call DZMSProtectObj;
[ _crate2 ] call DZMSProtectObj;
[ _crate3 ] call DZMSProtectObj;
[ _crate4 ] call DZMSProtectObj;

// DZMSAISpawn spawns AI to the mission.

[ [ ( _coords select 0 ) + 0.0352 , ( _coords select 1 ) - 6.8799 , 0 ] , 6 , 1 , 2 , 0 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) + 0.0352 , ( _coords select 1 ) - 6.8799 , 0 ] , 6 , 1 , 2 , 1 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) + 0.0352 , ( _coords select 1 ) - 6.8799 , 0 ] , 4 , 1 , 2 , 2 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) + 0.0352 , ( _coords select 1 ) - 6.8799 , 0 ] , 4 , 2 , 2 , 3 ] call DZMSAISpawn;
sleep 5;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMajorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMajorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMajorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMajorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMajorAI;

    // nuke the individual objects and scenery

    _net call DZMSPurgeObject;

    _crate1 call DZMSPurgeObject;
    _crate2 call DZMSPurgeObject;
    _crate3 call DZMSPurgeObject;
    _crate4 call DZMSPurgeObject;

    _vehicle1 call DZMSPurgeObject;
    _vehicle2 call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // clean up the AI groups
    call DZMSPurgeMajorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Forward Ordnance mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Major SM1 Forward Ordnance mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database
    [ _vehicle1 ] ExecVM DZMSSaveVeh;
    [ _vehicle2 ] ExecVM DZMSSaveVeh;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have taken the Forward Ordnance Depot!" , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Major SM1 Forward Ordnance mission has Ended." ];
};


// nuke the markers
deleteMarker "DZMSMajMarker";
deleteMarker "DZMSMajDot";

//Let the timer know the mission is over
DZMSMajDone = true;