
// when we come into this script, the mission timeout timer is already running

private [ "_strMissionName" , "_strMissionHail" , "_strMissionSuccess" , "_strMissionID" , 
 	"_lstBoxesLocal" , "_lstBoxesSetups" , "_lstVehiclesLocal" , "_lstVehiclesPersistent" , "_lstVehiclesLocked" , "_lstObjectsLocal" , "_lstSpawnsLocal" ,
	"_coords" , "_iloop" , "_strVehicleTypeOrCat" , "_strVehicleType" , "_fx" , "_fy" , "_fz" , "_frot" , "_fFuelNow" , "_nowVehicle" , "_iPersistNow" , "_vehHandles" ,
	"_strBoxType" , "_nowBox" , "_strBoxFill" , "_strObjectType" , "_nowObject" , "_boxHandles" , "_objHandles" , "_iHowManyInSquad" , "_iSkill" , "_bIsAmbush" ];



// mission name and messages

_strMissionName = "Bandit Materiel Stockpile";
_strMissionHail = "Survivor intel reports an impressive buildup of equipment, almost undefended!\nInvestigate the site and grab what you can!";
_strMissionSuccess = "Survivors have taken the bandit materiel stockpile!";
_strMissionID = "Major SM10";

_strMissionExtensionHail = "Survivor spotters have gone silent...";
_strMissionSuccess2 = "All remaining survivors have escaped the bandit ambush.";

// mission boxes

_specBox01 = [ "RUVehicleBox", 19.6709, -7.2813, 0, -83.79744 ];
_specBox02 = [ "RUVehicleBox", 7.9917, -6.7549, 0, -37.424088 ];
_specBox03 = [ "RUVehicleBox", -3.6592, -6.3330, 0, 87.649094 ];
_specBox04 = [ "RUVehicleBox", 8.7241, 1.8750, 0, 0 ];
_specBox05 = [ "RUVehicleBox", 7.0037, -16.0947, 0, -180.2733 ];

_lstBoxesLocal = [ _specBox01 , _specBox02 , _specBox03 , _specBox04 , _specBox05 ];

_lstBoxesSetups = [ "empty" , "empty" , "empty" , "empty" , "empty" ];

// mission vehicles ( type ID or category, x, y, z, rot ( >360 = random ), fuel ( <0 = random ) )

_specVeh01 = [ "BRDM2_ATGM_CDF", -3.6289, -16.5527, 0, 198.48228, 0 ];
_specVeh02 = [ "BMP2_CDF", 19.5701, -18.2812, 0, 128.41728, 0 ];
_specVeh03 = [ "T72_CDF", 22.6887 , 3.3330, 0, 75.064369, 0 ];
_specVeh04 = [ "BMP2_CDF", -2.7429 , 3.2354, 0, -66.96936, 0 ];
_specVeh05 = [ "Mi171Sh_CZ_EP1", 19.1750, 18.2812, 0, -44.81847, 0 ];
_specVeh06 = [ "Mi171Sh_rockets_CZ_EP1", -22.6885, -14.9658, 0, 28.228556, 0 ];

_lstVehiclesLocal = [ _specVeh01 , _specVeh02  , _specVeh03 , _specVeh04 , _specVeh05 , _specVeh06 ];

_lstVehiclesPersistent = [ 999 ];

_lstVehiclesLocked = [ 0 , 1 , 2 , 3 , 4 , 5 ];

// scenary / other objects

_spcObj01 = [ "MAP_CamoNet_EAST_var1", 8.3101, -7.0762, 0, 0 ];
_spcObj02 = [ "MAP_CamoNet_EAST", 9.2026, 4.3711, 0, 0 ];
_spcObj03 = [ "MAP_CamoNet_EAST", 21.1167, -7.9336, 0, 92.627365 ];
_spcObj04 = [ "MAP_CamoNet_EAST", -4.9714, -6.5830, 0, -89.988602 ];
_spcObj05 = [ "MAP_CamoNet_EAST", 7.4368, -17.0322, 0, 180.0414 ];

_lstObjectsLocal = [
	_spcObj01 , _spcObj02 , _spcObj03 , _spcObj04 , _spcObj05
];

// AI spawn specifications

_spcSpawnData01 = [ 0.3152, -11.3516, 0, 2, 0 ];
_spcSpawnData02 = [ 15.4128, -0.2988, 0, 2, 0 ];

_lstSpawnsLocal = [ _spcSpawnData01 , _spcSpawnData02 ];

// mission marker parameters

DZMSfMajMarkerSize = 200;
DZMSstrMajMarkerColor = "ColorYellow";
DZMSstrMajMarkerBrush = "Grid";
DZMSstrMajMarkerShape = "ELLIPSE";



// start standard common mission code

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result

_coords = call DZMSFindPos;

[ nil , nil , rTitleText , _strMissionHail , "PLAIN" , 10 ] call RE;

// DZMSAddMajMarker is a simple script that adds a marker to the location

[ _coords , _strMissionName ] ExecVM DZMSAddMajMarker;


// initialize the now counter for vehicle setup and empty the array just in case

_iloop = 0;
_vehHandles = [];

// traverse the vehicles to be set up
{
	// get the vehicle class ID or category
	_strVehicleTypeOrCat	= _x select 0;

	// see if it's a CATEGORY as opposed to a TYPE ....
	if ( 	_strVehicleTypeOrCat in DZMSVehicleCategories ) then {
		_strVehicleType = [ _strVehicleTypeOrCat ] call DZMSGetVeh;
	} else {
		_strVehicleType = _strVehicleTypeOrCat;
	};

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// get the fuel
	_fFuelNow = _x select 5;

	// create the vehicle and stash the handle
	_nowVehicle = createVehicle [ _strVehicleType, [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set up the persistence flat
	_iPersistNow = 0;

	// set up the persistance flag
	if ( _iloop in _lstVehiclesPersistent ) then {
		_iPersistNow = 1;
	};

	// set up the fuel value
	if ( _fFuelNow > 1 ) then {
		_fFuelNow = 1;
	};

	// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel
	if ( _fFuelNow < 0 ) then {
		[ _nowVehicle , _iPersistNow ] call DZMSSetupVehicle;
	} else {
		[ _nowVehicle , _iPersistNow , _fFuelNow ] call DZMSSetupVehicle;
	};

	// set the rotation
	_nowVehicle setDir _frot;

	// set up the lock state
	if ( _iloop in _lstVehiclesLocked ) then {
		_nowVehicle setVehicleLock "LOCKED";
	};

	// stash the handle in the array
	_vehHandles set [ _iloop , _nowVehicle ];

	// finally, increment the index
	_iloop = _iloop + 1;

} forEach _lstVehiclesLocal;

// end vehicle setup


// initialize the now counter for crate setup and empth the handle array just in case
_iloop = 0;
_boxHandles = [];

// traverse the crates to be set up
{
	// get the box type, which is never random
	_strBoxType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the mission box
	_nowBox = createVehicle [ _strBoxType  , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowBox setDir _frot;

	// select the mission box fill style
	_strBoxFill = _lstBoxesSetups select _iloop;

	// fill the box
	[ _nowBox , _strBoxFill ] ExecVM DZMSBoxSetup;

	// protect the box from the antihack system
	[ _nowBox ] call DZMSProtectObj;

	// stash the handle in an array
	_boxHandles set [ _iloop , _nowBox ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstBoxesLocal;

//  end box/crate setup


// initialize the now counter for scenery setup
_iloop = 0;
_objHandles = [];

// traverse the scenery objects to be set up
{
	// get the object type, which is never random
	_strObjectType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the scenery object
	_nowObject = createVehicle [ _strObjectType , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowObject setDir _frot;

	// protect the box from the antihack system
	[ _nowObject ] call DZMSProtectObj;

	// stash the handle in an array
	_objHandles set [ _iloop , _nowObject ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstObjectsLocal;

//  end scenery object setup


// initialize the now counter for scenery setup
_iloop = 0;

// traverse the AI spawn specs
{
	// get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 0 );
	_fy = ( _coords select 1 ) + ( _x select 1 );
	_fz = _x select 2;

	// how many in this squad
	_iHowManyInSquad = _x select 3;

	// and what's their skill level?
	_iSkill = _x select 4;

	// do the spawn
	[ [ _fx , _fy , _fz ] , _iHowManyInSquad , _iSkill , 2 , _iloop ] call DZMSAISpawn;

	// increment the counter
	_iloop = _iloop + 1;

	// a short delay
	sleep 5;

} forEach _lstSpawnsLocal;

// done with AI spawns


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMajorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMajorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMajorTimeoutEXPIRED ) then {

   	// we timed out -- stop the acceptance test
    	DZMSMajorAcceptanceTestRunning = false;

    	// at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    	sleep 30;

    	// so now timer, acceptance, and mission complete tests are all shut down....

    	// nuke all the AI
    	call DZMSPurgeAllMajorAI;

	// nuke the individual vehicles
	{
		_x call DZMSPurgeObject;
	} forEach _vehHandles;

	// nuke the individual mission boxes
	{
	    _x call DZMSPurgeObject;
	} forEach _boxHandles;

	// nuke the individual scenery objects
	{
	    _x call DZMSPurgeObject;
	} forEach _objHandles;

	// nuke the loose backpacks -- does nothing if there aren't any
	[ _coords ] call DZMSDelBackpacks; 

	// Let everyone know the mission is over
	[ nil , nil , rTitleText , format [ "%1 mission has timed out." , _strMissionName ] , "PLAIN" , 6 ] call RE;
	diag_log text format [ "[DZMS]: %1 %2 mission has timed out." , _strMissionID , _strMissionName ];

} else {

    	// acceptance test has already shut down timer. completion test is shut down too....

    	// here is where we would set persistence to any loot vehicles

   	// Call DZMSSaveVeh to attempt to save the vehicles to the database
	// re-init iloop
	_iloop = 0;
	{
		// set up the persistance flag
		_iPersistNow = 0;

		// check to see if this index is in the list
		if ( _iloop in _lstVehiclesPersistent ) then {
			_iPersistNow = 1;
		};

		// make the call to the save routine
		[ _x , _iPersistNow ] execVM DZMSSaveVeh;

		// increment _iloop
		_iloop = _iloop + 1;

	} forEach _vehHandles;

    	// Let everyone know the mission is over
    	[ nil , nil , rTitleText , _strMissionSuccess , "PLAIN" , 6 ] call RE;
    	diag_log text format [ "[DZMS]: %1 %2 mission ended." , _strMissionID , _strMissionName ];

     	// an ambush!
     	diag_log text format[ "[DZMS]: %1 %2 ambush extension has begun." , _strMissionID , _strMissionName ];

     	// now make the call to set up the ambush
     	[ _coords , 175 , 4 , 2 , 3 , 3 , 1 , 3 , DZMSMissionMajor ] call DZMSSetupAmbush; 

     	// now post a message
     	[ nil , nil , rTitleText , _strMissionExtensionHail , "PLAIN" , 6 ] call RE;

     	// modify the marker
	DZMSfMajMarkerSize = 300;
     	DZMSstrMajMarkerColor = "ColorRed";
     	DZMSstrMajMarkerBrush = "Solid";

     	// now wait for the ambush end conditions
     	[ _coords ] call DZMSWaitAmbushEscape;

     	// if we get to here, the ambush is over
     	[ nil , nil , rTitleText , _strMissionSuccess2 , "PLAIN" , 6 ] call RE;

     	// nuke the AI
     	call DZMSPurgeAllMajorAI;

	// nuke the individual vehicles
	{
		_x call DZMSPurgeObject;
	} forEach _vehHandles;

	// nuke the individual mission boxes
	{
	    _x call DZMSPurgeObject;
	} forEach _boxHandles;

	// nuke the individual scenery objects
	{
	    _x call DZMSPurgeObject;
	} forEach _objHandles;

     	// nuke the loose backpacks
     	[ _coords ] call DZMSDelBackpacks; 

	// and the ambush is over
     	diag_log text format[ "[DZMS]: %1 %2 ambush extension ended." , _strMissionID , _strMissionName ];

};


// nuke the markers
deleteMarker "DZMSMajMarker";
deleteMarker "DZMSMajDot";

// Let the timer know the mission is over
DZMSMajDone = true;