
// when we come into this script, the mission timeout timer is already running

private [ "_strMissionName" , "_strMissionHail" , "_strMissionSuccess" , "_strMissionID" , 
 	"_lstBoxesLocal" , "_lstBoxesSetups" , "_lstVehiclesLocal" , "_lstVehiclesPersistent" , "_lstVehiclesLocked" , "_lstObjectsLocal" , "_lstSpawnsLocal" ,
	"_coords" , "_iloop" , "_strVehicleTypeOrCat" , "_strVehicleType" , "_fx" , "_fy" , "_fz" , "_frot" , "_fFuelNow" , "_iPersistNow" , "_vehHandles" ,
	"_strBoxType" , "_nowBox" , "_strBoxFill" , "_strObjectType" , "_nowObject" , "_boxHandles" , "_objHandles" , "_iHowManyInSquad" , "_iSkill" , "_bIsAmbush" , 
	"_strVehicleType1" , "_strVehicleType2" , "_strVehicleType3" , "_nowVehicle1" , "_nowVehicle2" , "_nowVehicle3" ,
	"_frndAngle" , "_frndcos" , "_frndsin" , "_frndcos2" , "_frndsin2" ];


// mission name and messages

_strMissionName = "Hijacked Ballistic Missile!";
_strMissionHail = "A large and skilled force is waiting for a warlord to take delivery of a stolen MAZ!\nRecover it! Keep it out of bandit hands!";
_strMissionSuccess = "Survivors have recovered the stolen MAZ MRBM launcher!";
_strMissionID = "Major SM12";

// mission boxes

//_specBox01 = [ "RUBasicAmmunitionBox", -6.4377 , -0.2900, 0.1, 30.424841 ];

_lstBoxesLocal = [ ];

_lstBoxesSetups = [ ];

// mission vehicles ( type ID or category, x, y, z, rot ( >360 = random ), fuel ( <0 = random ) )

_specVeh01 = [ "MAZ_543_SCUD_TK_EP1" ,   0 , 0 , 0 , 999 , -1 ] ;
_specVeh02 = [ "Large"               , -30 , 0 , 0 , 999 , -1 ];
_specVeh03 = [ "ArmedSurface1"       ,  30 , 0 , 0 , 999 , -1 ];

_lstVehiclesLocal = [ _specVeh01 , _specVeh02  , _specVeh03 ];

_lstVehiclesPersistent = [ 0 ];

_lstVehiclesLocked = [ 999 ];

// scenary / other objects

//_spcObj01 = [ "MAP_76n6_ClamShell_Lower", 25.4731 , 1.5234, 0, -287.25015 ];

_lstObjectsLocal = [ ];

// AI spawn specifications

_spcSpawnData01 = [  40 ,  10 , 0 , 3 , 3 ];
_spcSpawnData02 = [  40 ,   0 , 0 , 3 , 3 ];
_spcSpawnData03 = [  40 , -10 , 0 , 3 , 3 ];
_spcSpawnData04 = [ -40 ,  10 , 0 , 3 , 3 ];
_spcSpawnData05 = [ -40 ,   0 , 0 , 3 , 3 ];
_spcSpawnData06 = [ -40 , -10 , 0 , 3 , 3 ];
_spcSpawnData07 = [ -10 ,  40 , 0 , 3 , 3 ];
_spcSpawnData08 = [   0 ,  40 , 0 , 3 , 3 ];
_spcSpawnData09 = [  10 ,  40 , 0 , 3 , 3 ];
_spcSpawnData10 = [ -10 , -40 , 0 , 3 , 3 ];
_spcSpawnData11 = [   0 , -40 , 0 , 3 , 3 ];
_spcSpawnData12 = [  10 , -40 , 0 , 3 , 3 ];

_lstSpawnsLocal = [
	_spcSpawnData01 , _spcSpawnData02 , _spcSpawnData03 , _spcSpawnData04 , _spcSpawnData05 , _spcSpawnData06 , 
	_spcSpawnData07 , _spcSpawnData08 , _spcSpawnData09 , _spcSpawnData10 , _spcSpawnData11 , _spcSpawnData12
];

// mission marker parameters

DZMSfMajMarkerSize = 700;
DZMSstrMajMarkerColor = "ColorRed";
DZMSstrMajMarkerBrush = "Solid";
DZMSstrMajMarkerShape = "ELLIPSE";



// start standard common mission code

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result

_coords = call DZMSFindPos;

[ nil , nil , rTitleText , _strMissionHail , "PLAIN" , 10 ] call RE;

// DZMSAddMajMarker is a simple script that adds a marker to the location

[ _coords , _strMissionName ] ExecVM DZMSAddMajMarker;


// initialize the now counter for vehicle setup and empty the array just in case

_iloop = 0;
_vehHandles = [];

// traverse the vehicles to be set up
{
	// get the vehicle class ID or category
	_strVehicleTypeOrCat	= _x select 0;

	// see if it's a CATEGORY as opposed to a TYPE ....
	if ( 	_strVehicleTypeOrCat in DZMSVehicleCategories ) then {
		_strVehicleType = [ _strVehicleTypeOrCat ] call DZMSGetVeh;
	} else {
		_strVehicleType = _strVehicleTypeOrCat;
	};

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// get the fuel
	_fFuelNow = _x select 5;

	// create the vehicle and stash the handle
	_nowVehicle = createVehicle [ _strVehicleType, [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set up the persistence flat
	_iPersistNow = 0;

	// set up the persistance flag
	if ( _iloop in _lstVehiclesPersistent ) then {
		_iPersistNow = 1;
	};

	// set up the fuel value
	if ( _fFuelNow > 1 ) then {
		_fFuelNow = 1;
	};

	// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel
	if ( _fFuelNow < 0 ) then {
		[ _nowVehicle , _iPersistNow ] call DZMSSetupVehicle;
	} else {
		[ _nowVehicle , _iPersistNow , _fFuelNow ] call DZMSSetupVehicle;
	};

	// set the rotation
	_nowVehicle setDir _frot;

	// set up the lock state
	if ( _iloop in _lstVehiclesLocked ) then {
		_nowVehicle setVehicleLock "LOCKED";
	};

	// stash the handle in the array
	_vehHandles set [ _iloop , _nowVehicle ];

	// finally, increment the index
	_iloop = _iloop + 1;

} forEach _lstVehiclesLocal;

// end vehicle setup


// initialize the now counter for crate setup and empty the handle array just in case
_iloop = 0;
_boxHandles = [];

// traverse the crates to be set up
{
	// get the box type, which is never random
	_strBoxType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the mission box
	_nowBox = createVehicle [ _strBoxType  , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowBox setDir _frot;

	// select the mission box fill style
	_strBoxFill = _lstBoxesSetups select _iloop;

	// fill the box
	[ _nowBox , _strBoxFill ] ExecVM DZMSBoxSetup;

	// protect the box from the antihack system
	[ _nowBox ] call DZMSProtectObj;

	// stash the handle in an array
	_boxHandles set [ _iloop , _nowBox ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstBoxesLocal;

//  end box/crate setup


// initialize the now counter for scenery setup
_iloop = 0;
_objHandles = [];

// traverse the scenery objects to be set up
{
	// get the object type, which is never random
	_strObjectType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the scenery object
	_nowObject = createVehicle [ _strObjectType , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowObject setDir _frot;

	// protect the box from the antihack system
	[ _nowObject ] call DZMSProtectObj;

	// stash the handle in an array
	_objHandles set [ _iloop , _nowObject ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstObjectsLocal;

//  end scenery object setup


// initialize the now counter for AI spawn setup
_iloop = 0;

// traverse the AI spawn specs
{
	// get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 0 );
	_fy = ( _coords select 1 ) + ( _x select 1 );
	_fz = _x select 2;

	// how many in this squad
	_iHowManyInSquad = _x select 3;

	// and what's their skill level?
	_iSkill = _x select 4;

	// do the spawn
	[ [ _fx , _fy , _fz ] , _iHowManyInSquad , _iSkill , 2 , _iloop ] call DZMSAISpawn;

	// increment the counter
	_iloop = _iloop + 1;

	// a short delay
	sleep 5;

} forEach _lstSpawnsLocal;

// done with AI spawns


// now set up ground vehicle fire support!

// find a direction
_frndAngle = random 360.0;

// find a displacement along that dir vector 80 meters out
_frndcos = ( sin _frndAngle ) * 70;
_frndsin = ( cos _frndAngle ) * 70;

_frndcos2 =  _frndcos * 1.5;
_frndsin2 =  _frndsin * 1.5;

//               spawn coords                                                   mission   iv   mission group type   AI group index               wp rad  orb rad , skill min max
_nowVehicle1 = [ [ ( ( _coords select 0 ) + _frndcos ) , ( ( _coords select 1 ) + _frndsin ) , 0 ] , [ ( ( _coords select 0 ) + _frndcos2 ) , ( ( _coords select 1 ) + _frndsin2 ) , 0 ] , 
	1 , DZMSMissionMajor , ( count DZMSGroupsInVehiclesMajor ) , 5 , 20 , 3 , 3 ] call DZMSSpawnSurface;
_nowVehicle2 = [ [ ( ( _coords select 0 ) - _frndcos ) , ( ( _coords select 1 ) - _frndsin ) , 0 ] , [ ( ( _coords select 0 ) - _frndcos2 ) , ( ( _coords select 1 ) - _frndsin2 ) , 0 ] , 
	2 , DZMSMissionMajor , ( count DZMSGroupsInVehiclesMajor ) , 5 , 20 , 3 , 3 ] call DZMSSpawnSurface;
_nowVehicle3 = [ [ ( ( _coords select 0 ) + _frndsin ) , ( ( _coords select 1 ) - _frndcos ) , 0 ] , [ ( ( _coords select 0 ) + _frndsin2 ) , ( ( _coords select 1 ) - _frndcos2 ) , 0 ] , 
	1 , DZMSMissionMajor , ( count DZMSGroupsInVehiclesMajor ) , 5 , 20 , 3 , 3 ] call DZMSSpawnSurface;

// the functions have already added the AI crew to the mission AI lists ... but we need to add the vehicle handle to the vehicle list

_vehHandles set [ ( count _vehHandles ) , _nowVehicle1 ];
_vehHandles set [ ( count _vehHandles ) , _nowVehicle2 ];
_vehHandles set [ ( count _vehHandles ) , _nowVehicle3 ];



// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMajorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMajorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMajorTimeoutEXPIRED ) then {

   	// we timed out -- stop the acceptance test
    	DZMSMajorAcceptanceTestRunning = false;

    	// at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    	sleep 30;

    	// so now timer, acceptance, and mission complete tests are all shut down....

    	// nuke all the AI
    	call DZMSPurgeAllMajorAI;

	// nuke the individual vehicles
	{
	    _x call DZMSPurgeObject;
	} forEach _vehHandles;

	// nuke the individual mission boxes
	{
	    _x call DZMSPurgeObject;
	} forEach _boxHandles;

	// nuke the individual scenery objects
	{
	    _x call DZMSPurgeObject;
	} forEach _objHandles;

	// nuke the loose backpacks -- does nothing if there aren't any
	[ _coords ] call DZMSDelBackpacks; 

	// Let everyone know the mission is over
	[ nil , nil , rTitleText , format [ "%1 mission has timed out." , _strMissionName ] , "PLAIN" , 6 ] call RE;
	diag_log text format [ "[DZMS]: %1 %2 mission has timed out." , _strMissionID , _strMissionName ];

} else {

    	// acceptance test has already shut down timer. completion test is shut down too....

    	// here is where we would set persistence to any loot vehicles

    	// Call DZMSSaveVeh to attempt to save the vehicles to the database
	// re-init iloop
	_iloop = 0;
	{
		// set up the persistance flag
		_iPersistNow = 0;

		// check to see if this index is in the list
		if ( _iloop in _lstVehiclesPersistent ) then {
			_iPersistNow = 1;
		};

		// make the call to the save routine
		[ _x , _iPersistNow ] execVM DZMSSaveVeh;

		// increment _iloop
		_iloop = _iloop + 1;

	} forEach _vehHandles;

    	// clean up the AI groups
   	call DZMSPurgeMajorGroups;

    	// Let everyone know the mission is over
    	[ nil , nil , rTitleText , _strMissionSuccess , "PLAIN" , 6 ] call RE;
    	diag_log text format [ "[DZMS]: %1 %2 mission ended." , _strMissionID , _strMissionName ];
};


// nuke the markers
deleteMarker "DZMSMajMarker";
deleteMarker "DZMSMajDot";

// Let the timer know the mission is over
DZMSMajDone = true;