
// when we come into this script, the mission timeout timer is already running

private [ "_missName" , "_coords" , "_veh1" , "_veh2" , "_vehicle1" , "_vehicle2" , "_crate1" , "_crate2" , "_crate3" , "_iWhichCrate" ];

// Name of the Mission
_missName = "Bandit Ordinance Handoff";

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[ nil , nil , rTitleText , "Bandits are holding very high value materiel for a pickup!\nIntercept it! Sieze it before the intended recipients show up!" , "PLAIN" , 10 ] call RE;

// DZMSAddMajMarker is a simple script that adds a marker to the location
DZMSfMajMarkerSize = 275;
DZMSstrMajMarkerColor = "ColorRed";
DZMSstrMajMarkerBrush = "Solid";
DZMSstrMajMarkerShape = "ELLIPSE";
[ _coords , _missname ] ExecVM DZMSAddMajMarker;

// We create the vehicles

_veh1 = [ "small" ] call DZMSGetVeh;
_veh2 = [ "small" ] call DZMSGetVeh;

_vehicle1 = createVehicle [ _veh1 , [ ( _coords select 0 ) - 12.0 , ( _coords select 1 ) + 11.0 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
_vehicle2 = createVehicle [ _veh2 , [ ( _coords select 0 ) + 11.3 , ( _coords select 1 ) - 9.8 , 0 ] , [] , 0 , "CAN_COLLIDE" ];

// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel and such
[ _vehicle1 , 0 ] call DZMSSetupVehicle;
[ _vehicle2 , 0 ] call DZMSSetupVehicle;

_crate1 = createVehicle [ "USSpecialWeaponsBox" , [ ( _coords select 0 ) + 4 , ( _coords select 1 ) + 5 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
_crate2 = createVehicle [ "USSpecialWeaponsBox" , [ ( _coords select 0 ) - 3 , ( _coords select 1 ) - 6 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
_crate3 = createVehicle [ "USLaunchersBox" , [ ( _coords select 0 ) + 1 , ( _coords select 1 ) -0.5 , 0 ] , [] , 0 , "CAN_COLLIDE" ];

// DZMSBoxFill fills the box, DZMSProtectObj prevents it from disappearing
[ _crate1 , "specopsweapons" ] ExecVM DZMSBoxSetup;
[ _crate2 , "specopsammo" ] ExecVM DZMSBoxSetup;


// figure out which sniper weaps are going to appear
_iWhichCrate = floor random 3.0;

if ( _iWhichCrate == 0 ) then {
    [ _crate3 , "civviesniper" ] ExecVM DZMSBoxSetup;
};

if ( _iWhichCrate == 1 ) then {
    [ _crate3 , "ruskieantimateriel" ] ExecVM DZMSBoxSetup;
};

if ( _iWhichCrate == 2 ) then {
    [ _crate3 , "usantimateriel" ] ExecVM DZMSBoxSetup;
};

// protect all three crates
[ _crate1 ] call DZMSProtectObj;
[ _crate2 ] call DZMSProtectObj;
[ _crate3 ] call DZMSProtectObj;


// DZMSAISpawn spawns AI to the mission.

[ [ ( _coords select 0 ) + 9 , ( _coords select 1 ) + 7 , 0 ] , 7 , 1 , 2 , 0 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) + 9 , ( _coords select 1 ) + 7 , 0 ] , 5 , 3 , 2 , 1 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) - 9 , ( _coords select 1 ) - 7 , 0 ] , 5 , 3 , 2 , 2 ] call DZMSAISpawn;
sleep 5;

[ [ ( _coords select 0 ) - 9 , ( _coords select 1 ) - 7 , 0 ] , 5 , 3 , 2 , 3 ] call DZMSAISpawn;
sleep 5;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMajorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMajorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMajorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMajorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMajorAI;

    // nuke the individual objects and scenery

    _crate1 call DZMSPurgeObject;
    _crate2 call DZMSPurgeObject;
    _crate3 call DZMSPurgeObject;

    _vehicle1 call DZMSPurgeObject;
    _vehicle2 call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Bandit Ordinance Handoff mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Major SM8 Bandit Ordinance Handoff mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database
    [ _vehicle1 ] ExecVM DZMSSaveVeh;
    [ _vehicle2 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMajorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have the bandit equipment!" , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Major SM8 Bandit Ordinance Handoff mission ended." ];
};


// nuke the markers
deleteMarker "DZMSMajMarker";
deleteMarker "DZMSMajDot";

// Let the timer know the mission is over
DZMSMajDone = true;