/*
	Bandit Hunting Party by lazyink (Full credit to TheSzerdi & TAW_Tonic for the code)
	Updated to new format by Vampire
*/

// when we come into this script, the minor mission timeout timer is already running

private [ "_missName" , "_coords" ];

//Name of the Mission
_missName = "Bandit Patrol";

//DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[nil,nil,rTitleText,"A bandit foot patrol has been spotted!\nIntercept them!", "PLAIN",10] call RE;

//DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 150;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Grid";
DZMSstrMinMarkerShape = "ELLIPSE";
[_coords,_missName] ExecVM DZMSAddMinMarker;

//DZMSAISpawn spawns AI to the mission.
//Usage: [_coords, count, skillLevel, unitArray]
[_coords,2,1, 1 , 0 ] call DZMSAISpawn;
sleep 5;
[_coords,2,1, 1 , 1 ] call DZMSAISpawn;
sleep 5;
[_coords,2,1, 1 , 2 ] call DZMSAISpawn;
sleep 5;
[_coords,2,2, 1 , 3 ] call DZMSAISpawn;
sleep 1;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

//    _net call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Bandit Patrol mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM1 Bandit Patrol mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
//    [ _vehicle1 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have wiped out the bandit patrol!" ,  "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM1 Bandit Patrol mission has ended." ];
};

// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

//Let the timer know the mission is over
DZMSMinDone = true;