
// when we come into this script, the mission timeout timer is already running

private [ "_strMissionName" , "_strMissionHail" , "_strMissionSuccess" , "_strMissionID" , 
 	"_lstBoxesLocal" , "_lstBoxesSetups" , "_lstVehiclesLocal" , "_lstVehiclesPersistent" , "_lstVehiclesLocked" , "_lstObjectsLocal" , "_lstSpawnsLocal" ,
	"_coords" , "_iloop" , "_strVehicleTypeOrCat" , "_strVehicleType" , "_fx" , "_fy" , "_fz" , "_frot" , "_fFuelNow" , "_nowVehicle" , "_iPersistNow" , "_vehHandles" ,
	"_strBoxType" , "_nowBox" , "_strBoxFill" , "_strObjectType" , "_nowObject" , "_boxHandles" , "_objHandles" , "_iHowManyInSquad" , "_iSkill" , "_bIsAmbush" ];


// mission name and messages

_strMissionName = "Bandit Listening Post";
_strMissionHail = "Survivor intel reports bandits have set up a listening post.\nInvestigate the site, kill any guards, and take anything you can carry!";
_strMissionSuccess = "Survivors have taken the bandit listening post!";
_strMissionID = "Minor SM10";


// mission boxes

_specBox01 = [ "MAP_USBasicWeapons", 9.8645062, 0.3486, 0, 71.945122 ];
_specBox02 = [ "MAP_SpecialWeapons", 10.7191858, 5.7725, 0, 54.34042 ];
_specBox03 = [ "MAP_RULaunchers", 10.5375452, 3.1523, 0, -8.3990517 ];

_lstBoxesLocal = [ _specBox01 , _specBox02 , _specBox03 ];

_lstBoxesSetups = [ "weapons" , "supplyprefab" , "specopsammo" ];

// mission vehicles ( type ID or category, x, y, z, rot ( >360 = random ), fuel ( <0 = random ) )

_specVeh01 = [ "Large", -21.481009, 26.873, 0, 999, -1 ];
_specVeh02 = [ "Small", 21.10121, -17.9092, 0, 999, -1 ];
_specVeh03 = [ "Small", -11.101014, 2.6055, 0, 999, -1 ];

_lstVehiclesLocal = [ _specVeh01 , _specVeh02  , _specVeh03 ];

_lstVehiclesPersistent = [ 0 ];

_lstVehiclesLocked = [ 999 ];

// scenary / other objects

_spcObj01 = [ "SHouse", 0.05, 4.0, 0, 0 ];
_spcObj02 = [ "MAP_Ind_IlluminantTower", -11.312371, -10.0283, 0, 0 ];
_spcObj03 = [ "MAP_Ind_IlluminantTower",  13.959524,  18.0313, 0, 0 ];
_spcObj04 = [ "MAP_PowGen_Big", 0.43145084, -9.4346, 0, 113.90587 ];
_spcObj05 = [ "MAP_BigHBarrier", 0.14694834, -18.0049, 0, 0 ];
_spcObj06 = [ "MAP_BigHBarrier", -0.25773418, 22.0225, 0, 0 ];
_spcObj07 = [ "MAP_BigHBarrier", 20.645239, 4.2949, 0, -83.563278 ];
_spcObj08 = [ "MAP_BigHBarrier", -19.755869, 3.748, 0, -90.554413 ];
_spcObj09 = [ "MAP_BigHBarrier", -16.020353, -13.0664, 0, 46.216911 ];
_spcObj10 = [ "MAP_BigHBarrier", 15.149971, -12.1074, 0, -45.732407 ];
_spcObj11 = [ "MAP_BigHBarrier", 17.477474, 23.1758, 0, 43.658947 ];
_spcObj12 = [ "MAP_BigHBarrier", -13.468074, 16.2139, 0, -45.207554 ];

_lstObjectsLocal = [
	_spcObj01 , _spcObj02 , _spcObj03 , _spcObj04 , _spcObj05 , _spcObj06 , 
	_spcObj07 , _spcObj08 , _spcObj09 , _spcObj10 , _spcObj11 , _spcObj12
];

// AI spawn specifications

_spcSpawnData01 = [  30,   5, 0, 3, 2 ];
_spcSpawnData02 = [  30,  -5, 0, 3, 3 ];
_spcSpawnData03 = [ -30,   5, 0, 3, 2 ];
_spcSpawnData04 = [ -30,  -5, 0, 3, 3 ];
_spcSpawnData05 = [   5,  30, 0, 3, 2 ];
_spcSpawnData06 = [  -5,  30, 0, 3, 3 ];
_spcSpawnData07 = [   5, -30, 0, 3, 2 ];
_spcSpawnData08 = [  -5, -30, 0, 3, 3 ];

_lstSpawnsLocal = [ _spcSpawnData01 , _spcSpawnData02 , _spcSpawnData03 , _spcSpawnData04 ,
			    _spcSpawnData05 , _spcSpawnData06 , _spcSpawnData07 , _spcSpawnData08
];

// mission marker parameters

DZMSfMinMarkerSize = 400;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Grid";
DZMSstrMinMarkerShape = "ELLIPSE";



// start standard common mission code

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result

_coords = call DZMSFindPos;

[ nil , nil , rTitleText , _strMissionHail , "PLAIN" , 10 ] call RE;

// DZMSAddMinMarker is a simple script that adds a marker to the location

[ _coords , _strMissionName ] ExecVM DZMSAddMinMarker;


// initialize the now counter for vehicle setup and empty the array just in case

_iloop = 0;
_vehHandles = [];

// traverse the vehicles to be set up
{
	// get the vehicle class ID or category
	_strVehicleTypeOrCat	= _x select 0;

	// see if it's a CATEGORY as opposed to a TYPE ....
	if ( 	_strVehicleTypeOrCat in DZMSVehicleCategories ) then {
		_strVehicleType = [ _strVehicleTypeOrCat ] call DZMSGetVeh;
	} else {
		_strVehicleType = _strVehicleTypeOrCat;
	};

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// get the fuel
	_fFuelNow = _x select 5;

	// create the vehicle and stash the handle
	_nowVehicle = createVehicle [ _strVehicleType, [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set up the persistence flat
	_iPersistNow = 0;

	// set up the persistance flag
	if ( _iloop in _lstVehiclesPersistent ) then {
		_iPersistNow = 1;
	};

	// set up the fuel value
	if ( _fFuelNow > 1 ) then {
		_fFuelNow = 1;
	};

	// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel
	if ( _fFuelNow < 0 ) then {
		[ _nowVehicle , _iPersistNow ] call DZMSSetupVehicle;
	} else {
		[ _nowVehicle , _iPersistNow , _fFuelNow ] call DZMSSetupVehicle;
	};

	// set the rotation
	_nowVehicle setDir _frot;

	// set up the lock state
	if ( _iloop in _lstVehiclesLocked ) then {
		_nowVehicle setVehicleLock "LOCKED";
	};

	// stash the handle in the array
	_vehHandles set [ _iloop , _nowVehicle ];

	// finally, increment the index
	_iloop = _iloop + 1;

} forEach _lstVehiclesLocal;

// end vehicle setup


// initialize the now counter for crate setup and empty the handle array just in case
_iloop = 0;
_boxHandles = [];

// traverse the crates to be set up
{
	// get the box type, which is never random
	_strBoxType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the mission box
	_nowBox = createVehicle [ _strBoxType  , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowBox setDir _frot;

	// select the mission box fill style
	_strBoxFill = _lstBoxesSetups select _iloop;

	// fill the box
	[ _nowBox , _strBoxFill ] ExecVM DZMSBoxSetup;

	// protect the box from the antihack system
	[ _nowBox ] call DZMSProtectObj;

	// stash the handle in an array
	_boxHandles set [ _iloop , _nowBox ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstBoxesLocal;

//  end box/crate setup


// initialize the now counter for scenery setup
_iloop = 0;
_objHandles = [];

// traverse the scenery objects to be set up
{
	// get the object type, which is never random
	_strObjectType = _x select 0;

	// now get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 1 );
	_fy = ( _coords select 1 ) + ( _x select 2 );
	_fz = _x select 3;
	_frot = _x select 4;

	// if the rotation is large enough, it means we should randomize it
	if ( _frot > 360 ) then {
		_frot = random 360;
	};

	// now create the scenery object
	_nowObject = createVehicle [ _strObjectType , [ _fx , _fy , _fz ] , [] , 0 , "CAN_COLLIDE" ];

	// set the box rotation
	_nowObject setDir _frot;

	// protect the box from the antihack system
	[ _nowObject ] call DZMSProtectObj;

	// stash the handle in an array
	_objHandles set [ _iloop , _nowObject ];

	// finally, increment the counter
	_iloop = _iloop + 1;

} forEach _lstObjectsLocal;

//  end scenery object setup


// initialize the now counter for AI spawn setup
_iloop = 0;

// traverse the AI spawn specs
{
	// get the coordinates
	_fx = ( _coords select 0 ) + ( _x select 0 );
	_fy = ( _coords select 1 ) + ( _x select 1 );
	_fz = _x select 2;

	// how many in this squad
	_iHowManyInSquad = _x select 3;

	// and what's their skill level?
	_iSkill = _x select 4;

	// do the spawn
	[ [ _fx , _fy , _fz ] , _iHowManyInSquad , _iSkill , 1 , _iloop ] call DZMSAISpawn;

	// increment the counter
	_iloop = _iloop + 1;

	// a short delay
	sleep 5;

} forEach _lstSpawnsLocal;

// done with AI spawns


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

   	// we timed out -- stop the acceptance test
    	DZMSMinorAcceptanceTestRunning = false;

    	// at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    	sleep 30;

    	// so now timer, acceptance, and mission complete tests are all shut down....

    	// nuke all the AI
    	call DZMSPurgeAllMinorAI;

	// nuke the individual vehicles
	{
		_x call DZMSPurgeObject;
	} forEach _vehHandles;

	// nuke the individual mission boxes
	{
	    _x call DZMSPurgeObject;
	} forEach _boxHandles;

	// nuke the individual scenery objects
	{
	    _x call DZMSPurgeObject;
	} forEach _objHandles;

	// nuke the loose backpacks -- does nothing if there aren't any
	[ _coords ] call DZMSDelBackpacks; 

	// Let everyone know the mission is over
	[ nil , nil , rTitleText , format [ "%1 mission has timed out." , _strMissionName ] , "PLAIN" , 6 ] call RE;
	diag_log text format [ "[DZMS]: %1 %2 mission has timed out." , _strMissionID , _strMissionName ];

} else {

    	// acceptance test has already shut down timer. completion test is shut down too....

    	// here is where we would set persistence to any loot vehicles

   	// Call DZMSSaveVeh to attempt to save the vehicles to the database
	// re-init iloop
	_iloop = 0;
	{
		// set up the persistance flag
		_iPersistNow = 0;

		// check to see if this index is in the list
		if ( _iloop in _lstVehiclesPersistent ) then {
			_iPersistNow = 1;
		};

		// make the call to the save routine
		[ _x , _iPersistNow ] execVM DZMSSaveVeh;

		// increment _iloop
		_iloop = _iloop + 1;

	} forEach _vehHandles;

    	// Let everyone know the mission is over
    	[ nil , nil , rTitleText , _strMissionSuccess , "PLAIN" , 6 ] call RE;
    	diag_log text format [ "[DZMS]: %1 %2 mission ended." , _strMissionID , _strMissionName ];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

// Let the timer know the mission is over
DZMSMinDone = true;