/*
	Hummer Wreck by lazyink (Full credit for code to TheSzerdi & TAW_Tonic)
	Updated to new format by Vampire
*/

// when we come into this script, the minor mission timeout timer is already running


private ["_missName","_coords","_crash","_crate"];

//Name of the Mission
_missName = "Humvee Missing";

//DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[nil,nil,rTitleText,"A survivor vehicle patrol is missing!\nInvestigate the last known position!", "PLAIN",10] call RE;

//DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 150;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Grid";
DZMSstrMinMarkerShape = "ELLIPSE";
[_coords,_missName] ExecVM DZMSAddMinMarker;

//Add the scenery
_crash = createVehicle ["HMMWVwreck",_coords,[], 0, "CAN_COLLIDE"];

//DZMSProtectObj prevents it from disappearing
[_crash] call DZMSProtectObj;

//Add and fill the crate
_crate = createVehicle ["RULaunchersBox",[(_coords select 0) - 14, _coords select 1,0],[], 0, "CAN_COLLIDE"];
[_crate,"weapons"] ExecVM DZMSBoxSetup;
[_crate] call DZMSProtectObj;

//DZMSAISpawn spawns AI to the mission.

[_coords,3,1, 1 , 0 ] call DZMSAISpawn;
sleep 1;
[_coords,3,2, 1 , 1 ] call DZMSAISpawn;
sleep 1;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

    _crash call DZMSPurgeObject;

    _crate call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Humvee Missing mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM5 Humvee Missing mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
//    [ _vehicle1 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have wiped out the bandits who took the survivor patrol!" , "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM5 Humvee Crash mission has ended." ];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

//Let the timer know the mission is over
DZMSMinDone = true;