/*
	Weapon Truck Crash by lazyink (Full credit for code to TheSzerdi & TAW_Tonic)
	Updated to new format by Vampire
*/


// when we come into this script, the minor mission timeout timer is already running

private ["_missName","_coords","_crash","_crate1","_crate2","_crate3"];

//Name of the Mission
_missName = "Weapons Truck Overdue";

//DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[nil,nil,rTitleText,"A survivor weapons transport is missing!\nInvestigate its last known position!", "PLAIN",10] call RE;

//DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 150;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Grid";
DZMSstrMinMarkerShape = "ELLIPSE";
[_coords,_missName] ExecVM DZMSAddMinMarker;

//Add scenery
_crash = createVehicle ["UralWreck",_coords,[], 0, "CAN_COLLIDE"];

//DZMSProtectObj prevents it from disappearing
[_crash] call DZMSProtectObj;

//Add and fill the boxes
_crate1 = createVehicle ["USLaunchersBox",[(_coords select 0) + 3, _coords select 1,0],[], 0, "CAN_COLLIDE"];
[_crate1,"weapons"] ExecVM DZMSBoxSetup;
[_crate1] call DZMSProtectObj;

_crate2 = createVehicle ["USLaunchersBox",[(_coords select 0) - 3, _coords select 1,0],[], 0, "CAN_COLLIDE"];
[_crate2,"weapons"] ExecVM DZMSBoxSetup;
[_crate2] call DZMSProtectObj;

_crate3 = createVehicle ["RULaunchersBox",[(_coords select 0) - 6, _coords select 1,0],[], 0, "CAN_COLLIDE"];
[_crate3,"weapons"] ExecVM DZMSBoxSetup;
[_crate3] call DZMSProtectObj;

//DZMSAISpawn spawns AI to the mission.

[_coords,3,0, 1 , 0 ] call DZMSAISpawn;
sleep 1;
[_coords,3,1, 1 , 1 ] call DZMSAISpawn;
sleep 1;
[_coords,3,1, 1 , 2 ] call DZMSAISpawn;
sleep 1;
[_coords,3,2, 1 , 3 ] call DZMSAISpawn;
sleep 1;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

    _crash call DZMSPurgeObject;

    _crate1 call DZMSPurgeObject;
    _crate2 call DZMSPurgeObject;
    _crate3 call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Weapons Truck Overdue mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM6 Weapons Truck Overdue mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
//    [ _vehicle1 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have secured the missing weapons truck!" , "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM6 Weapons Truck Overdue mission has ended." ];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

//Let the timer know the mission is over
DZMSMinDone = true;