// when we come into this script, the minor mission timeout timer is already running

private [ "_missName" , "_coords" , "_crash1" , "_crash2" , "_crash3" , "_crate1" , "_crate2" , "_rndNumber" , "_strMarkerString" ];

// Name of the Mission
_missName = "Unknown Bandit Transport";

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[ nil , nil , rTitleText , "Bandits fighting among themselves have disabled some sort of high value shipment!\nFind out what's so important to the bad guys!" , "PLAIN" , 10 ] call RE;

// DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 300;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Solid";
DZMSstrMinMarkerShape = "ELLIPSE";
[ _coords , _missName ] ExecVM DZMSAddMinMarker;

// Add scenery
_crash1 = createVehicle [ "UralWreck" , _coords , [] , 0 , "CAN_COLLIDE" ];
[ _crash1 ] call DZMSProtectObj;

_crash2 = createVehicle [ "HMMWVwreck" , [ ( _coords select 0 ) + 2 , ( _coords select 1 ) - 17 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
[ _crash2 ] call DZMSProtectObj;

_crash3 = createVehicle [ "UAZWreck" , [ ( _coords select 0 ) - 2 , ( _coords select 1 ) + 14 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
[ _crash3 ] call DZMSProtectObj;
 

// Add and fill the boxes
_crate1 = createVehicle [ "USBasicWeaponsBox" , [ ( _coords select 0 ) + 4 , ( _coords select 1 ) + 1 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
[ _crate1 , "weapons" ] ExecVM DZMSBoxSetup;
[ _crate1 ] call DZMSProtectObj;

_crate2 = createVehicle [ "USBasicWeaponsBox" , [ ( _coords select 0 ) - 7 , ( _coords select 1 ) - 2 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
[ _crate2 , "money" ] ExecVM DZMSBoxSetup;
[ _crate2 ] call DZMSProtectObj;

// DZMSAISpawn spawns AI to the mission.
// Usage: [ _coords , count , skillLevel , unitArray ]

[ _coords , 5 , 0 , 1 , 0 ] call DZMSAISpawn;
sleep 1;

[ _coords , 3 , 1 , 1 , 1 ] call DZMSAISpawn;
sleep 1;

[ _coords , 2 , 2 , 1 , 2 ] call DZMSAISpawn;
sleep 1;

[ _coords , 3 , 1 , 1 , 3 ] call DZMSAISpawn;
sleep 1;






// this code is causing some errors

// now add some DZAI bandit air support!

// create a random number
_rndNumber = round( random 999999 );

// now create the marker name
_strMarkerString = format [ "MissionChopper%1" , _rndNumber ];

// create the marker itself

_this = createMarker [ _strMarkerString , [ ( _coords select 0 ) , ( _coords select 1 ) ] ];
_this setMarkerShape "ELLIPSE";
_this setMarkerType "Empty";
_this setMarkerBrush "Solid";
_this setMarkerSize [ 250 , 250 ];
_this setMarkerAlpha 0;

// stash the marker handle in the global array and increment the marker count
DZMSSupportVehicleMarkers set [ DZMSiHowManySuppVehMarkers , _this ];
DZMSiHowManySuppVehMarkers = DZMSiHowManySuppVehMarkers + 1;

// spawn the chopper using the marker
// DZAI spawn doesn't work from here. Why not??
//[ _strMarkerString , "UH1H_DZ" , [ 2 , 2 ] , 3 , false ] call DZAI_spawn_vehicle;

// end attempt to add vehicle AI to mission




// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

    _crash1 call DZMSPurgeObject;
    _crash2 call DZMSPurgeObject;
    _crash3 call DZMSPurgeObject;

    _crate1 call DZMSPurgeObject;
    _crate2 call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Unknown Bandit Transport mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM7 Unknown Bandit Transport mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
//    [ _vehicle1 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have secured the mystery bandit shipment!" , "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM7 Unknown Bandit Transport mission has ended." ];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

// Let the timer know the mission is over
DZMSMinDone = true;