
// when we come into this script, the minor mission timeout timer is already running

private [ "_missName" , "_coords" , "_vehicle" , "_crate1" , "_crate2" ];

// Name of the Mission
_missName = "Bandit Deli Delivery";

// DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[ nil , nil , rTitleText , "A bandit deli delivery has run out of gas. See what you can recover." , "PLAIN" , 10 ] call RE;

// DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 250;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Grid";
DZMSstrMinMarkerShape = "ELLIPSE";
[_coords,_missName] ExecVM DZMSAddMinMarker;

// We create the vehicle
_vehicle = createVehicle [ "Lada2_TK_CIV_EP1" , _coords , [] , 0 , "CAN_COLLIDE" ];
_vehicle setDir random 360;

// DZMSSetupVehicle prevents the vehicle from disappearing and sets fuel and such
[ _vehicle , 0 , 0 ] call DZMSSetupVehicle;

// We create and fill the crates
_crate1 = createVehicle [ "RUOrdnanceBox" , [ ( _coords select 0 ) + 1.7408 , ( _coords select 1 ) - 2.565 , 0.10033049 ] , [] , 0 , "CAN_COLLIDE" ];
_crate1 setDir random 360;
[_crate1,"deli"] ExecVM DZMSBoxSetup;
[_crate1] call DZMSProtectObj;

_crate2 = createVehicle [ "RUOrdnanceBox" , [ ( _coords select 0 ) - 1.2387 , ( _coords select 1 ) - 3.043 , 0.10033049 ] , [] , 0 , "CAN_COLLIDE" ];
_crate2 setDir random 360;
[_crate2,"weapons"] ExecVM DZMSBoxSetup;
[_crate2] call DZMSProtectObj;

// DZMSAISpawn spawns AI to the mission.

[ [ ( _coords select 0 ) - 1.0796 , ( _coords select 1 ) - 13.709 , 0 ] , 3 , 3 , 1 , 0 ] call DZMSAISpawn;
sleep 3;
[ [ ( _coords select 0 ) + 1.8872 , ( _coords select 1 ) + 13.964 , 0 ] , 3 , 3 , 1 , 1 ] call DZMSAISpawn;
sleep 3;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

    _vehicle call DZMSPurgeObject;

    _crate1 call DZMSPurgeObject;
    _crate2 call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Bandit Deli Delivery mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM8 Bandit Deli Delivery mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
    [ _vehicle ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have taken the bandit deli delivery!" , "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM8 Bandit Deli Delivery mission has ended."];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

//Let the timer know the mission is over
DZMSMinDone = true;