
// when we come into this script, the minor mission timeout timer is already running


private [ "_missName" , "_coords" , "_crash" , "_crate" ];

//Name of the Mission
_missName = "Demolition Supplies";

//DZMSFindPos loops BIS_fnc_findSafePos until it gets a valid result
_coords = call DZMSFindPos;

[ nil , nil , rTitleText , "A renegade spec ops vehicle carrying demolition supplies has been intercepted by bandits.\nInvestigate the last known position and keep the explosives out of bandit hands!" , "PLAIN" , 10 ] call RE;

// DZMSAddMinMarker is a simple script that adds a marker to the location
DZMSfMinMarkerSize = 270;
DZMSstrMinMarkerColor = "ColorRed";
DZMSstrMinMarkerBrush = "Solid";
DZMSstrMinMarkerShape = "ELLIPSE";
[ _coords , _missName ] ExecVM DZMSAddMinMarker;

// Add the scenery
_crash = createVehicle [ "BMP2Wreck" , _coords , [] ,  0 , "CAN_COLLIDE" ];
_crash setDir random 360;

// DZMSProtectObj prevents it from disappearing
[ _crash ] call DZMSProtectObj;

// Add and fill the crate
_crate = createVehicle [ "CZBasicWeapons_EP1" , [ ( _coords select 0 ) - 7 , ( _coords select 1 ) + 3.7 , 0.3 ] , [] , 0 , "CAN_COLLIDE" ];
_crate setDir random 360;
[ _crate , "demolition" ] ExecVM DZMSBoxSetup;
[ _crate ] call DZMSProtectObj;

// DZMSAISpawn spawns AI to the mission.

[ _coords , 5 , 1 , 1 , 0 ] call DZMSAISpawn;
sleep 3;
[ _coords , 5 , 2 , 1 , 1 ] call DZMSAISpawn;
sleep 3;
[ _coords , 5 , 3 , 1 , 2 ] call DZMSAISpawn;
sleep 3;
[ _coords , 5 , 2 , 1 , 3 ] call DZMSAISpawn;
sleep 3;
[ _coords , 5 , 3 , 1 , 4 ] call DZMSAISpawn;
sleep 3;


// this concludes mission setup

// start the mission timeout timer running
[] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMinorMissionAcceptedTest.sqf";


// Wait until the player is within 30 meters and also meets the kill req
[ _coords ] call DZMSWaitMinorMissionComp;


// if the mission was never accepted and the timeout has expired, nuke everything and move on
if ( DZMSMinorTimeoutEXPIRED ) then {

    // we timed out -- stop the acceptance test
    DZMSMinorAcceptanceTestRunning = false;

    // at this point the acceptance test might be in a WAIT state, and if we rush we could nuke the AI and then see a "death" triggering acceptance....
    sleep 30;

    // so now timer, acceptance, and mission complete tests are all shut down....

    // nuke all the AI
    call DZMSPurgeAllMinorAI;

    // nuke the individual objects and scenery ( if any )

    _crash call DZMSPurgeObject;

    _crate call DZMSPurgeObject;

    // nuke the loose backpacks
    [ _coords ] call DZMSDelBackpacks; 

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Demolition Supplies mission has timed out." , "PLAIN" , 6 ] call RE;
    diag_log text format [ "[DZMS]: Minor SM9 Demolition Supplies mission has timed out." ];

} else {

    // acceptance test has already shut down timer. completion test is shut down too....

    // here is where we would set persistence to any loot vehicles

    // Call DZMSSaveVeh to attempt to save the vehicles to the database ( if any )
//    [ _vehicle1 ] ExecVM DZMSSaveVeh;

    // clean up the AI groups
    call DZMSPurgeMinorGroups;

    // Let everyone know the mission is over
    [ nil , nil , rTitleText , "Survivors have secured the demolition supplies." , "PLAIN" , 6 ] call RE;
    diag_log text format[ "[DZMS]: Minor SM9 Demolition Supplies mission has ended." ];
};


// nuke the markers
deleteMarker "DZMSMinMarker";
deleteMarker "DZMSMinDot";

//Let the timer know the mission is over
DZMSMinDone = true;