/*
	Usage: [_crate,"type"] execVM "dir\DZMSBox.sqf";
		_crate is the crate to fill
		"type" is the type of crate
		"type" can be weapons or medical
*/

_crate = _this select 0;
_type = _this select 1;

// Clear the current cargo
clearWeaponCargoGlobal _crate;
clearMagazineCargoGlobal _crate;


//////////////////////////////////////////////////////////////////
// Medical Crates
//////////////////////////////////////////////////////////////////

if ( _type == "medical" ) then {

	// load medical
	_sCount  = count DZMSMedicalList;
	_iLoopCount = round( random 11 );
	_iLoopLimit = 7 + _iLoopCount;

	for "_x" from 0 to _iLoopCount do {

		_sSelect = floor( random _sCount  );
		_item = DZMSMedicalList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , ( round( random 2 ) ) ];
	};
};

///////////////////////////////////////////////////////////////////
// Weapon Crates
///////////////////////////////////////////////////////////////////

if ( _type == "weapons" ) then {

	// load grenades
	_sCount  = count DZMSshellList;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSshellList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , ( round( random 2 ) ) ];
	};
   
	// load packs
	_sCount  = count DZMSPacklist;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSPacklist select _sSelect;
		_crate addBackpackCargoGlobal [ _item , 1 ];
	};
	 
	// load pistols
	_sCount  = count DZMSpistolList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSpistolList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};

	// load sniper
	_sCount  = count DZMSsniperList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSsniperList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};

	// load smg
	_sCount  = count DZMSmgList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSmgList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};

	// load lmg
	_sCount  = count DZMSLmgList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSLmgList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};

	// load primary
	_sCount  = count DZMSprimaryList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSprimaryList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};
};

if ( _type == "snipergear" ) then {

	// load sniper
	_sCount  = count DZMSsniperList;
	_iLoopCount = round( random 1 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSsniperList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
		_ammo = [] + getArray ( configFile >> "cfgWeapons" >> _item >> "magazines" );

		if ( count _ammo > 0 ) then {

			_crate addMagazineCargoGlobal [ ( _ammo select 0 ) , ( round( random 2 ) ) ];
		};
	};
};

///////////////////////////////////////////////////////////////////
// Epoch Supply Crates
///////////////////////////////////////////////////////////////////

if ( _type == "supply" ) then {

	// load tools
	_sCount  = count DZMSConTools;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSConTools select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
	};
	
	// load construction
	_sCount  = count DZMSConSupply;
	_iLoopCount = round( random 17 );
	_iLoopLimit = 13 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {
		_sSelect = floor( random _sCount  );
		_item = DZMSConSupply select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "supplyprefab" ) then {

	// load tools
	_sCount  = count DZMSConTools;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 1 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSConTools select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
	};
	
	// load construction
	_sCount  = count DZMSPrefabBldgParts;
	_iLoopCount = round( random 7 );
	_iLoopLimit = 7 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {
		_sSelect = floor( random _sCount  );
		_item = DZMSPrefabBldgParts select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

///////////////////////////////////////////////////////////////////
// Epoch Money Crates
///////////////////////////////////////////////////////////////////

if ( _type == "money" ) then {

	// load money
	_sCount  = count DZMSMoneyList;
	_iLoopCount = round( random 4 );
	_iLoopLimit = 3 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSMoneyList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "smallmoney" ) then {

	// load money
	_sCount  = count DZMSMoneyList;
	_iLoopCount = round( random 5 );
	_iLoopLimit = 3 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSMoneyList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "barbecue" ) then {

	// load uncooked meat
	_sCount  = count DZMSBarbequeList;
	_iLoopCount = round( random 7 );
	_iLoopLimit = 3 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSBarbequeList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "picnic" ) then {

	// load picnic chow meat
	_sCount  = count DZMSPicnicList;
	_iLoopCount = round( random 7 );
	_iLoopLimit = 5 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSPicnicList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "recycle" ) then {

	// load trash
	_sCount  = count DZMSRecycleList;
	_iLoopCount = round( random 23 );
	_iLoopLimit = 9 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSRecycleList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "deli" ) then {

	// load deli meats
	_sCount  = count DZMSDeliList;
	_iLoopCount = round( random 8 );
	_iLoopLimit = 7 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSDeliList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "demolition" ) then {

	// load explosives list
	_sCount  = count DZMSDemolitionList;
	_iLoopCount = round( random 3 );
	_iLoopLimit = 2 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSDemolitionList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "specopsweapons" ) then {

	// load spec ops weps list
	_sCount  = count DZMSSpecOpsEquipList;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 2 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSSpecOpsEquipList select _sSelect;
		_crate addWeaponCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "heavyammo" ) then {

	// load heavy ammo list
	_sCount  = count DZMSHeavyAmmoList;
	_iLoopCount = round( random 3 );
	_iLoopLimit = 3 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSHeavyAmmoList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 1 ];
	};
};

if ( _type == "specopsammo" ) then {

	// load spec ops ammo list
	_sCount  = count DZMSSpecOpsAmmoList;
	_iLoopCount = round( random 2 );
	_iLoopLimit = 2 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSSpecOpsAmmoList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "vehicleparts" ) then {

	// load vehicle parts list
	_sCount  = count DZMSVehiclePartsList;
	_iLoopCount = round( random 3 );
	_iLoopLimit = 3 + _iLoopCount;

	for "_x" from 0 to _iLoopLimit do {

		_sSelect = floor( random _sCount  );
		_item = DZMSVehiclePartsList select _sSelect;
		_crate addMagazineCargoGlobal [ _item , 2 ];
	};
};

if ( _type == "civviesniper" ) then {
    _crate addWeaponCargoGlobal [ "VSS_Vintorez" , 1 ];
    _crate addMagazineCargoGlobal [ "20Rnd_9x39_SP5_VSS" , 2 ];
};

if ( _type == "ruskieantimateriel" ) then {
    _crate addWeaponCargoGlobal [ "ksvk" , 1 ];
    _crate addMagazineCargoGlobal [ "5Rnd_127x108_KSVK" , 3 ];
};

if ( _type == "usantimateriel" ) then {
    _crate addWeaponCargoGlobal [ "m107" , 1 ];
    _crate addMagazineCargoGlobal [ "10Rnd_127x99_M107" , 3 ];
};


