
private [ "_fdServerTimeAtStartSecs" , "_fdServerTimeNowSecs" , "_fdElapsedTimeSecs" , "_fdElapsedTimeMins" , "_hadRunOnce" ];

// set the flags
DZMSCookieTimeoutRUN = true;
DZMSCookieTimeoutEXPIRED = false;


// get the server time RIGHT NOW
_fdServerTimeAtStartSecs = serverTime;

// a flag to verify that the loop runs at least once in the log
_hadRunOnce = false;

// loop until we time out or we're turned off from outside
while { DZMSCookieTimeoutRUN } do { 

    if ( !_hadRunOnce ) then {

        diag_log text format [ "[DZMS]: Cookie timeout timer loop running." ];
        _hadRunOnce = true;

    };

    // wait a bit
    sleep 10;

    // get the server time RIGHT NOW
    _fdServerTimeNowSecs = serverTime;

    // now calculate the elapsed seconds since this script started running
    _fdElapsedTimeSecs = _fdServerTimeNowSecs - _fdServerTimeAtStartSecs;

    // convert that to minutes
    _fdElapsedTimeMins = _fdElapsedTimeSecs / 60.0;

    // test to see if that's a wrap
    if ( _fdElapsedTimeMins > DZMSCookieTimeoutMins  ) exitWith { 

        diag_log text format [ "[DZMS]: Cookie timeout timer expired -- second values -- Startup %1 , Time Now %2" , _fdServerTimeAtStartSecs , _fdServerTimeNowSecs ];
        diag_log text format [ "[DZMS]: Cookie timeout timer expired -- minute values -- Elapsed %1 , Timeout %2" , _fdElapsedTimeMins , DZMSCookieTimeoutMins ];

        DZMSCookieTimeoutRUN = false; 
        DZMSCookieTimeoutEXPIRED = true; 
    };
};

// a message
diag_log text format [ "[DZMS]: Cookie timeout timer terminate." ];

// clear the run flag just in case
DZMSCookieTimeoutRUN = false;


// how do we get to here?
//
// (1) we run out of time, in which case we return DZMSCookieTimeoutRUN = false AND DZMSCookieTimeoutEXPIRED = true
//
// (2) external setting of DZMSCookieTimeoutRUN to false, in which case we return DZMSCookieTimeoutRUN = false AND DZMSCookieTimeoutEXPIRED = false
