
private [ "_position" , "_unitcount" , "_skill" , "_wpRadius" , "_xpos" , "_ypos" , "_unitGroup" , "_aiskin" , "_iloop" , 
	"_unit" , "_missionTypeID" , "_wppos1" , "_wppos2" , "_wppos3" , "_wppos4" , "_iHowManyUnits" , "_strSeq" , 
	"_wp1" , "_wp2" , "_wp3" , "_wp4" , "_wpfin" , "_groupIdx" , "_iHowManyGroups" , "_iLastIndex" , "_bFoundOne" , "_wpExcursion" ];


// get the passed variables
_position = _this select 0;
_unitcount = _this select 1;
_missionTypeID = _this select 2;
_groupIdx = _this select 3;
_wpRadius = _this select 4;
_wpExcursion = _this select 5;

// set skill to zero
_skill = 0;

// set the spawn position
_xpos = _position select 0;
_ypos = _position select 1;


// Create or access the group ... 
// first figure out how many groups are there in the list we're using?

switch ( _missionTypeID ) do {
	case 1: { _iHowManyGroups = count DZMSGroupsHostagesMinor; };
	case 2: { _iHowManyGroups = count DZMSGroupsHostagesMajor; };
	case 3: { _iHowManyGroups = count DZMSGroupsHostagesCookie; };
};


// figure out what the last index of the existing groups is
_iLastIndex = _iHowManyGroups - 1;


// first, check to see if the group ID is nonnegative, which means just use the group indexed or add it to the list...
if ( _groupIdx > -1 ) then {

	// and then see if our target index for the group we're trying to use is larger ....
	if ( _groupIdx > _iLastIndex ) then {

		// we need to add as many groups as we need to get there ...
		for "_iloop" from _iHowManyGroups to _groupIdx do {

			// make a new group
			_unitGroup = createGroup east;

			// put that group into the list
			switch ( _missionTypeID ) do {
				case 1: { DZMSGroupsHostagesMinor set [ _iloop , _unitGroup ]; };
				case 2: { DZMSGroupsHostagesMajor set [ _iloop , _unitGroup ]; };
				case 3: { DZMSGroupsHostagesCookie set [ _iloop, _unitGroup ]; };
			};
		};
	};

	// now that we KNOW we have enough groups in the applicable group list, set the local handle to the one we want to use
	switch ( _missionTypeID ) do {
		case 1: { _unitGroup = DZMSGroupsHostagesMinor select _groupIdx; };
		case 2: { _unitGroup = DZMSGroupsHostagesMajor select _groupIdx; };
		case 3: { _unitGroup = DZMSGroupsHostagesCookie select _groupIdx; };
	};

} else {

	// the group ID is negative, which means we need to search for the first empty group and use that one, OR add one if necessary

	// set a flag
	_bFoundOne = false;

	// find the last index
	_iLastIndex = _iHowManyGroups - 1;

	// traverse the members of the group
	for "_iloop" from 0 to _iLastIndex do {
		
		// how many units are there in this group?
		switch ( _missionTypeID ) do {
			case 1: { _iHowManyUnits = count units ( DZMSGroupsHostagesMinor select _iloop ); };
			case 2: { _iHowManyUnits = count units ( DZMSGroupsHostagesMajor select _iloop ); };
			case 3: { _iHowManyUnits = count units ( DZMSGroupsHostagesCookie select _iloop );};
		};

		// check to see if we found an unused group
		if ( _iHowManyUnits < 1 ) exitWith {

			// an empty or unused group -- so set the flag, set the index, and pick the unit
			_groupIdx = _iloop;
			_bFoundOne = true;

			switch ( _missionTypeID ) do {
				case 1: { _unitGroup = DZMSGroupsHostagesMinor select _groupIdx; };
				case 2: { _unitGroup = DZMSGroupsHostagesMajor select _groupIdx; };
				case 3: { _unitGroup = DZMSGroupsHostagesCookie select _groupIdx; };
			};

			// and then bounce out of the for loop
		};
	};

	// so when we get to here, we need to create a group if we didn't find one we could use...
	if ( !_bFoundOne ) then {

		// make a new group
		_unitGroup = createGroup east;

		// and then we need to shove it into the appropriate list
		switch ( _missionTypeID ) do {
			case 1: { DZMSGroupsHostagesMinor set [ _iHowManyGroups , _unitGroup ]; };
			case 2: { DZMSGroupsHostagesMajor set [ _iHowManyGroups , _unitGroup ]; };
			case 3: { DZMSGroupsHostagesCookie set [ _iHowManyGroups , _unitGroup ]; };
		};

		// and for consistency set the group index to the last one in the list
		_groupIdx = _iHowManyGroups - 1;

		// the local handle is already set to the new group
	};
};


// either we're not re-using the group, or we killed all the units ... so there's no need to purge the group before we use it again....


// now traverse how many units we want to create
for "_x" from 1 to _unitcount do {

	//  Lets pick a skin from the array
	_aiskin = DZMSHostageSkins call BIS_fnc_selectRandom;
	
	// Lets spawn the unit
	_unit = _unitGroup createUnit [ _aiskin , [ ( _position select 0 ) , ( _position select 1 ) , ( _position select 2 ) ] , [] , 10 , "PRIVATE" ];
	
	// Make him join the correct team
	[ _unit ] joinSilent _unitGroup;
	
	// Add the behaviour
	_unit enableAI "MOVE";
	_unit enableAI "ANIM";
	_unit enableAI "FSM";
	_unit setBehaviour "CARELESS";
	_unit setCaptive true;
	
	// Remove the items he spawns with by default
	removeAllWeapons _unit;
	removeAllItems _unit;
	
	// set up skills
	_aicskill = DZMSSkills0;
	
	{
		_unit setSkill [ ( _x select 0 ) , ( _x select 1 ) ]

	} forEach _aicskill;
	
	// Lets prepare the unit for cleanup
	_unit addEventHandler [ "Killed" , { [ ( _this select 0 ) , ( _this select 1 ) ] ExecVM DZMSHostageKilled; } ];
	_unit setVariable [ "DZMSAI" , true ];
};


// These are 4 waypoints in a NESW pattern around the center
_wppos1 = [ _xpos      , _ypos + _wpExcursion , 0 ];
_wppos2 = [ _xpos + _wpExcursion , _ypos      , 0 ];
_wppos3 = [ _xpos      , _ypos - _wpExcursion , 0 ];
_wppos4 = [ _xpos - _wpExcursion , _ypos      , 0 ];

// We add the 4 waypoints
_wp1 = _unitGroup addWaypoint [ _wppos1 , _wpRadius ];
_wp1 setWaypointType "MOVE";
_wp2 = _unitGroup addWaypoint [ _wppos2 , _wpRadius ];
_wp2 setWaypointType "MOVE";
_wp3 = _unitGroup addWaypoint [ _wppos3 , _wpRadius ];
_wp3 setWaypointType "MOVE";
_wp4 = _unitGroup addWaypoint [ _wppos4 , _wpRadius ];
_wp4 setWaypointType "MOVE";

// Then we add a center waypoint that tells them to visit the rest
_wpfin = _unitGroup addWaypoint [ [ _xpos , _ypos , 0 ] , _wpRadius ];
_wpfin setWaypointType "CYCLE";


// finally, add the units we created to the list of all units for this category
switch ( _missionTypeID ) do {
	case 1: { DZMSUnitsHostagesMinor = DZMSUnitsHostagesMinor + ( units _unitGroup ); };
	case 2: { DZMSUnitsHostagesMajor = DZMSUnitsHostagesMajor + ( units _unitGroup ); };
	case 3: { DZMSUnitsHostagesCookie = DZMSUnitsHostagesCookie + ( units _unitGroup ); };
};


switch ( _missionTypeID ) do {
	case 1: { _strSeq = "DZMSUnitsHostagesMinor"; };
	case 2: { _strSeq = "DZMSUnitsHostagesMajor"; };
	case 3: { _strSeq = "DZMSUnitsHostagesCookie"; };
};

diag_log text format[ "[DZMS]: ( Hostages) %3 %1 AI Spawned of %2 units requested for group %4" , count ( units _unitGroup ) , _unitcount , _strSeq , _groupIdx  ];
