
private [ "_fdServerTimeAtStartSecs" , "_fdServerTimeNowSecs" , "_fdElapsedTimeSecs" , "_fdElapsedTimeMins", "_hadRunOnce" ];

// set the flags
DZMSMajorTimeoutRUN = true;
DZMSMajorTimeoutEXPIRED = false;
DZMSMajorAccepted = false;


// get the server time RIGHT NOW
_fdServerTimeAtStartSecs = serverTime;

// a flag to verify that the loop runs at least once in the log
_hadRunOnce = false;


// loop until we time out or we're turned off from outside
while { ( DZMSMajorTimeoutRUN AND ( !DZMSMajorAccepted ) ) } do { 

    if ( !_hadRunOnce ) then {

        diag_log text format [ "[DZMS]: Major timeout timer loop running!" ];
        _hadRunOnce = true;

    };

    // wait a bit
    sleep 10;

    // get the server time RIGHT NOW
    _fdServerTimeNowSecs = serverTime;

    // now calculate the elapsed seconds since this script started running
    _fdElapsedTimeSecs = _fdServerTimeNowSecs - _fdServerTimeAtStartSecs;

    // convert that to minutes
    _fdElapsedTimeMins = _fdElapsedTimeSecs / 60.0;

    // test to see if that's a wrap
    if ( _fdElapsedTimeMins > DZMSMajorTimeoutMins  ) exitWith { 

        diag_log text format [ "[DZMS]: Major timeout timer expired -- second values -- Startup %1 , Time Now %2" , _fdServerTimeAtStartSecs , _fdServerTimeNowSecs ];
        diag_log text format [ "[DZMS]: Major timeout timer expired -- minute values -- Elapsed %1 , Timeout %2" , _fdElapsedTimeMins , DZMSMajorTimeoutMins ];
        DZMSMajorTimeoutRUN = false; 
        DZMSMajorTimeoutEXPIRED = true; 

        // just in case the mission was accepted while this loop was in a wait state, and THEN we timed out...
        DZMSMajorAccepted = false;
    };
};

// a message
diag_log text format [ "[DZMS]: Major timeout timer terminate." ];

// clear the run flag just in case
DZMSMajorTimeoutRUN = false;

// shut down the acceptance test, just in case
DZMSMajorAcceptanceTestRunning = false;


// how do we get to here?
//
// (1) we run out of time, in which case we return DZMSMajorTimeoutRUN = false AND DZMSMajorTimeoutEXPIRED = true
//
// (2) external setting of DZMSMajorTimeoutRUN to false, in which case we return DZMSMajorTimeoutRUN = false AND DZMSMajorTimeoutEXPIRED = false
//
// (3) external setting of DZMSMajorAccepted to true, in which case we return DZMSMajorTimeoutRUN = false AND DZMSMajorTimeoutEXPIRED = false




