
private [ "_run" , "_timeDiff" , "_wait" , "_cntMis" , "_ranMis" , "_varName" ];

// Let's get our time Min and Max
_timeDiff = DZMSMajorMax - DZMSMajorMin;

diag_log text format [ "[DZMS]: Major Mission Clock Starting!" ];

// Lets get the loop going
_run = true;

while { _run } do
{
    // Lets wait the random time
    _wait  = DZMSMajorMin + round( random _timeDiff );
    [ _wait , 5 ] call DZMSSleep;
	
    // Let's check that there are missions in the array.
    // If there are none, lets end the timer.
    _cntMis = count DZMSMajorArray;
    if ( _cntMis == 0 ) exitWith { /* Exit The Loop */ };
	
    // Lets pick a mission
    _ranMis = floor ( random _cntMis );
    _varName = DZMSMajorArray select _ranMis;
    
    // rebuild the array for the next mission
    DZMSUnitsMajor = [];
    DZMSUnitsHostagesMajor = [];
    DZMSUnitsInVehiclesMajor = [];

    // let's run the mission elapsed time / timeout timer
    [] execVM "\z\addons\dayz_server\DZMS\Scripts\DZMSMajTimeoutTimer.sqf";
    
    // Let's Run the Mission
    [] execVM format [ "\z\addons\dayz_server\DZMS\Missions\Major\%1.sqf" , _varName ];
    diag_log text format [ "[DZMS]: Running Major Mission %1." , _varName ];
	
    // Let's wait for it to finish or timeout
    waitUntil { DZMSMajDone };

    // reset the flag!
    DZMSMajDone = false;
};