// this routine sets a flag that will disable timeout AS SOON AS a single surface AI troop is killed
// this routine must be spawned after all the mission AI are set up

private [ "_numSpawned1" , "_numSpawned2" , "_numAlive1" ,  "_numAlive2" , "_hasRunOnce" ];

DZMSMajorAcceptanceTestRunning = true;
DZMSMajorAccepted = false;

// how many AI are there?
_numSpawned1 = count DZMSUnitsMajor;
_numSpawned2 = count DZMSUnitsInVehiclesMajor;

// a flag to check to see if we run at least once
_hasRunOnce = false;

// run the loop
while { DZMSMajorAcceptanceTestRunning } do { 

    if ( !_hasRunOnce ) then {

        diag_log text format [ "[DZMS]: Major mission acceptance test running." ];
        _hasRunOnce = true;
    };

    // wait a bit
    sleep 10;

    // test to see if ANY of the AI in this group are dead

    // if there aren't any at all, then there are none that are dead
    if ( _numSpawned1 > 0 ) then {
        _numAlive1 = { alive _x } count DZMSUnitsMajor;
    } else {
        _numAlive1 = 0;
    };

    // if there aren't any at all, then there are none that are dead
    if ( _numSpawned2 > 0 ) then {
        _numAlive2 = { alive _x } count DZMSUnitsInVehiclesMajor;
    } else {
        _numAlive2 = 0;
    };

    // if any of the AI have been killed.... 
    if ( ( _numAlive1 < _numSpawned1 ) OR ( _numAlive2 < _numSpawned2 ) ) exitWith {

        // a message to the players
        [ nil , nil , rTitleText , format [ "AI at running major mission: %1 have been killed.\nMission accepted. Mission timeout suspended.", DZMSMajName ] , "PLAIN" , 6 ] call RE;

        diag_log text format [ "[DZMS]: Major mission acceptance test triggered -- AI killed." ];
        DZMSMajorAcceptanceTestRunning = false;

        // if the timeout has run out while this routine is in the this cycle, then we need to discard the acceptance
        // if the timeout is still running when we accept, then the acceptance is valid...
        DZMSMajorAccepted = DZMSMajorTimeoutRUN;
    };
};

// a message
diag_log text format [ "[DZMS]: Major mission acceptance test terminate." ];

// we're not running the acceptance test....
DZMSMajorAcceptanceTestRunning = false;
