/*
	Marker Resetter by Vampire
	Marker Resetter checks if a Mission is running and resets the marker for JIPs
*/

private[ "_run" , "_nul" , "_nil1" , "_nil2" , "_nil3" , "_nil4" ];

diag_log text format [ "[DZMS]: Mission Marker Loop for JIPs Starting!" ];

// Lets define these
if ( isNil "DZMSMajCoords" ) then { DZMSMajCoords = [ 0 , 0 , 0 ]; };
if ( isNil "DZMSMinCoords" ) then { DZMSMinCoords = [ 0 , 0 , 0 ]; };
if ( isNil "DZMSCookieCoords" ) then { DZMSCookieCoords = [ 0 , 0 , 0 ]; };

// Lets start the timer
_run = true;

while { _run } do
{
     [ 25 , 5 ] call DZMSSleep; // sleep 25 seconds

	// If the marker exists (meaning the mission is active) lets delete it and re-add it
	if ( !( getMarkerColor "DZMSMajMarker" == "" ) ) then {
		deleteMarker "DZMSMajMarker";
		deleteMarker "DZMSMajDot";

		// Re-Add the markers

		_nul = createMarker [ "DZMSMajMarker" , DZMSMajCoords ];

		"DZMSMajMarker" setMarkerColor DZMSstrMajMarkerColor;
		"DZMSMajMarker" setMarkerShape DZMSstrMajMarkerShape;
		"DZMSMajMarker" setMarkerBrush DZMSstrMajMarkerBrush;
		"DZMSMajMarker" setMarkerSize [ DZMSfMajMarkerSize , DZMSfMajMarkerSize ];

		_nil1 = createMarker [ "DZMSMajDot" , DZMSMajCoords ];

		"DZMSMajDot" setMarkerColor "ColorBlack";
		"DZMSMajDot" setMarkerType "Vehicle";
		"DZMSMajDot" setMarkerText DZMSMajName;
	};

	// Lets do the same for the minor mission
	if ( !( getMarkerColor "DZMSMinMarker" == "" ) ) then {
		deleteMarker "DZMSMinMarker";
		deleteMarker "DZMSMinDot";

		// Re-Add the markers

		_nul = createMarker [ "DZMSMinMarker" , DZMSMinCoords ];

		"DZMSMinMarker" setMarkerColor DZMSstrMinMarkerColor;
		"DZMSMinMarker" setMarkerShape DZMSstrMinMarkerShape;
		"DZMSMinMarker" setMarkerBrush DZMSstrMinMarkerBrush;
		"DZMSMinMarker" setMarkerSize [ DZMSfMinMarkerSize , DZMSfMinMarkerSize ];

		_nil2 = createMarker [ "DZMSMinDot" , DZMSMinCoords ];

		"DZMSMinDot" setMarkerColor "ColorBlack";
		"DZMSMinDot" setMarkerType "Vehicle";
		"DZMSMinDot" setMarkerText DZMSMinName;
	};

	// let's do the same thing for the cookie mission
	if ( !( getMarkerColor "DZMSCookieMarker" == "" ) ) then {
		deleteMarker "DZMSCookieMarker";
		deleteMarker "DZMSCookieDot";

		// Re-Add the markers

		_nul = createMarker [ "DZMSCookieMarker" , DZMSCookieCoords ];

		"DZMSCookieMarker" setMarkerColor DZMSstrCookieMarkerColor;
		"DZMSCookieMarker" setMarkerShape DZMSstrCookieMarkerShape;
		"DZMSCookieMarker" setMarkerBrush DZMSstrCookieMarkerBrush;
		"DZMSCookieMarker" setMarkerSize [ DZMSfCookieMarkerSize , DZMSfCookieMarkerSize ];

		_nil3 = createMarker ["DZMSCookieDot", DZMSCookieCoords];

		"DZMSCookieDot" setMarkerColor "ColorBlack";
		"DZMSCookieDot" setMarkerType "Vehicle";
		"DZMSCookieDot" setMarkerText DZMSCookieName;
	};

	// Now we wait another 25 seconds
};