/*
	Save To Hive by Vampire
	This function attempts to save vehicles to the database if enabled when a mission ends.
	Usage: [ Vehicle ]
*/

// get the object handle
_object = _this select 0;

// set up the persistence flag
_iPersistentFlag = 0;

// set the persistence flag
if ( ( count _this ) > 1 ) then {
	_iPersistentFlag = _this select 1;
};

// figure out object type and state from handle
_class = typeOf _object;
_dir = getDir _object;
_pos = getPos _object;
_worldspace = [ _dir , _pos ];


// If vehicle saving is OFF, then this script does nothing
if ( ( !( DZMSSaveVehicles ) ) AND ( _iPersistentFlag < 1 ) ) exitWith {};


// Check if vehicle is null or dead
if ( isNull _object OR !alive _object OR ( damage _object ) > .995 ) exitWith {};

// Get a random fuel count to set
_ranFuel = random 1;
if ( _ranFuel < .1 ) then { _ranFuel = .1; };


	// The server is running DayZ Epoch, so we use the Epoch method.
//	_uid = _worldspace call dayz_objectUID3;
	_uid = _worldspace call dayz_objectUID2;

	_key = format[ "CHILD:308:%1:%2:%3:%4:%5:%6:%7:%8:%9" , dayZ_instance , _class , 0 , 0 , _worldspace , [] , [] , _ranFuel , _uid ];

	_key call server_hiveWrite;
	
	// If the server is busy, it might not write on the first try
	// Because of this, we loop it until it works
	_done = false;

	while { !_done } do
	{

		_key = format[ "CHILD:388:%1:" , _uid ];
		_result = _key call server_hiveReadWrite;
		_outcome = _result select 0;

		waitUntil {!isNil "_outcome"};
		
		if(debug_mode) then { diag_log ("[DZMS]HIVE: WRITE: "+ str(_key)); };

		if ( _outcome == "PASS" ) then {

			_oid = _result select 1;
			_object setVariable [ "ObjectID" , _oid , true ];
			
			if(debug_mode) then { diag_log("[DZMS]CUSTOM: Selected " + str(_oid)); };

			_done = true;

		} else {
			if(debug_mode) then { diag_log("[DZMS]CUSTOM: trying again to get id for: " + str(_uid)); };
			_done = false;

		};
		sleep 1;
	};

	if(!_done) then { 
		deleteVehicle _vehicle;
		if(debug_mode) then { 
			diag_log("[DZMS]CUSTOM: failed to get id for : " + str(_uid)); 
		};
	} else {
		_vehicle setVariable ["lastUpdate",time];
	};

	
	// Lets get it ready for the user
	_object setvelocity [ 0 , 0 , 1 ];
	_object setFuel _ranFuel;
	_object setVehicleLock "UNLOCKED";
	
	clearWeaponCargoGlobal _object;
	clearMagazineCargoGlobal _object;
	
	_object allowDamage false;
	_object setVariable [ "lastUpdate" ,  time ];
	_object setVariable [ "CharacterID" , "0" , true ];

//	PVDZE_serverObjectMonitor set [ count PVDZE_serverObjectMonitor , _object ];
	dayz_serverObjectMonitor set [ count dayz_serverObjectMonitor , _object ];
	
	sleep 1;

	_object call fnc_veh_ResetEH;
	PVDZE_veh_Init = _object;

	publicVariable "PVDZE_veh_Init";

	[ _object , "all" ] spawn server_updateObject;
	_object allowDamage true;
	
