
private [ "_cordsSpawn" , "_cordsTarget" , "_strChopperReq" , "_strChopperType" , "_iMissionTypeID" , "_objChopperHandle" , 
	"_iGroupIdx" , "_fRndRad" , "_fOrbitRad" , "_iSkillMin" , "_iSkillMax" ];

// get the values from the parameter block

_cordsSpawn = _this select 0;
_cordsTarget = _this select 1;
_strChopperReq = _this select 2;
_iMissionTypeID = _this select 3;
_iGroupIdx = _this select 4;
_fRndRad = _this select 5;
_fOrbitRad = _this select 6;
_iSkillMin = _this select 7;
_iSkillMax = _this select 8; 


// check the chopper type -- randomize it if requested

if ( _strChopperReq == "random" ) then {
	_strChopperType = [ "activechopper" ] call DZMSGetVeh;
} else {
	_strChopperType = _strChopperReq;
};


// create the chopper

diag_log text format [ "[DZMS]: Calling createVehicle for chopper type: %1" , _strChopperType ];
_objChopperHandle = createVehicle [ _strChopperType , [ ( _cordsSpawn select 0 ) , ( _cordsSpawn select 1 ) , 250 ] , [] , 0 , "FLY" ];

// prevent the AH system from removing it

[ _objChopperHandle ] call DZMSProtectObj;

// get it flying

_objChopperHandle engineOn true;
_objChopperHandle flyInHeight 185;
_objChopperHandle forceSpeed 80;

// fill it up with fuel and ammo and set a random direction

_objChopperHandle setFuel 1;
_objChopperHandle setVehicleAmmo 1;
_objChopperHandle setDir ( random 360 );

// crew of an aircraft can't stay if the vehicle is critically damaged

_objChopperHandle allowCrewInImmobile false;

// empty the plane of any default contents -- the crate emptying routine works for any 'vehicle'

[ _objChopperHandle ] call DZMSEmptyBoxCompletely;

// crew the aircraft

//           spawn here     vehicle handle      string type       major, minor, etc              mission center
[ _cordsSpawn , _objChopperHandle , _strChopperType , _iMissionTypeID , _iGroupIdx , _cordsTarget , _fOrbitRad , _fRndRad , _iSkillMin , _iSkillMax ] call DZMSSpawnCrew;


// done here -- the last value is the return value
_objChopperHandle