
private [ "_posVehicle" , "_objVehicle" , "_strVehicleType" , "_iMissionTypeID" , "_unitGroup" , "_iGunners" , "_posMissionCenter" ,
	"_iGroupIdx" , "_iHowManyGroups" , "_iLastIndex" , "_iloop" , "_bFoundOne" , "_iTotalAI" , "_iSkillMin" , "_iSkillMax" , "_iSkill" , "_strGroup" ,
	"_aiskin" , "_unit" , "_weaponArray" , "_weapon" , "_magazine" , "_aigear" , "_gearmagazines" , "_geartools" , "_aipack" , "_bAirVehicle" , "_aicskill" ,
	"_wppos1" , "_wppos2" , "_wppos3" , "_wppos4" , "_wp1" , "_wp2" , "_wp3" , "_wp4" , "_wpfin" , "_xpos" , "_ypos" , "_zpos" , "_wpOrbitRadius" , "_wpRndRadius"
];


// the location at which the vehicle spawned
_posVehicle = _this select 0;

// the vehicle to be crewed
_objVehicle = _this select 1;

// the type of vehicle, used to identify crew counts
_strVehicleType = _this select 2;

// the mission group used
_iMissionTypeID = _this select 3;

// the group index for the group list
_iGroupIdx = _this select 4;

// the actual mission center, not where the vehicle is spawned -- the center of all action
_posMissionCenter = _this select 5;

// get the mission center orbital waypoint radius
_wpOrbitRadius = _this select 6;

// get the waypoint locaton randomizer radius
_wpRndRadius = _this select 7;

// get the skill values
_iSkillMin = _this select 8;
_iSkillMax = _this select 9;


// find or make the group handle

// which mission group type are we using?

switch ( _iMissionTypeID ) do {
	case 1: { _iHowManyGroups = count DZMSGroupsInVehiclesMinor; };
	case 2: { _iHowManyGroups = count DZMSGroupsInVehiclesMajor; };
	case 3: { _iHowManyGroups = count DZMSGroupsInVehiclesCookie; };
};

// figure out what the last index of the existing groups is

_iLastIndex = _iHowManyGroups - 1;

// first, check to see if the group ID is nonnegative, which means just use the group indexed or add it to the list...

if ( _iGroupIdx > -1 ) then {

	// and then see if our target index for the group we're trying to use is larger ....

	if ( _iGroupIdx > _iLastIndex ) then {

		// we need to add as many groups as we need to get there ...

		for "_iloop" from _iHowManyGroups to _iGroupIdx do {

			// make a new group

			_unitGroup = createGroup east;

			// put that group into the list

			switch ( _iMissionTypeID ) do {
				case 1: { DZMSGroupsInVehiclesMinor set [ _iloop , _unitGroup ]; };
				case 2: { DZMSGroupsInVehiclesMajor set [ _iloop , _unitGroup ]; };
				case 3: { DZMSGroupsInVehiclesCookie set [ _iloop, _unitGroup ]; };
			};
		};
	};

	// now that we KNOW we have enough groups in the applicable group list, set the local handle to the one we want to use

	switch ( _iMissionTypeID ) do {
		case 1: { _unitGroup = DZMSGroupsInVehiclesMinor select _iGroupIdx; };
		case 2: { _unitGroup = DZMSGroupsInVehiclesMajor select _iGroupIdx; };
		case 3: { _unitGroup = DZMSGroupsInVehiclesCookie select _iGroupIdx; };
	};

} else {

	// the group ID is negative, which means we need to search for the first empty group and use that one, OR add one if necessary

	// set a flag

	_bFoundOne = false;

	// find the last index

	_iLastIndex = _iHowManyGroups - 1;

	// traverse the members of the group

	for "_iloop" from 0 to _iLastIndex do {
		
		// how many units are there in this group?

		switch ( _iMissionTypeID ) do {
			case 1: { _iHowManyUnits = count units ( DZMSGroupsInVehiclesMinor select _iloop ); };
			case 2: { _iHowManyUnits = count units ( DZMSGroupsInVehiclesMajor select _iloop ); };
			case 3: { _iHowManyUnits = count units ( DZMSGroupsInVehiclesCookie select _iloop );};
		};

		// check to see if we found an unused group

		if ( _iHowManyUnits < 1 ) exitWith {

			// an empty or unused group -- so set the flag, set the index, and pick the unit
			_iGroupIdx = _iloop;
			_bFoundOne = true;

			switch ( _iMissionTypeID ) do {
				case 1: { _unitGroup = DZMSGroupsInVehiclesMinor select _iGroupIdx; };
				case 2: { _unitGroup = DZMSGroupsInVehiclesMajor select _iGroupIdx; };
				case 3: { _unitGroup = DZMSGroupsInVehiclesCookie select _iGroupIdx; };
			};

			// and then bounce out of the for loop
		};
	};

	// so when we get to here, we need to create a group if we didn't find one we could use...

	if ( !_bFoundOne ) then {

		// make a new group

		_unitGroup = createGroup east;

		// and then we need to shove it into the appropriate list

		switch ( _iMissionTypeID ) do {
			case 1: { DZMSGroupsInVehiclesMinor set [ _iHowManyGroups , _unitGroup ]; };
			case 2: { DZMSGroupsInVehiclesMajor set [ _iHowManyGroups , _unitGroup ]; };
			case 3: { DZMSGroupsInVehiclesCookie set [ _iHowManyGroups , _unitGroup ]; };
		};

		// and for consistency set the group index to the last one in the list

		_iGroupIdx = _iHowManyGroups - 1;

		// the local handle is already set to the new group
	};
};


// figure out how many gunners there are / how many fun positions there are

_iGunners = [ _strVehicleType ]call DZMSFindGunnerCount;

// so the total AI count is...

_iTotalAI = _iGunners + 1;


// now traverse how many units we want to create

for "_iloop" from 1 to _iTotalAI do {

	//  Lets pick a skin from the array

	_aiskin = DZMSBanditSkins call BIS_fnc_selectRandom;
	
	// Lets spawn the unit

	_unit = _unitGroup createUnit [ _aiskin , _posVehicle , [] , 10 , "PRIVATE" ];
	
	// Make him join the correct team
	[ _unit ] joinSilent _unitGroup;
	
	// Add the behaviour
	_unit enableAI "TARGET";
	_unit enableAI "AUTOTARGET";
	_unit enableAI "MOVE";
	_unit enableAI "ANIM";
	_unit enableAI "FSM";
	_unit setCombatMode "RED";
	_unit setBehaviour "COMBAT";
	
	// Remove the items he spawns with by default

	removeAllWeapons _unit;
	removeAllItems _unit;
	
	// Now we need to figure out the loadout and assign it
	
	// Get the weapon array based on skill

	// make the skill level
	_iSkill = _iSkillMin + floor ( random ( _iSkillMax - _iSkillMin + 1 ) );

	// cap the skill level
	if ( _iSkill > 3 ) then {
		_iSkill = 3;
	};

	// get the weapon for this skill level

	_weaponArray = [ _iSkill ] call DZMSGetWeapon;
	
	_weapon = _weaponArray select 0;
	_magazine = _weaponArray select 1;
	
	// Get the gear array

	_aigear = DZMSGearArrays call BIS_fnc_selectRandom;
	_gearmagazines = _aigear select 0;
	_geartools = _aigear select 1;
	
	// Gear the AI backpack

	_aipack = DZMSPacklist call BIS_fnc_selectRandom;

	// Let's add 3 copies of the magazine to the Unit

	_unit addMagazine _magazine;
	_unit addMagazine _magazine;
	_unit addMagazine _magazine;

	_unit addWeapon _weapon;

	_unit selectWeapon _weapon;
	
	_unit addBackpack _aipack;
	
	// traverse the list of magazine items

	{
		_unit addMagazine _x

	} forEach _gearmagazines;
	
	// traverse the tools list

	{
		_unit addWeapon _x

	} forEach _geartools;
	
	// do something to mitigate the "unused variable" error in teh report file

	_aicskill = DZMSSkills0;

	// now copy the skills matrix over

	switch ( _iSkill ) do {

		case 0: { _aicskill = DZMSSkills0; };
		case 1: { _aicskill = DZMSSkills1; };
		case 2: { _aicskill = DZMSSkills2; };
		case 3: { _aicskill = DZMSSkills3; };
	};
	
	// traverse the skill set values

	{
		_unit setSkill [ ( _x select 0 ) , ( _x select 1 ) ]

	} forEach _aicskill;

	// now move the unit into the vehicle

	if ( _iloop == 1 ) then {

		// this is the pilot/driver/leader

		_unit assignAsDriver _objVehicle;
		_unit moveInDriver _objVehicle;
		_unit setVariable [ "isDriver" , true ];
		_unitGroup selectLeader _unit;

	} else {

		// this is a gunner

		_unit assignAsGunner _objVehicle;
		_unit moveInTurret [ _objVehicle , [ ( _iloop - 1 ) ] ];

	};
	
	// prepare the unit for cleanup

	_unit addEventHandler [ "Killed" , { [ ( _this select 0 ) , ( _this select 1 ) ] ExecVM DZMSAIKilled; } ];

	_unit setVariable [ "DZMSAI" , true ];
};


// set up the mission center coordinates

// are we crewing an aircraft?

_bAirVehicle = ( _strVehicleType isKindOf "Air" );

_xpos = ( _posMissionCenter select 0 );
_ypos = ( _posMissionCenter select 1 );

if ( _bAirVehicle ) then {
	_zpos = 150;
} else {
	_zpos = 0;
};


// these are four waypoints in a NESW pattern around the mission center

_wppos1 = [ _xpos , _ypos + _wpOrbitRadius , _zpos ];
_wppos2 = [ _xpos + _wpOrbitRadius , _ypos , _zpos ];
_wppos3 = [ _xpos , _ypos - _wpOrbitRadius , _zpos ];
_wppos4 = [ _xpos - _wpOrbitRadius , _ypos , _zpos ];

// add the four waypoints

_wp1 = _unitGroup addWaypoint [ _wppos1 , _wpRndRadius ];
_wp1 setWaypointType "MOVE";
_wp2 = _unitGroup addWaypoint [ _wppos2 , _wpRndRadius ];
_wp2 setWaypointType "MOVE";
_wp3 = _unitGroup addWaypoint [ _wppos3 , _wpRndRadius ];
_wp3 setWaypointType "MOVE";
_wp4 = _unitGroup addWaypoint [ _wppos4 , _wpRndRadius ];
_wp4 setWaypointType "MOVE";

// then add a center waypoint that tells them to visit the rest

_wpfin = _unitGroup addWaypoint [ [ _xpos , _ypos , _zpos ] , _wpRndRadius ];
_wpfin setWaypointType "CYCLE";


// finally, add the units we created to the list of all units for this category

_strGroup = "__";

switch ( _iMissionTypeID ) do {

	case 1: { DZMSUnitsInVehiclesMinor = DZMSUnitsInVehiclesMinor + ( units _unitGroup ); _strGroup = "Minor"; };
	case 2: { DZMSUnitsInVehiclesMajor = DZMSUnitsInVehiclesMajor + ( units _unitGroup ); _strGroup = "Major"; };
	case 3: { DZMSUnitsInVehiclesCookie = DZMSUnitsInVehiclesCookie + ( units _unitGroup ); _strGroup = "Cookie"; };
};


// set group variables

_unitGroup setBehaviour "AWARE";
_unitGroup setCombatMode "RED";
_unitGroup setSpeedMode "FULL";
_unitGroup allowFleeing 0;


diag_log text format[ "[DZMS]: %1 Crew AI Spawned requested for %2 group %3" , _iTotalAI , _strGroup , _iGroupIdx ];


// we're done here
