
private [ "_coordsSpawn" , "_cordsTarget" , "_iVehicleTable" , "_strVehicleType" , "_iMissionTypeID" , "_objVehicleHandle" , 
	"_iGroupIdx" , "_fRndRad" , "_fOrbitRad" , "_iTemp" , "_iSkillMin" , "_iSkillMax" ];

// get the values from the parameter block

_coordsSpawn = _this select 0;
_cordsTarget = _this select 1;
_iVehicleTable = _this select 2;
_iMissionTypeID = _this select 3;
_iGroupIdx = _this select 4;
_fRndRad = _this select 5;
_fOrbitRad = _this select 6;
_iSkillMin = _this select 7;
_iSkillMax = _this select 8; 


// check the vehicle difficulty level

switch ( _iVehicleTable ) do {
	case 1: { _strVehicleType = [ "armedsurface1" ] call DZMSGetVeh; };
	case 2: { _strVehicleType = [ "armedsurface2" ] call DZMSGetVeh; };
	case 3: { _strVehicleType = [ "armedsurface3" ] call DZMSGetVeh; };
};

if ( count _this > 9 ) then {
	_strVehicleType = _this select 9;
};

// create the Vehicle

diag_log text format [ "[DZMS]: Calling createVehicle for vehicle type: %1" , _strVehicleType ];
_objVehicleHandle = createVehicle [ _strVehicleType , _coordsSpawn , [] , 0 , "NONE" ];

// prevent the AH system from removing it

[ _objVehicleHandle ] call DZMSProtectObj;

// fill it up with fuel and ammo and set a random direction

_objVehicleHandle setFuel 1;
_objVehicleHandle setVehicleAmmo 1;
_objVehicleHandle setDir ( random 360 );

// crew of a surface vehicle can take refuge in even an immobilized vehicle

_objVehicleHandle allowCrewInImmobile true;

// empty the vehicle of any default contents -- the crate emptying routine works for any 'vehicle'

[ _objVehicleHandle ] call DZMSEmptyBoxCompletely;

// crew the vehicle
//           spawn here     vehicle handle      string type       major, minor, etc              mission center

[ _coordsSpawn , _objVehicleHandle , _strVehicleType , _iMissionTypeID , _iGroupIdx , _cordsTarget , _fOrbitRad , _fRndRad , _iSkillMin , _iSkillMax  ] call DZMSSpawnCrew;


// done here -- the last value is the return value
_objVehicleHandle