if ( isServer ) then {

	/* GENERAL CONFIG */

		debug_mode	= false;	// enable debug
		use_blacklist	= true;		// use blacklist
		blacklist		= [
			[ [ 15500 , 12200 , 0 ] , [ 18300 , 9400 , 0 ] ] ,
			[ [ 17500 , 12200 , 0 ] , [ 20300 , 9400 , 0 ] ] ,
			[ [ 14600 , 10700 , 0 ] , [ 17400 , 7900 , 0 ] ] ,
			[ [ 16600 , 10700 , 0 ] , [ 19400 , 7900 , 0 ] ] ,
			[ [  5000 , 8800 , 0 ]  , [ 14000 , -200 , 0 ] ] ,
			[ [ 12000 , 8800 , 0 ]  , [ 21000 , -200 , 0 ] ]
		];

	/* END GENERAL CONFIG */

	/* AI CONFIG */

		ai_clear_body 		= false;	// instantly clear bodies
		ai_clean_dead 		= false;	// clear bodies after certain amount of time
		ai_cleanup_time 	= 3600;		// time to clear bodies in seconds
		ai_clean_roadkill	= false; 	// clean bodies that are roadkills
		ai_roadkill_damageweapon	= 90;	// percentage of chance a roadkill will destroy weapon AI is carrying

		ai_bandit_combatmode	= "RED";	// combatmode of bandit AI
		ai_bandit_behaviour	= "COMBAT";	// behaviour of bandit AI

		ai_hero_combatmode	= "RED";	// combatmode of hero AI
		ai_hero_behaviour	= "COMBAT";		// behaviour of hero AI

		ai_friendly_behaviour	= false;	// make ai friendly towards comrades

		player_bandit		= -5000;	// this is the amount you declare someone to be a bandit on your server, bandit AI will not attack you if ai_friendly_behaviour is true
		player_hero		= 5000;		// this is the amount you declare someone to be a hero on your server, hero AI will not attack you if ai_friendly_behaviour is true

		ai_share_info		= true;		// AI share info on player position
		ai_share_distance	= 300;		// distance from killed AI for AI to share your rough position

		ai_kills_gain		= true;		// add kill to bandit/human kill score
		ai_humanity_gain	= true;		// gain humanity for killing AI
		ai_add_humanity	= 25;			// amount of humanity gained for killing a bandit AI
		ai_remove_humanity	= 50;		// amount of humanity lost for killing a hero AI
		ai_special_humanity	= 150;		// amount of humanity gain or loss for killing a special AI dependant on player alignment
		
		ai_skill_extreme	= [["aimingAccuracy",1.0],["aimingShake",1.0],["aimingSpeed",1.0],["endurance",1.0],["spotDistance",1.0],["spotTime",1.0],["courage",1.0],["reloadSpeed",1.0],["commanding",1.0],["general",1.0]]; 	// Extreme
		ai_skill_very_hard	= [["aimingAccuracy",0.9],["aimingShake",0.9],["aimingSpeed",0.9],["endurance",1.0],["spotDistance",0.9],["spotTime",0.9],["courage",1.0],["reloadSpeed",1.0],["commanding",1.0],["general",1.0]]; 	// Very Hard
		ai_skill_hard		= [["aimingAccuracy",0.8],["aimingShake",0.8],["aimingSpeed",0.8],["endurance",1.0],["spotDistance",0.8],["spotTime",0.8],["courage",1.0],["reloadSpeed",1.0],["commanding",1.0],["general",1.0]]; 	// Hard
		ai_skill_medium		= [["aimingAccuracy",0.6],["aimingShake",0.6],["aimingSpeed",0.6],["endurance",1.0],["spotDistance",0.6],["spotTime",0.6],["courage",0.9],["reloadSpeed",1.0],["commanding",1.0],["general",1.0]];	// Medium
		ai_skill_easy		= [["aimingAccuracy",0.4],["aimingShake",0.5],["aimingSpeed",0.5],["endurance",1.0],["spotDistance",0.5],["spotTime",0.5],["courage",0.8],["reloadSpeed",1.0],["commanding",0.9],["general",1.0]];	// Easy
		ai_skill_very_easy	= [["aimingAccuracy",0.3],["aimingShake",0.4],["aimingSpeed",0.4],["endurance",1.0],["spotDistance",0.3],["spotTime",0.3],["courage",0.7],["reloadSpeed",1.0],["commanding",0.8],["general",1.0]];	// Very Easy

		ai_skill_random		= [
			ai_skill_extreme , 
			ai_skill_very_hard , 
			ai_skill_very_hard , 
			ai_skill_hard , 
			ai_skill_hard , 
			ai_skill_hard , 
			ai_skill_hard , 
			ai_skill_medium , 
			ai_skill_medium , 
			ai_skill_medium , 
			ai_skill_medium , 
			ai_skill_easy ,
			ai_skill_easy ,
			ai_skill_very_easy
		];

		ai_static_useweapon	= true;	// Allows AI on static guns to have a loadout 	
		ai_static_weapons	= [ "KORD_high_TK_EP1" , "DSHKM_Ins" , "M2StaticMG" ];	// static guns

		ai_static_skills	= false;	// Allows you to set custom array for AI on static weapons. (true: On false: Off) 

		ai_static_array		= [ 
			[ "aimingAccuracy" , 0.20 ] , 
			[ "aimingShake" , 0.70 ] , 
			[ "aimingSpeed" , 0.75 ] , 
			[ "endurance" , 1.00 ] , 
			[ "spotDistance" , 0.70 ] , 
			[ "spotTime" , 0.50 ] , 
			[ "courage" , 1.00 ] , 
			[ "reloadSpeed" , 1.00 ] , 
			[ "commanding" , 1.00 ] , 
			[ "general" , 1.00 ]
		];

		ai_gear00	= [ [ "ItemBandage" , "ItemBandage" , "ItemAntibiotic6" ] , [ "ItemRadio" , "ItemMachete" , "ItemCrowbar" , "Binocular" ] ];
		ai_gear01	= [ [ "ItemBandage" , "ItemAntibiotic6" ] , [ "ItemMachete" , "Binocular" ] ];
		ai_gear02	= [ [ "ItemBandage" , "ItemAntibacterialWipe" , "ItemSodaPepsi" , "ItemMorphine" ] , [ "Binocular_Vector" ] ];
		ai_gear03	= [ [ "ItemBandage" , "ItemPainkiller" , "FoodSunFlowerSeed" ] , [ "Binocular" ] ];
		ai_gear04	= [ [ "ItemDocument" , "FoodCanFrankBeans" , "ItemHeatPack" ] , [ "ItemToolbox" ] ];
		ai_gear05	= [ [ "ItemWaterbottle" , "ItemBloodbag" ] , [ "ItemCompass" , "ItemCrowbar" ] ];
		ai_gear06	= [ [ "ItemBandage" , "ItemAntibacterialWipe" , "ItemEpinephrine" , "ItemPainkiller" , "FoodMRE" ] , [ "ItemGPS" , "ItemKeyKit" ] ];
		ai_gear07	= [ [ "ItemBandage" , "ItemSodaPepsi" , "ItemMorphine" ] , [ "ItemEtool" ] ];
		ai_gear08	= [ [ "ItemBandage" , "ItemSodaLvg" ] , [ "ItemHatchet" ] ];
		ai_gear09	= [ [ "ItemBandage" , "ItemAntibacterialWipe" , "ItemPainkiller" , "FoodNutmix" ] , [ "ItemMatchbox" ] ];
		ai_gear10	= [ [ "ItemBandage" , "ItemSodaCoke" ] , [ "ItemKnife" ] ];
		ai_gear11	= [ [ "ItemBandage" , "ItemWaterbottleBoiled" ] , [ "ItemSledge" ] ];
		ai_gear12	= [ [ "ItemBandage" , "ItemAntibacterialWipe" , "ItemPainkiller" ] , [ "ItemFishingPole" ] ];
		ai_gear13	= [ [ "ItemBandage" , "ItemMorphine" , "FoodPumpkin" ] , [ "ItemMap" ] ];
		ai_gear14	= [ [ "ItemBandage" , "ItemSodaPepsi" , "ItemMorphine" ] , [ "NVGoggles" ] ];

		ai_gear_random	= [
			ai_gear00 , 
			ai_gear01 , 
			ai_gear02 , 
			ai_gear03 , 
			ai_gear04 , 
			ai_gear05 , 
			ai_gear06 , 
			ai_gear07 , 
			ai_gear08 , 
			ai_gear09 , 
			ai_gear10 , 
			ai_gear11 , 
			ai_gear12 , 
			ai_gear13 , 
			ai_gear14
		];	// Allows the possibility of random gear

		ai_wep_assault	= [
			"AK74_Kobra_DZ" , 
			"AK74_Kobra_DZ" , 
			"AK74_Kobra_DZ" , 
			"AKS74U_DZ" , 
			"AKS_GOLD" , 
			"AKM_DZ" , 
			"AKM_DZ" , 
			"AKM_DZ" , 
			"AK74_DZ" , 
			"AKM_DZ" , 
			"FNFAL_DZ" , 
			"FNFAL_DZ" , 
			"FNFAL_DZ" , 
			"G36A_Camo_DZ" , 
			"G36C_DZ" , 
			"G36_C_SD_camo" , 
			"G36K_Camo_DZ" , 
			"M16A2_DZ" , 
			"M16A2GL" , 
			"M16A4_DZ" , 
			"M16A4_ACG" , 
			"M4A1_DZ" , 
			"M4A1_Aim" , 
			"M4A1_Aim" , 
			"M4A1_Aim" , 
			"M4A1_HWS_GL_camo" , 
			"M4A1_AIM_SD_camo" , 
			"M4A1_HWS_GL_SD_Camo" , 
			"M4A3_CCO_EP1" , 
			"M4A3_CCO_EP1" , 
			"M4A3_CCO_EP1" , 
			"SA58_DZ" , 
			"SA58_DZ" , 
			"Sa58V_RCO_EP1" , 
			"Sa58V_CCO_EP1" ,
			"SA58_DZ" , 
			"SA58_DZ" , 
			"Sa58V_RCO_EP1" , 
			"Sa58V_CCO_EP1" ,
			"SCAR_L_STD_HOLO" , 
			"m8_carbine" , 
			"m8_compact" , 
			"m8_holo_sd" , 
			"BAF_L85A2_RIS_Holo"
		];	// Assault

		ai_wep_machine	= [
			"RPK_DZ" , 
			"RPK74_DZ" , 
			"PKM_DZ" , 
			"UK59_DZ" , 
			"MG36" , 
			"MG36_camo" , 
			"m8_SAW" , 
			"Mk48_DZ" , 
			"M249_m145_EP1_DZE" , 
			"M249_DZ" , 
			"M249_EP1_DZ" , 
			"M249_DZ" , 
			"M249_EP1_DZ" , 
			"Pecheneg_DZ" , 
			"m240_scoped_EP1_DZE" , 
			"M60A4_EP1_DZE" , 
			"M240_DZ"
		];	// Light machine guns

		ai_wep_sniper	= [
			"M14_DZ" , 
			"SCAR_H_LNG_Sniper_SD" , 
			"M110_NVG_EP1" , 
			"SVD_DZ" , 
			"SVD_des_EP1" , 
			"SVD_CAMO" , 
			"VSS_Vintorez" , 
			"AK_107_pso" , 
			"CZ550_DZ" , 
			"M4SPR" , 
			"DMR_DZ" , 
			"DMR_DZ" , 
			"M24_DZ" , 
			"M24_des_EP1" , 
			"SCAR_L_STD_Mk4CQT" , 
			"m8_sharpshooter" , 
			"BAF_L85A2_RIS_SUSAT" , 
			"M40A3_DZ"
		];	// Sniper rifles

		ai_wep_random		= [
			ai_wep_assault , 
			ai_wep_assault , 
			ai_wep_assault , 
			ai_wep_sniper , 
			ai_wep_machine
		];	// random weapon 60% chance assault rifle,20% light machine gun,20% sniper rifle

		ai_wep_launchers_AT	= [ "M136" , "RPG18" , "JAVELIN" ];
		ai_wep_launchers_AA	= [ "Strela" , "Igla" , "STINGER" ];
		
		ai_packs	= [
			"DZ_Patrol_Pack_EP1" , 
			"CZ_VestPouch_EP1" , 
			"DZ_ALICE_Pack_EP1" , 
			"DZ_TK_Assault_Pack_EP1" , 
			"DZ_Assault_Pack_EP1" , 
			"DZ_British_ACU" , 
			"DZ_TerminalPack_EP1" , 
			"DZ_GunBag_EP1" , 
			"DZ_Patrol_Pack_EP1" , 
			"CZ_VestPouch_EP1" , 
			"DZ_ALICE_Pack_EP1" , 
			"DZ_TK_Assault_Pack_EP1" , 
			"DZ_Assault_Pack_EP1" , 
			"DZ_British_ACU" , 
			"DZ_TerminalPack_EP1" , 
			"DZ_GunBag_EP1" , 
			"DZ_CivilBackpack_EP1" , 
			"DZ_Backpack_EP1" , 
			"DZ_LargeGunBag_EP1"
		];

		ai_hero_skin	= [ "FR_AC" , "FR_AR" , "FR_Corpsman" , "FR_GL" , "FR_Marksman" , "FR_R" , "FR_Sapper" , "FR_TL" ];

		ai_bandit_skin	= [
			"Rocker1_DZ" , 
			"Rocker2_DZ" , 
			"Rocker3_DZ" , 
			"Rocker4_DZ" , 
			"Ins_Soldier_GL_DZ" , 
			"TK_INS_Soldier_EP1_DZ" , 
			"TK_INS_Warlord_EP1_DZ" , 
			"GUE_Commander_DZ" , 
			"GUE_Soldier_Sniper_DZ" , 
			"GUE_Soldier_MG_DZ" , 
			"GUE_Soldier_Crew_DZ" , 
			"GUE_Soldier_2_DZ" , 
			"GUE_Soldier_CO_DZ" , 
			"BanditW1_DZ" , 
			"BanditW2_DZ" , 
			"Bandit1_DZ" , 
			"Bandit2_DZ"
		];

		ai_special_skin	= ["Functionary1_EP1_DZ"];

		ai_all_skin	= [ ai_hero_skin , ai_bandit_skin , ai_special_skin ];

		ai_add_skin	= true;	// adds unit skin to inventory on death
		
		/* AI Cache Units */
		ai_cache_units	= false;

		/**Range for Re-Activation*************/
		/****** Default: 800 ******************/
		ai_cache_units_reactivation_range = 800;

		/**Time untill units are Frozen again**/
		/************* Default: 30 ************/
		ai_cache_units_refreeze = 30;

		/****** Log Actions to RPT File? ******/
		/*********** Default: true ************/
		ai_cache_units_freeze_log = true;

		/******** Unassign Waypoints?  ********/
		/*********** Default: false ***********/
		ai_cache_units_unassign_waypoints = false;

		/******** Randomize Position?  ********/
		/******** Distance to Randomize *******/
		/*********** Default: true ************/
		/*********** Distance: 20 *************/
		ai_cache_units_randomize_position = true;
		ai_cache_units_randomize_distance = 20;

		/********** Hide un-used AI?  *********/
		/*********** Default: true ************/
		ai_cache_unites_hide_ai = true;

		/* AI Cache Units End */
		
	/* END AI CONFIG */

	/* WAI MISSIONS CONFIG */
		wai_mission_system	= true;	// use built in mission system

		wai_mission_markers	= ["DZMSMajMarker","DZMSMinMarker","DZMSBMajMarker","DZMSBMinMarker"];
		wai_avoid_missions	= 750;	// avoid spawning missions this close to other missions, these are defined in wai_mission_markers
		wai_avoid_traders	= 750;		// avoid spawning missions this close to traders
		wai_avoid_town		= 0;		// avoid spawning missions this close to towns, *** doesn't function with infiSTAR enabled ***
		wai_avoid_road		= 0;		// avoid spawning missions this close to roads
		wai_avoid_water		= 50;		// avoid spawning missions this close to water

		
		wai_mission_timer	= [30,900];		// time between missions 5-15 minutes
		wai_mission_timeout	= [900,1800]; 	// time each missions takes to despawn if inactive 15-30 minutes
		wai_timeout_distance	= 1000;	// if a player is this close to a mission then it won't time-out
		
		wai_clean_mission	= true;		// clean all mission buildings after a certain period
		wai_clean_mission_time	= 1800;	// time after a mission is complete to clean mission buildings

		wai_mission_fuel	= [5,60];		// fuel inside mission spawned vehicles [min%,max%]
		wai_vehicle_damage	= [20,70];	// damages to spawn vehicles with [min%,max%]
		wai_keep_vehicles	= true;		// save vehicles to database and keep them after restart
		wai_linux_server	= false;		// false = Windows (HiveExt.dll)		true = Linux Server (writer.pl)		has no effect when "wai_keep_vehicles = false;"
		wai_lock_vehicles	= true;		// lock mission vehicles and add keys to random AI bodies (be careful with ai_clean_dead if this is true

		wai_crates_smoke	= true;		// pop smoke on crate when mission is finished during daytime
		wai_crates_flares	= true;		// pop flare on crate when mission is finished during nighttime
		
		wai_players_online	= 1; 		// number of players online before mission starts
		wai_server_fps		= 5; 		// missions only starts if server FPS is over wai_server_fps
		
		wai_kill_percent	= 90;			// percentage of AI players that must be killed at "crate" missions to be able to trigger completion

		wai_high_value		= true;	// enable the possibility of finding a high value item (defined below crate_items_high_value) inside a crate
		wai_high_value_chance	= 1;		// chance in percent you find above mentioned item

		wai_enable_minefield	= true;	// enable minefields to better defend missions
		wai_use_launchers	= true;	// add a rocket launcher to each spawned AI group
		wai_remove_launcher	= false;	// remove rocket launcher from AI on death

		// Missions
		wai_radio_announce	= true;		// Setting this to true will announce the missions to those that hold a radio only
		wai_hero_limit		= 2;			// define how many hero missions can run at once
		wai_bandit_limit	= 2;			// define how many bandit missions can run at once

		wai_hero_missions		= [ 		// ["mission filename",% chance of picking this mission],Make sure the chances add up to 100,or it will not be accurate percentages
			[ "bandit_kids_car"    	, 9 ] ,
			[ "bandit_patrol"       	, 8 ] ,
			[ "destroyed_ural"      	, 8 ] ,
			[ "medi_camp"           	, 7 ] ,
			[ "new_transport"      	, 7 ] ,
			[ "weapon_cache"        	, 6 ] ,
			[ "black_hawk_crash"    	, 6 ] ,
			[ "armed_vehicle"       	, 5 ] ,
			[ "patrol_armed_vehicle1"	, 5 ] ,
			[ "armed_vehicle2"      	, 4 ] ,
			[ "disabled_milchopper" 	, 4 ] ,
			[ "sniper_extraction"   	, 4 ] ,
			[ "captured_mv22"       	, 4 ] ,
			[ "armed_vehicle3"      	, 3 ] ,
			[ "mayors_mansion"      	, 3 ] ,
			[ "ikea_convoy"         	, 3 ] ,
			[ "bandit_base"         	, 3 ] ,
			[ "disabled_milchopper2"	, 3 ] ,
			[ "armed_vehicle4"      	, 3 ] ,
			[ "warlord_visiting"    	, 2 ] ,
			[ "disabled_milchopper3"	, 2 ] ,
			[ "armed_vehicle5"      	, 1 ]
		];

		wai_bandit_missions	= [
			["patrol",10],
			["armed_vehicle",10],
			["black_hawk_crash",10],
			["captured_mv22",6],
			["broken_down_ural",12],
			["hero_base",6],
			["ikea_convoy",8],
			["medi_camp",14],
			["presidents_mansion",6],
			["sniper_extraction",8],
			["weapon_cache",10]
		];

		// location array

	wai_patrol_locations = [
		[ "Bubendorf" , [ 3860 , 14270 , 0 ] ] ,
		[ "Hubel" , [ 920 , 10830 , 0 ] ] ,
		[ "Hindelbank" , [ 2540 , 11330 , 0 ] ] ,
		[ "Ittingen" , [ 2230 , 10210 , 0 ] ] ,
		[ "Worb" , [ 2350 , 7680 , 0 ] ] ,
		[ "Homburg" , [ 2740 , 6240 , 0 ] ] ,
		[ "SW Airbase" , [ 4960 , 4840 , 0 ] ] ,
		[ "Waldegg" , [ 8530 , 1280 , 0 ] ] ,
		[ "Brienz" , [ 14520 , 3230 , 0 ] ] ,
		[ "SE Airbase" , [ 18220 , 2500 , 0 ] ] ,
		[ "Froburg" , [ 17260 , 3710 , 0 ] ] ,
		[ "Giswil" , [ 16750 , 5350 , 0 ] ] ,
		[ "Sorenburg" , [ 13560 , 5500 , 0 ] ] ,
		[ "Farnen" , [ 13180 , 7110 , 0 ] ] ,
		[ "Schangen" , [ 8930 , 5741 , 0 ] ] ,
		[ "Buckten" , [ 5500 , 5940 , 0 ] ] ,
		[ "Munsingen" , [ 3970 , 8090 , 0 ] ] ,
		[ "Hasle" , [ 3550 , 10120 , 0 ] ] ,
		[ "Unterdorf" , [ 5080 , 11230 , 0 ] ] ,
		[ "Muttenz" , [ 6300 , 10220 , 0 ] ] ,
		[ "Muenchenstein" , [ 6160 , 9930 , 0 ] ] ,
		[ "Chatzbach" , [ 7480 , 9510 , 0 ] ] ,
		[ "Signau" , [ 5990 , 8870 , 0 ] ] ,
		[ "Eggwil" , [ 7370 , 6800 , 0 ] ] ,
		[ "Milan" , [ 9980 , 8010 , 0 ] ] ,
		[ "Sissach" , [ 11370 , 8910 , 0 ] ] ,
		[ "Bruderholz" , [ 9850 , 10130 , 0 ] ] ,
		[ "Agerifeld" , [ 8730 , 11320 , 0 ] ] ,
		[ "Oberdorf" , [ 5750 , 12040 , 0 ] ] ,
		[ "Huttwil" , [ 4630 , 12520 , 0 ] ] ,
		[ "Seltisberg" , [ 5950 , 15270 , 0 ] ] ,
		[ "Neue Welt" , [ 5670 , 13940 , 0 ] ] ,
		[ "Trueb" , [ 7640 , 14300 , 0 ] ] ,
		[ "Truebsall" , [ 8450 , 14620 , 0 ] ] ,
		[ "Seewen" , [ 6530 , 16760 , 0 ] ] ,
		[ "Lenzburg" , [ 9170 , 16300 , 0 ] ] ,
		[ "Freidorf" , [ 8390 , 17440 , 0 ] ] ,
		[ "Hasenmatt" , [ 11080 , 18460 , 0 ] ] ,
		[ "Magden" , [ 10470 , 17180 , 0 ] ] ,
		[ "Olten" , [ 9870 , 16770 , 0 ] ] ,
		[ "Ruemlingen" , [ 10610 , 16120 , 0 ] ] ,
		[ "Hirsegg" , [ 10360 , 14350 , 0 ] ] ,
		[ "Napf" , [ 10830 , 11920 , 0 ] ] ,
		[ "Liestal" , [ 12560 , 9930 , 0 ] ] ,
		[ "Alpnach" , [ 18410 , 9540 , 0 ] ] ,
		[ "Sachseln" , [ 14610 , 11090 , 0 ] ] ,
		[ "Romoos" , [ 12680 , 11790 , 0 ] ] ,
		[ "Lausen" , [ 12090 , 15230 , 0 ] ] ,
		[ "Luzern" , [ 14940 , 14120 , 0 ] ] ,
		[ "Wolhusen" , [ 14240 , 12980 , 0 ] ] ,
		[ "Emmen" , [ 15120 , 13440 , 0 ] ] ,
		[ "Horw" , [ 16860 , 14200 , 0 ] ] ,
		[ "Meggen" , [ 16080 , 15430 , 0 ] ] ,
		[ "NE Airport" , [ 14660 , 16790 , 0 ] ] ,
		[ "Suhrenfeld" , [ 16400 , 18550 , 0 ] ] ,
		[ "Pfeffiken" , [ 18260 , 17200 , 0 ] ]
	];

		
		// Vehicle arrays

		minor_vehicles		= [
			"ATV_US_EP1" , 
			"car_hatchback" , 
			"car_sedan" , 
			"datsun1_civil_1_open_DZE" , 
			"datsun1_civil_2_covered_DZE" , 
			"datsun1_civil_3_open_DZE" , 
			"hilux1_civil_1_open_DZE" , 
			"hilux1_civil_2_covered_DZE" , 
			"hilux1_civil_3_open_DZE" , 
			"HMMWV_DES_EP1" , 
			"HMMWV" , 
			"HMMWV_DZ" , 
			"BAF_Offroad_W" , 
			"LandRover_CZ_EP1" , 
			"LandRover_TK_CIV_EP1" , 
			"S1203_TK_CIV_EP1" , 
			"SkodaBlue" , 
			"SkodaGreen" , 
			"SkodaRed" , 
			"SUV_Blue" , 
			"SUV_Camo" , 
			"SUV_Orange" , 
			"SUV_Red" , 
			"UAZ_CDF" , 
			"UAZ_INS" , 
			"UAZ_RU" , 
			"UAZ_Unarmed_TK_CIV_EP1" , 
			"UAZ_Unarmed_TK_EP1" , 
			"UAZ_Unarmed_UN_EP1" , 
			"VolhaLimo_TK_CIV_EP1" , 
			"VWGolf" , 
			"SUV_TK_CIV_EP1" 
		];
		armed_vehicle 	= [
			"ArmoredSUV_PMC_DZE" , 
			"ArmoredSUV_PMC_DZ" , 
			"GAZ_Vodnik_DZE" , 
			"GAZ_Vodnik_DZ" , 
			"HMMWV_Armored" , 
			"LandRover_MG_TK_EP1_DZE" , 
			"LandRover_MG_TK_EP1_DZ" , 
			"LandRover_Special_CZ_EP1_DZE" , 
			"LandRover_Special_CZ_EP1_DZ" , 
			"Pickup_PK_GUE_DZE" , 
			"Pickup_PK_GUE_DZ" , 
			"Pickup_PK_INS_DZE" , 
			"Pickup_PK_INS_DZ" , 
			"Pickup_PK_TK_GUE_EP1_DZE" , 
			"Pickup_PK_TK_GUE_EP1_DZ" , 
			"UAZ_MG_TK_EP1_DZE" ,
			"UAZ_MG_TK_EP1_DZ" , 
			"Offroad_DSHKM_Gue_DZ" , 
			"Offroad_DSHKM_Gue_DZE"
		];

		armed_vehicle_2	= [
			"AAV" ,
			"BAF_Jackal2_GMG_W" , 
			"BAF_Jackal2_L2A1_W" , 
			"BRDM2_CDF" ,
			"BRDM2_Gue" ,
			"BRDM2_INS" ,
			"BRDM2_TK_EP1" ,
			"BRDM2_TK_GUE_EP1" ,
			"BTR40_MG_TK_GUE_EP1" , 
			"GAZ_Vodnik_HMG" , 
			"GRAD_TK_EP1" , 
			"GRAD_CDF" , 
			"HMMWV_M1151_M2_CZ_DES_EP1_DZ" , 
			"HMMWV_M1151_M2_CZ_DES_EP1_DZE" , 
			"HMMWV_M998A2_SOV_DES_EP1_DZE" ,
			"HMMWV_M998A2_SOV_DES_EP1_DZ" ,
			"HMMWV_M998_crows_M2_DES_EP1" ,
			"HMMWV_MK19" , 
			"HMMWV_M2" , 
			"LandRover_SPG9_TK_INS_EP1" , 
			"UAZ_SPG9_INS"
		];

		armed_vehicle_3	= [
			"BMP2_CDF" , 
			"BAF_FV510_W" , 
			"BRDM2_ATGM_CDF" , 
			"BTR60_TK_EP1" , 
			"HMMWV_M998_crows_MK19_DES_EP1" ,
			"LAV25" , 
			"M1126_ICV_M2_EP1" ,
			"M113_UN_EP1" , 
			"M113_TK_EP1" , 
			"Ural_ZU23_TK_EP1",
			"Ural_ZU23_CDF"
		];

		armed_vehicle_4	= [
			"M2A3_EP1" , 
			"M6_EP1" ,
			"BMP3" , 
			"M1128_MGS_EP1" , 
			"M1129_MC_EP1" , 
			"BTR90"
		];

		armed_vehicle_5	= [
			"2S6M_Tunguska" , 
			"T34" ,
			"T55" , 
			"T72_RU" , 
			"T90" , 
			"ZSU_CDF" , 
			"M1A1" , 
			"M1A2_TUSK_MG" ,
			"M1A1_US_DES_EP1" , 
			"M1A2_US_TUSK_MG_EP1"
		];

		armed_chopper 	= [
			"pook_H13_gunship_CDF" , 
			"pook_H13_transport_CDF" , 
			"Ka137_MG_PMC" , 
			"UH1H_DZE" , 
			"UH1H_DZ" , 
			"UH1H_TK_EP1" , 
			"Mi17_DZ" , 
			"Mi17_DZE" , 
			"Mi17_CDF"
		];

		armed_chopper_2		= [
			"UH60M_EP1_DZE" , 
			"UH60M_EP1_DZ" , 
			"UH1Y_DZE" , 
			"UH1Y_DZ" , 
			"MH60S_DZE" , 
			"MH60S_DZ" ,
			"MH60S" ,
			"CH_47F_EP1_DZE" , 
			"Mi171Sh_CZ_EP1" , 
			"CH_47F_EP1_DZ"
		];

		armed_chopper_3		= [
			"AW159_Lynx_BAF" , 
			"Ka52" , 
			"Ka52Black" , 
			"Ka60_GL_PMC" , 
			"AH1Z" , 
			"BAF_Apache_AH1_D" , 
			"AH64D_EP1" ,
			"Mi171Sh_rockets_CZ_EP1" ,
			"Mi24_D" , 
			"Mi24_D_TK_EP1" , 
			"Mi24_P" , 
			"Mi24_V"
		];

		civil_chopper 		= [
			"AH6X_DZ" , 
			"BAF_Merlin_DZE" , 
			"CH53_DZE" , 
			"MH6J_DZ" , 
			"Mi17_Civilian_DZ" , 
			"Mi17_medevac_INS" , 
			"pook_H13_medevac_CDF" , 
			"pook_H13_amphib_CDF" , 
			"pook_H13_civ_white"
		];

		military_unarmed 	= [
			"GAZ_Vodnik_MedEvac" , 
			"HMMWV_Ambulance" , 
			"HMMWV_Ambulance_CZ_DES_EP1" , 
			"HMMWV_DES_EP1" , 
			"HMMWV" , 
			"HMMWV_DZ" , 
			"HMMWV_M1035_DES_EP1" ,
			"BAF_Offroad_W" , 
			"LandRover_CZ_EP1" , 
			"LandRover_TK_CIV_EP1" , 
			"UAZ_CDF" , 
			"UAZ_INS" , 
			"UAZ_RU" , 
			"UAZ_Unarmed_TK_CIV_EP1" , 
			"UAZ_Unarmed_TK_EP1" , 
			"UAZ_Unarmed_UN_EP1"
		];

		military_unarmed_2 	= [
			"BMP2_Ambul_CDF" , 
			"BMP2_Ambul_INS" , 
			"M1133_MEV_EP1" , 
			"M113Ambul_TK_EP1"
		];

		cargo_trucks 		= [
			"Kamaz" , 
			"KamazOpen_DZE" , 
			"MTVR_DES_EP1" ,
			"MtvrSupply_DES_EP1" , 
			"Ural_CDF" , 
			"Ural_TK_CIV_EP1" , 
			"Ural_UN_EP1" , 
			"UralCivil_DZE" ,
			"UralCivil2_DZE" , 
			"UralSupply_TK_EP1" ,
			"V3S_TK_EP1_DZE" , 
			"V3S_Open_TK_CIV_EP1" , 
			"V3S_Supply_TK_GUE_EP1" , 
			"V3S_Open_TK_EP1" , 
			"WarfareSupplyTruck_USMC"
		];

		reammo_trucks		= [
			"KamazReammo" , 
			"MtvrReammo_DES_EP1" , 
			"UralReammo_CDF" ,
			"V3S_Reammo_TK_GUE_EP1" , 
			"WarfareReammoTruck_USMC"
		];

		repair_trucks		= [
			"KamazRepair" , 
			"MtvrRepair_DES_EP1" , 
			"UralRepair_CDF" , 
			"V3S_Repair_TK_GUE_EP1" , 
			"WarfareRepairTruck_Gue"
		];

		refuel_trucks		= [
			"KamazRefuel" , 
			"KamazRefuel_DZ" , 
			"MtvrRefuel_DES_EP1_DZ" , 
			"UralRefuel_TK_EP1_DZ" ,
			"UralRefuel_CDF" , 
			"V3S_Refuel_TK_GUE_EP1_DZ"
		];

		civil_vehicles 		= [
			"datsun1_civil_1_open_DZE" , 
			"datsun1_civil_2_covered_DZE" , 
			"datsun1_civil_3_open_DZE" , 
			"hilux1_civil_1_open_DZE" , 
			"hilux1_civil_2_covered_DZE"  ,
			"hilux1_civil_3_open_DZE" ,
			"LandRover_TK_CIV_EP1" , 
			"SUV_Blue" , 
			"SUV_Camo" , 
			"SUV_Charcoal" , 
			"SUV_Green" , 
			"SUV_Orange" , 
			"SUV_Pink" , 
			"SUV_Red" , 
			"SUV_Silver" , 
			"SUV_TK_CIV_EP1" , 
			"SUV_White" , 
			"SUV_Yellow"
		];

		// Dynamic box array
		crates_large		= ["USVehicleBox","RUVehicleBox","TKVehicleBox_EP1"];
		crates_medium		= ["USBasicWeaponsBox","RUBasicWeaponsBox","USSpecialWeaponsBox","USSpecialWeapons_EP1","RUSpecialWeaponsBox","SpecialWeaponsBox","TKSpecialWeapons_EP1","CZBasicWeapons_EP1","UNBasicWeapons_EP1"];
		crates_small		= ["GuerillaCacheBox","RULaunchersBox","RUBasicAmmunitionBox","RUOrdnanceBox","USBasicAmmunitionBox","USLaunchersBox","USOrdnanceBox","USOrdnanceBox_EP1","USLaunchers_EP1","USBasicWeapons_EP1","USBasicAmmunitionBox_EP1","UNBasicAmmunitionBox_EP1","TKOrdnanceBox_EP1","TKLaunchers_EP1","TKBasicAmmunitionBox_EP1","GuerillaCacheBox_EP1","GERBasicWeapons_EP1"];

		crate_weapons_buildables	= ["ChainSaw","ChainSawB","ChainSawG","ChainSawP","ChainSawR"];
		
		crate_tools		= ["ItemKeyKit","Binocular","Binocular_Vector","ItemCompass","ItemCrowbar","ItemEtool","ItemFishingPole","ItemFlashlightRed","ItemGPS","ItemHatchet","ItemKnife","ItemMachete","ItemMatchbox","ItemToolbox","NVGoggles"];
		crate_tools_buildable	= ["ItemToolbox","ItemEtool","ItemCrowbar","ItemKnife"];
		crate_tools_sniper	= ["ItemCompass","Binocular","Binocular_Vector","NVGoggles","ItemGPS"];

		crate_items			= [
			"FoodNutmix" , 
			"FoodPistachio" , 
			"FoodMRE" , 
			"ItemSodaOrangeSherbet" , 
			"ItemSodaRbull" , 
			"ItemSodaR4z0r" , 
			"ItemSodaMdew" , 
			"ItemSodaPepsi" , 
			"ItemBandage" , 
			"ItemSodaCoke" , 
			"FoodbaconCooked" , 
			"FoodCanBakedBeans" , 
			"FoodCanFrankBeans" , 
			"FoodCanPasta" , 
			"FoodCanSardines" , 
			"FoodchickenCooked" , 
			"FoodmuttonCooked" , 
			"FoodrabbitCooked" ,
 			"FishCookedTrout" , 
			"FishCookedTuna" , 
			"FishCookedSeaBass" , 
			"ItemAntibiotic6" , 
			"ItemBloodbag" , 
			"ItemEpinephrine" , 
			"ItemHeatPack" , 
			"ItemMorphine" , 
			"ItemGoldBar" , 
			"ItemGoldBar10oz" , 
			"CinderBlocks" , 
			"ItemCanvas" , 
			"ItemComboLock" , 
			"ItemLightBulb" , 
			"ItemLockbox" , 
			"ItemSandbag" , 
			"ItemTankTrap" , 
			"ItemWire" , 
			"MortarBucket" , 
			"PartEngine" , 
			"PartFueltank" , 
			"PartGeneric" , 
			"PartGlass" , 
			"PartPlankPack" , 
			"PartVRotor" , 
			"PartWheel" , 
			"PartWoodPile"
		];

		crate_items_high_value	= [ "ItemBriefcase100oz" , "ItemVault" , "plot_pole_kit" , "ItemHotwireKit" ];

		crate_items_food		= [
			"ItemWaterbottle" , 
			"FoodNutmix" , 
			"FoodPistachio" , 
			"FoodMRE" , 
			"ItemSodaOrangeSherbet" , 
			"ItemSodaRbull" , 
			"ItemSodaR4z0r" , 
			"ItemSodaMdew" , 
			"ItemSodaPepsi" , 
			"ItemSodaCoke" , 
			"FoodbaconCooked" , 
			"FoodCanBakedBeans" , 
			"FoodCanFrankBeans" , 
			"FoodCanPasta" , 
			"FoodCanSardines" , 
			"FoodchickenCooked" , 
			"FoodmuttonCooked" , 
			"FoodrabbitCooked" , 
			"FishCookedTrout" , 
			"FishCookedTuna" , 
			"FishCookedSeaBass" 
		];

		crate_items_buildables	= [
			"forest_large_net_kit" , 
			"cinder_garage_kit" , 
			[ "PartPlywoodPack" , 5 ] , 
			"ItemSandbagExLarge5X" , 
			"park_bench_kit" , 
			"ItemComboLock" , 
			[ "CinderBlocks" , 10 ] , 
			"ItemCanvas" , 
			"ItemComboLock" , 
			[ "ItemLightBulb" , 5 ] , 
			"ItemLockbox" , 
			[ "ItemSandbag" , 10 ] , 
			[ "ItemTankTrap" , 10 ] , 
			[ "ItemWire" , 10 ] , 
			[ "MortarBucket" , 10 ] , 
			[ "PartPlankPack" , 5 ] , 
			"PartWoodPile"
		];

		crate_items_vehicle_repair	= [ "PartEngine" , "PartFueltank" , "PartGeneric" , "PartGlass" , "PartVRotor" , "PartWheel" ];

		crate_items_medical	= [
			"ItemWaterbottleBoiled" , 
			"ItemAntibiotic6" , 
			"ItemBloodbag" , 
			"ItemEpinephrine" , 
			"ItemHeatPack" , 
			"ItemMorphine" ,
			"ItemAntibacterialWipe" ,  
			"ItemBandage" , 
			"FoodCanFrankBeans" , 
			"FoodCanPasta"
		];

		crate_items_chainbullets	= [ "2000Rnd_762x51_M134" , "200Rnd_762x51_M240" , "100Rnd_127x99_M2" , "150Rnd_127x107_DSHKM" ];
		crate_items_sniper	= [ [ "ItemPainkiller" , 5 ] , "Skin_Sniper1_DZ" , "Skin_CZ_Soldier_Sniper_EP1_DZ" , "Skin_GUE_Soldier_Sniper_DZ" ];
		crate_items_president	= [ "ItemDocument" , "ItemGoldBar10oz" ];

		crate_backpacks_all	= [
			"DZ_Patrol_Pack_EP1" , 
			"DZ_Assault_Pack_EP1" , 
			"CZ_VestPouch_EP1" , 
			"DZ_TerminalPack_EP1" , 
			"DZ_ALICE_Pack_EP1" , 
			"DZ_TK_Assault_Pack_EP1" , 
			"DZ_CompactPack_EP1" , 
			"DZ_British_ACU" , 
			"DZ_GunBag_EP1" , 
			"DZ_CivilBackpack_EP1" , 
			"DZ_Backpack_EP1" , 
			"DZ_LargeGunBag_EP1"
		];

		crate_backpacks_large	= [ "DZ_GunBag_EP1" , "DZ_Backpack_EP1" , "DZ_LargeGunBag_EP1" , "DZ_CivilBackpack_EP1" ];

		crate_random	= [ crate_items , crate_items_food , crate_items_buildables , crate_items_vehicle_repair , crate_items_medical , crate_items_chainbullets ];

	/* END WAI MISSIONS CONFIG */

	/* STATIC MISSIONS CONFIG */

		static_missions		= false;		// use static mission file
		custom_per_world	= false;		// use a custom mission file per world

	/* END STATIC MISSIONS CONFIG */

	WAIconfigloaded = true;

};