if(isServer) then {

	private ["_complete","_crate","_mission","_static_gun","_crate_type","_rndnum","_playerPresent","_vehname","_vehicle","_position","_vehclass"];

	// Get mission number, important we do this early
	_mission 		= count wai_mission_data -1;
	
	//Armed Land Vehicle
	_vehclass 		= armed_vehicle call BIS_fnc_selectRandom;
	_vehname 		= getText (configFile >> "CfgVehicles" >> _vehclass >> "displayName");

	_pos_location = [
		[ "Bubendorf" , [ 3860 , 14270 , 0 ] ] ,
		[ "Hubel" , [ 920 , 10830 , 0 ] ] ,
		[ "Hindelbank" , [ 2540 , 11330 , 0 ] ] ,
		[ "Ittingen" , [ 2230 , 10210 , 0 ] ] ,
		[ "Worb" , [ 2350 , 7680 , 0 ] ] ,
		[ "Homburg" , [ 2740 , 6240 , 0 ] ] ,
		[ "SW Airbase" , [ 4960 , 4840 , 0 ] ] ,
		[ "Waldegg" , [ 8530 , 1280 , 0 ] ] ,
		[ "Brienz" , [ 14520 , 3230 , 0 ] ] ,
		[ "SE Airbase" , [ 18220 , 2500 , 0 ] ] ,
		[ "Froburg" , [ 17260 , 3710 , 0 ] ] ,
		[ "Giswil" , [ 16750 , 5350 , 0 ] ] ,
		[ "Sorenburg" , [ 13560 , 5500 , 0 ] ] ,
		[ "Farnen" , [ 13180 , 7110 , 0 ] ] ,
		[ "Schangen" , [ 8930 , 5741 , 0 ] ] ,
		[ "Buckten" , [ 5500 , 5940 , 0 ] ] ,
		[ "Munsingen" , [ 3970 , 8090 , 0 ] ] ,
		[ "Hasle" , [ 3550 , 10120 , 0 ] ] ,
		[ "Unterdorf" , [ 5080 , 11230 , 0 ] ] ,
		[ "Muttenz" , [ 6300 , 10220 , 0 ] ] ,
		[ "Muenchenstein" , [ 6160 , 9930 , 0 ] ] ,
		[ "Chatzbach" , [ 7480 , 9510 , 0 ] ] ,
		[ "Signau" , [ 5990 , 8870 , 0 ] ] ,
		[ "Eggwil" , [ 7370 , 6800 , 0 ] ] ,
		[ "Milan" , [ 9980 , 8010 , 0 ] ] ,
		[ "Sissach" , [ 11370 , 8910 , 0 ] ] ,
		[ "Bruderholz" , [ 9850 , 10130 , 0 ] ] ,
		[ "Agerifeld" , [ 8730 , 11320 , 0 ] ] ,
		[ "Oberdorf" , [ 5750 , 12040 , 0 ] ] ,
		[ "Huttwil" , [ 4630 , 12520 , 0 ] ] ,
		[ "Seltisberg" , [ 5950 , 15270 , 0 ] ] ,
		[ "Neue Welt" , [ 5670 , 13940 , 0 ] ] ,
		[ "Trueb" , [ 7640 , 14300 , 0 ] ] ,
		[ "Truebsall" , [ 8450 , 14620 , 0 ] ] ,
		[ "Seewen" , [ 6530 , 16760 , 0 ] ] ,
		[ "Lenzburg" , [ 9170 , 16300 , 0 ] ] ,
		[ "Freidorf" , [ 8390 , 17440 , 0 ] ] ,
		[ "Hasenmatt" , [ 11080 , 18460 , 0 ] ] ,
		[ "Magden" , [ 10470 , 17180 , 0 ] ] ,
		[ "Olten" , [ 9870 , 16770 , 0 ] ] ,
		[ "Ruemlingen" , [ 10610 , 16120 , 0 ] ] ,
		[ "Hirsegg" , [ 10360 , 14350 , 0 ] ] ,
		[ "Napf" , [ 10830 , 11920 , 0 ] ] ,
		[ "Liestal" , [ 12560 , 9930 , 0 ] ] ,
		[ "Alpnach" , [ 18410 , 9540 , 0 ] ] ,
		[ "Sachseln" , [ 14610 , 11090 , 0 ] ] ,
		[ "Romoos" , [ 12680 , 11790 , 0 ] ] ,
		[ "Lausen" , [ 12090 , 15230 , 0 ] ] ,
		[ "Luzern" , [ 14940 , 14120 , 0 ] ] ,
		[ "Wolhusen" , [ 14240 , 12980 , 0 ] ] ,
		[ "Emmen" , [ 15120 , 13440 , 0 ] ] ,
		[ "Horw" , [ 16860 , 14200 , 0 ] ] ,
		[ "Meggen" , [ 16080 , 15430 , 0 ] ] ,
		[ "NE Airport" , [ 14660 , 16790 , 0 ] ] ,
		[ "Suhrenfeld" , [ 16400 , 18550 , 0 ] ] ,
		[ "Pfeffiken" , [ 18260 , 17200 , 0 ] ]
	];
	_location 		= _pos_location call BIS_fnc_selectRandom;
	_position		= (_location select 1);

	[_mission,_position,"Medium",format["Patrol %1",_vehname],"MainBandit",false,false] call mission_init;
	
	diag_log format["WAI: [Mission:[Bandit] Patrol]: Starting... %1",_position];

	//Spawn units
	_units = [[_position select 0,_position select 1,0.1],3,"Hard","Random",3,"Random","Hero","Random","Hero",_mission] call spawn_group;

	//Spawn vehicles
	_vehicle = [_vehclass,_position,_mission] call custom_publish;

	// load the guns
	[_vehicle,_vehclass] spawn load_ammo;

	//Setup patrol
	[_vehicle,_position,_units,_pos_location,3] call patrol;
	
	if(debug_mode) then {
		diag_log format["WAI: [Bandit] patrol spawned a %1",_vehname];
	};
	
	//Condition
	_complete = [
		[_mission,_vehicle], // mission number and crate
		["patrol"], 		 // ["crate"], or ["kill"], or ["assassinate", _unitGroup],
		[_vehicle], 		 // cleanup objects
		format["Heroes have started to patrol near %1",(_location select 0)],	// mission announcement
		"Bandits have taken out the hero patrol!",		// mission success
		"The hero squad reached its destination."		// mission fail
	] call mission_winorfail;

	if(_complete) then {
		[_vehicle,6,4,15,2] call dynamic_crate;
	};

	diag_log format["WAI: [Mission:[Bandit] Armed Vehicle]: Ended at %1",_position];
	
	b_missionsrunning = b_missionsrunning - 1;
};