if ( isServer ) then {

	private ["_complete","_crate","_mission","_static_gun","_crate_type","_rndnum","_vehname","_vehicle","_position","_vehclass"];

	// Get mission number, important we do this early
	_mission	= count wai_mission_data -1;

	// Armed Land Vehicle
	_vehclass 	= armed_vehicle_5 call BIS_fnc_selectRandom;
	_vehname 	= getText ( configFile >> "CfgVehicles" >> _vehclass >> "displayName" );

	_position	= [80] call find_position;
	[ _mission , _position , "extreme" , format[ "Disabled %1" , _vehname ] , "MainHero" , false ] call mission_init;
	
	diag_log format[ "[WAI] [Mission:[Hero] Armed Vehicle 5 ]: Starting... %1" , _position ];

	// Setup the crate
	_crate_type 	= crates_small call BIS_fnc_selectRandom;
	_crate 		= createVehicle [_crate_type,[(_position select 0),(_position select 1) + 5,0], [], 0, "CAN_COLLIDE"];
	
	// Troops
	_rndnum = ( 6 + round( random 3 ) );
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , ["Random" , "AT"] , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , "Random"          , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , ["Random" , "AT"] , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , "Random"          , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , ["Random" , "AT"] , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "extreme" , "Random"          , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;

	// armor patrols
	_vehclasspatrol1 = armed_vehicle_3 call BIS_fnc_selectRandom;
	[ [(_position select 0) + 75 , (_position select 1) + 75 , 0] , [(_position select 0) + 75 , (_position select 1) + 75 , 0] , 50 , 2 , _vehclasspatrol1 , "extreme" , "Bandit" , "Bandit" , _mission ] call vehicle_patrol;
	_vehclasspatrol2 = armed_vehicle_3 call BIS_fnc_selectRandom;
	[ [(_position select 0) + 75 , (_position select 1) - 75 , 0] , [(_position select 0) + 75 , (_position select 1) - 75 , 0] , 50 , 2 , _vehclasspatrol2 , "extreme" , "Bandit" , "Bandit" , _mission ] call vehicle_patrol;
	_vehclasspatrol3 = armed_vehicle_3 call BIS_fnc_selectRandom;
	[ [(_position select 0) - 75 , (_position select 1) + 75 , 0] , [(_position select 0) - 75 , (_position select 1) + 75 , 0] , 50 , 2 , _vehclasspatrol3 , "extreme" , "Bandit" , "Bandit" , _mission ] call vehicle_patrol;
	_vehclasspatrol4 = armed_vehicle_3 call BIS_fnc_selectRandom;
	[ [(_position select 0) - 75 , (_position select 1) - 75 , 0] , [(_position select 0) - 75 , (_position select 1) - 75 , 0] , 50 , 2 , _vehclasspatrol4 , "extreme" , "Bandit" , "Bandit" , _mission ] call vehicle_patrol;

	// chopper paratrooper drops
	[[(_position select 0) + 100 ,(_position select 1) + 100 , 0],[  150 ,  150 , 0 ],400,"UH60M_EP1_DZE",10,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	[[(_position select 0) + 100 ,(_position select 1) - 100 , 0],[  150 , -150 , 0 ],400,"UH60M_EP1_DZE",10,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	[[(_position select 0) - 100 ,(_position select 1) + 100 , 0],[ -150 ,  150 , 0 ],400,"UH60M_EP1_DZE",10,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	[[(_position select 0) - 100 ,(_position select 1) - 100 , 0],[ -150 , -150 , 0 ],400,"UH60M_EP1_DZE",10,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	
	// Static Guns
	_static_gun = ai_static_weapons call BIS_fnc_selectRandom;
	[[
		[ ( ( _position select 0 ) + 50 ) , ( _position select 1 )      , 0 ],
		[ ( ( _position select 0 ) - 50 ) , ( _position select 1 )      , 0 ],
		[ ( ( _position select 0 )      ) , ( _position select 1 ) + 50 , 0 ],
		[ ( ( _position select 0 )      ) , ( _position select 1 ) - 50 , 0 ],
		[ ( ( _position select 0 ) + 35 ) , ( _position select 1 ) + 35 , 0 ],
		[ ( ( _position select 0 ) + 35 ) , ( _position select 1 ) - 35 , 0 ],
		[ ( ( _position select 0 ) - 35 ) , ( _position select 1 ) + 35 , 0 ],
		[ ( ( _position select 0 ) - 35 ) , ( _position select 1 ) - 35 , 0 ]
	] , _static_gun , "extreme" , "Bandit" , "Bandit" , 0 , 2 , "Random" , "Random" , _mission ] call spawn_static;
	
	// Spawn Vehicle
	_vehicle	= [ _vehclass , _position , _mission ] call custom_publish;
	
	if ( debug_mode ) then {
		diag_log format[ "[WAI] [Hero] armed_vehicle 5 spawned a %1" , _vehname ];
	};
	
	// Condition
	_complete = [
		[_mission,_crate],	// mission number and crate
		["crate"], 		// ["crate"], or ["kill"], or ["assassinate", _unitGroup],
		[_vehicle], 		// cleanup objects
		"Bandits have captured a piece of front line armor. It's waiting for heavy transport. If the bandits deploy this.... !",	// mission announcement
		"Survivors have secured the front line armor!",		// mission success
		"Survivors did not secure the front line armor."	// mission fail
	] call mission_winorfail;

	if ( _complete ) then {
		[ _crate , 0 , 0 , [ 25 , crate_items_chainbullets ] , 2 ] call dynamic_crate;
	};

	diag_log format["[WAI] [Hero] armed_vehicle5 ended at %1",_position];
	
	h_missionsrunning = h_missionsrunning - 1;
};