if ( isServer ) then {

	private 		[ "_complete" , "_vehicle" , "_crate_type" , "_crate" , "_mission" , "_vehname" , "_position" , "_vehclass" ];

	// Get mission number, important we do this early
	_mission 		= count wai_mission_data -1;

	// the kid's car
	_vehclass 		= minor_vehicles call BIS_fnc_selectRandom;
	_vehname 		= getText ( configFile >> "CfgVehicles" >> _vehclass >> "displayName" );

	_position		= [30] call find_position;
	[ _mission , _position , "very easy" , format["Bandit Gift Car ", _vehname ] , "MainHero" , true ] call mission_init;
	
	diag_log format[ "[WAI] [Mission:[Hero] bandit_kids_car]: Starting... %1" , _position ];

	// Setup the crate
	_crate_type 	= crates_small call BIS_fnc_selectRandom;
	_crate 		= createVehicle [ _crate_type , [ ( _position select 0 ) , ( _position select 1 ) + 5 , 0 ] , [] , 0 , "CAN_COLLIDE" ];
	
	// Troops
	[ [ _position select 0 , _position select 1 , 0 ] , 3 , "very easy" , [ "Random" , "AT" ] , 4 , "Random" , "Bandit" , "Random" , "Bandit" , _mission ] call spawn_group;

	// Spawn vehicle
	_vehicle		= [ _vehclass , _position , _mission , false , 0 , 1 ] call custom_publish;
	
	if ( debug_mode ) then {
		diag_log format["[WAI] [Hero] bandit_kids_car spawned a %1" , _vehname ];
	};
	
	// Condition
	_complete = [
		[ _mission , _crate ],	// mission number and crate
		[ "crate" ] , 			// ["crate"], or ["kill",wai_kill_percent], or ["assassinate", _unitGroup],
		[ _vehicle ] , 			// cleanup objects
		"A minor bandit warlord had a vehicle fixed up for his son. Best intel says it's lightly guarded by bandit recruits. Get it before the brat picks it up.",	// mission announcement
		"Survivors have seized the bandit vehicle!",		// mission success
		"Survivors weren't able to grab the bandit vehicle."	// mission fail
	] call mission_winorfail;

	if ( _complete ) then {
		[ _crate , 0 , [ 2 , crate_tools ] , [ 5 , crate_items_vehicle_repair ] , 1 ] call dynamic_crate;
	};

	diag_log format[ "[WAI] [Mission:[Hero] Bandit Gift Car]: Ended at %1" , _position ];
	
	h_missionsrunning = h_missionsrunning - 1;
};