if(isServer) then {

	private ["_static_gun","_complete","_vehicle","_rndnum","_crate_type","_crate","_mission","_vehname","_position","_vehclass"];

	// Get mission number, important we do this early
	_mission 	= count wai_mission_data -1;

	// Military Chopper level 2
	_vehclass 	= armed_chopper_2 call BIS_fnc_selectRandom;
	_vehname 	= getText ( configFile >> "CfgVehicles" >> _vehclass >> "displayName" );

	_position	= [50] call find_position;
	[ _mission , _position , "very hard" , format[ "Disabled %1" , _vehname ] , "MainHero" , false ] call mission_init;
	
	diag_log format["[WAI] [Mission:[Hero] Disabled Military Chopper 2]: Starting... %1",_position];

	// Setup the crate
	_crate_type 	= crates_medium call BIS_fnc_selectRandom;
	_crate 		= createVehicle [_crate_type,[(_position select 0),(_position select 1) + 5,0], [], 0, "CAN_COLLIDE"];
	
	// Troops
	_rndnum = ( 4 + round( random 2 ) );
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "very hard" , ["Random" , "AT"] , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "very hard" , "Random"          , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "very hard" , ["Random" , "AT"] , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[ [ _position select 0 , _position select 1 , 0 ] , _rndnum , "very hard" , "Random"          , 3 , "Random","Bandit","Random","Bandit",_mission] call spawn_group;

	// armor patrols
	_vehclasspatrol1 = armed_vehicle_3 call BIS_fnc_selectRandom;
	[ [(_position select 0) + 30 , (_position select 1) , 0] , [(_position select 0) + 30 , (_position select 1) , 0] , 50 , 2 , _vehclasspatrol1 , "very hard" , "Bandit" , "Bandit" , _mission ] call vehicle_patrol;

	// chopper paratrooper drops
	[[(_position select 0) + 120 ,(_position select 1) , 0],[  120 , 0 , 0 ],500,"UH1H_DZ",6,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	[[(_position select 0) + 120 ,(_position select 1) , 0],[ -120 , 0 , 0 ],500,"UH1H_DZ",6,"Random","Random",4,"Random","Bandit","Random","Bandit",false,_mission] spawn heli_para;
	
	// Static Guns
	_static_gun = ai_static_weapons call BIS_fnc_selectRandom;
	[[
		[ ( ( _position select 0 ) + 50 ) , ( _position select 1 )      , 0 ],
		[ ( ( _position select 0 ) - 50 ) , ( _position select 1 )      , 0 ],
		[ ( ( _position select 0 )      ) , ( _position select 1 ) + 50 , 0 ],
		[ ( ( _position select 0 )      ) , ( _position select 1 ) - 50 , 0 ]
	] , _static_gun , "very hard" , "Bandit" , "Bandit" , 0 , 2 , "Random" , "Random" , _mission ] call spawn_static;

	// Spawn vehicle
	_vehicle = [ _vehclass , _position , _mission ] call custom_publish;
	
	if ( debug_mode ) then {
		diag_log format[ "[WAI] [Hero] disabled_milchopper 2 spawned a %1" , _vehname];
	};
	
	// Condition
	_complete = [
		[_mission,_crate],	// mission number and crate
		["crate"], 		// ["crate"], or ["kill",wai_kill_percent], or ["assassinate", _unitGroup],
		[_vehicle], 		// cleanup objects
		"Bandits have taken a multimission chopper gunship! Very bad news. Get it back before they deploy!",	// mission announcement
		"Survivors have secured the heavy chopper gunship!",		// mission success
		"Survivors did not secure the heavy chopper gunship."		// mission fail
	] call mission_winorfail;

	if ( _complete ) then {
		[ _crate , 0 , 0 , [ 25 , crate_items_chainbullets ] , 2 ] call dynamic_crate;
	};
 
	diag_log format["[WAI] [Mission:[Hero] Disabled Military Chopper 2]: Ended at %1",_position];
	
	h_missionsrunning = h_missionsrunning - 1;
};