if ( isServer ) then {

	private [ "_complete" , "_crate" , "_mission" , "_static_gun" , "_crate_type" , "_rndnum" , "_playerPresent" , "_vehname" , "_vehicle" , "_position" , "_vehclass" ];

	// Get mission number, important we do this early
	_mission 		= count wai_mission_data -1;
	
	// Armed Land Vehicle -- level 0 -- get vehicle type and name
	_vehclass 		= armed_vehicle call BIS_fnc_selectRandom;
	_vehname 		= getText ( configFile >> "CfgVehicles" >> _vehclass >> "displayName" );

	// figure out where the patrol is STARTING
	_location 		= wai_patrol_locations call BIS_fnc_selectRandom;

	// get the NAME of where the patrol is starting...
	_position		= ( _location select 1 );

	// call mission init -- set marker to STARTING position, spawn mines
	//                        difficulty                                              mines   marker
	[ _mission , _position , "Easy" , format[ "Patrol %1" , _vehname ] , "MainHero" , false , true ] call mission_init;
	
	diag_log format[ "[WAI] [Mission:[Hero] Patrol]: Starting... %1" , _position ];

	// Spawn units                                              #   skill
	_units = [[ _position select 0 , _position select 1 , 0 ] , 4 , "Easy" , ["Random","AT"] , 3 , "Random" , "Bandit" , "Random" , "Bandit" , _mission ] call spawn_group;

	// Spawn vehicles
	_vehicle = [ _vehclass , _position , _mission ] call custom_publish;
	
	// load the guns -- does something useful only for _DZE variants, others are pre-loaded
	[ _vehicle , _vehclass ] spawn load_ammo;

	// set up waypoint count for this mission
	_nWayPoints = 2;

	// Setup patrol                   #wps
	[ _vehicle , _position , _units , _nWayPoints  ] call patrol;
	
	if ( debug_mode ) then {
		diag_log format["[WAI] [Hero] patrol spawned a %1",_vehname];
	};
	
	// Condition
	_complete = [
		[ _mission , _vehicle ] , // mission number and crate
		[ "patrol" ] , 		 													// ["crate"], or ["kill"], or ["assassinate", _unitGroup],
		[ _vehicle ] , 		 																		// cleanup objects
		format[ "Survivor intel reports a bandit %1 is heading out from %2" , _vehname , ( _location select 0 ) ] ,		// mission announcement
		"Heroes have taken the bandit patrol!",															// mission success
		"The bandit patrol reached its destination."														// mission fail
	] call mission_winorfail;

	if ( _complete ) then {
		[ _vehicle , 8 , 2 , 8 , 2 ] call dynamic_crate;
	};

	diag_log format[ "[WAI] [Mission:[Hero] Patrol]: Ended at %1" , _position ];
	
	h_missionsrunning = h_missionsrunning - 1;
};