if ( isServer ) then {

	private 	["_complete","_vehicle","_rndnum","_crate_type","_crate","_mission","_tanktraps","_mines","_playerPresent","_cleanmission","_currenttime","_starttime","_missiontimeout","_vehname","_veh","_position","_vehclass","_vehdir","_objPosition"];

	// Get mission number, important we do this early
	_mission 	= count wai_mission_data -1;

	// Military Chopper
	_vehclass 	= armed_chopper call BIS_fnc_selectRandom;
	_vehname 	= getText ( configFile >> "CfgVehicles" >> _vehclass >> "displayName" );

	_position	= [30] call find_position;
	[_mission,_position,"Hard",format["Contested Sniper Gear %1", _vehname],"MainHero",true] call mission_init;	
	
	diag_log 	format["[WAI] [Mission:[Hero] Contested Sniper Gear ]: Starting... %1",_position];

	// Setup the crate
	_crate_type 	= crates_medium call BIS_fnc_selectRandom;
	_crate 		= createVehicle [_crate_type,[(_position select 0),(_position select 1) + 5,0], [], 0, "CAN_COLLIDE"];
	
	// Troops
	_rndnum = 2 + round (random 4);
	[[_position select 0,_position select 1,0],_rndnum,"Hard",["Random","AT"],4,"Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[[_position select 0,_position select 1,0],_rndnum,"Hard","Random",4,"Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[[_position select 0,_position select 1,0],_rndnum,"Hard","Random",4,"Random","Bandit","Random","Bandit",_mission] call spawn_group;
	[[_position select 0,_position select 1,0],_rndnum,"Hard","Random",4,"Random","Bandit","Random","Bandit",_mission] call spawn_group;

	// Static Guns
	[[
		[(_position select 0) + 30, (_position select 1) - 30, 0],
		[(_position select 0) + 30, (_position select 1) + 30, 0],
		[(_position select 0) - 30, (_position select 1) - 30, 0],
		[(_position select 0) - 30, (_position select 1) + 30, 0]
	],"M2StaticMG","Hard","Bandit","Bandit",0,2,"Random","Random",_mission] call spawn_static;
	
	// Spawn vehicle
	_vehicle = [_vehclass,_position,_mission] call custom_publish;
	
	if ( debug_mode) then {
		diag_log format["[WAI] [Hero] sniper_extraction spawned a %1",_vehname];
	};
	
	//Condition
	_complete = [
		[_mission,_crate],	// mission number and crate
		["crate"], 		// ["crate"], or ["kill",wai_kill_percent], or ["assassinate", _unitGroup],
		[_vehicle], 		// cleanup objects
		"Bandits ambushed a rival bandit sniper team and their transport. Recover the gear and vic before the bad guys get away.",	// mission announcement
		"Survivors have secured the sniper gear and taken the chopper!",	// mission success
		"Survivors did not secure the sniper gear."					// mission fail
	] call mission_winorfail;

	if(_complete) then {
		[_crate,[10,ai_wep_sniper],[4,crate_tools_sniper],[4,crate_items_sniper],2] call dynamic_crate;
	};

	diag_log format["[WAI] [Mission:[Hero] Contested Sniper Gear ]: Ended at %1",_position];
	
	h_missionsrunning = h_missionsrunning - 1;
};