

// test for server status
if ( isDedicated ) then {

	// set up a public variable event handler for the server only to update a hangar door's data immediately to the data base/create a hangar door object ....
	"PVDZEP_CreateObjHangarDoorAndSaveToDB" addPublicVariableEventHandler {

		private [ "_arglist" , "_objTarget" , "_iValue" , "_objectID" , "_objectUID" , "_ix" , "_iy" , "_lstDummies" , "_lstVectorAndID" , "_fHeading" , "_keyval" , "_strKeyDesc" ];

		// get the argument list
		_arglist = _this select 1;

		// unpack the argument list
		_objTarget 	= _arglist select 0;
		_iValue 		= _arglist select 1;
		_fHeading 		= _arglist select 2;
		_keyval 		= _arglist select 3;
		_strKeyDesc 	= _arglist select 4;

		// get the db table values for the first two column values for the target object
		_objectID = _objTarget getVariable ["ObjectID","0"];
		_objectUID = _objTarget getVariable ["ObjectUID","0"];


		// calculation of the direction cos and sin in an x-y system based on CW heading angle from NORTH
		_ix = floor ( 1000 * ( sin _fHeading ) );
		_iy = floor ( 1000 * ( cos _fheading ) );

		// create the variables to be saved to object space
		_lstDummies = [ "cos_heading" , "sin_heading" , "keyval" , "doorid" , "keydesc" ];
		_lstVectorAndID = [ _ix , _iy , _keyval , _iValue , _strKeyDesc ];

		// save the data to the running game copy of the object -- these values are not persistent across restarts but ARE broadcast to all clients
		_objTarget setVariable [ "DummyNameList" , _lstDummies , true ];
		_objTarget setVariable [ "VectorAndID" , _lstVectorAndID , true ];
		_objTarget setVariable [ "OpenOrClosed" , "closed" , true ];

		// update the object to the data base
		[ _objTarget , "hangardoor" ] call server_updateObject;
	};

	// handler to clear a hangar door's data and revert it to a regular metal plate
	"PVDZEP_ClearObjHangarDoorVarsAndDB" addPublicVariableEventHandler {

		private [ "_arglist" , "_objTarget" , "_objectID" , "_objectUID" ];

		// get the argument list
		_arglist = _this select 1;

		// unpack the argument list
		_objTarget = _arglist select 0;

		// get the db table values for the first two column values for the target object
		_objectID = _objTarget getVariable [ "ObjectID" , "0" ];
		_objectUID = _objTarget getVariable [ "ObjectUID" , "0" ];

		// clear the object space variables
		_objTarget setVariable [ "DummyNameList" , nil , true ];
		_objTarget setVariable [ "VectorAndID"   , nil , true ];
		_objTarget setVariable [ "OpenOrClosed"  , "undefined" , true ];	// we should be able to set this to nil just as well, but explicit to undefined makes sure default failures create no error

		// update the object to the data base
		[ _objTarget , "hangardoorclear" ] call server_updateObject;

	};

	// handler to transfer ownership of a door group's objects to the client on which the player is setting them up
	"PVDZEP_MakeClientGroupOwner" addPublicVariableEventHandler {

		private [ "_arglist" , "_player" , "_lstObjects" , "_iClientID" , "_iTestID" ];

		// get the argument list
		_arglist = _this select 1;

		// get the player from the argument list
		_player = _arglist select 0;
		
		// get the list of object handles
		_lstObjects = _arglist select 1;

		// get the client ID on which the player resides
		_iClientID = owner _player;

		// iterate through the list
		{
			// get the client ID of object
			_iTestID = owner _x;

			// if the caller doesn't already own it, transfer ownership
			if ( _iTestID != _iClientID ) then {
				_x setOwner _iClientID;
			};

		} forEach _lstObjects;
		
		// done here -- nothing else to do
	};
	
};
